package ca.ualberta.proteus.biojava.test;

import junit.framework.TestCase;
import ca.ualberta.proteus.biojava.PDBFileParser;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.File;
import java.io.FilenameFilter;

import org.biojava.bio.structure.Structure;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Feb 5, 2008
 * Time: 11:53:23 PM
 * To change this template use File | Settings | File Templates.
 */
public class PDBFileParserTest extends TestCase
{
    public void test() throws IOException
    {
        String file = "test/molmol.pdb";
        PDBFileParser parser = new PDBFileParser();

        Structure structure = parser.parsePDBFile(new FileInputStream(file));

        System.out.print(structure.toPDB());
    }

    public void testAll() throws IOException
    {
        PDBFileParser parser = new PDBFileParser();

        File[] files = new File("pdb").listFiles(new FilenameFilter()
        {
            public boolean accept(File dir, String name)
            {
                return name.endsWith("pdb");
            }
        });

        for ( File f : files)
        {
            Structure structure = parser.parsePDBFile(new FileInputStream(f));
        }

        System.out.println("Parsed " + files.length + " files");
    }
}
