package ca.ualberta.proteus.db;

import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.program.ProteusSettings;
import ca.ualberta.proteus.util.Consts;
import com.db4o.Db4o;
import com.db4o.ObjectContainer;
import com.db4o.internal.Config4Impl;
import com.db4o.config.ObjectClass;
import com.db4o.config.Configuration;
import com.db4o.ext.DatabaseFileLockedException;
import com.db4o.ext.ExtObjectContainer;
import org.apache.log4j.Logger;

import java.text.SimpleDateFormat;
import java.io.IOException;
import java.util.Date;

/**
 * (C) Zigtag Inc. 2007
 * <p/>
 * User: scott
 * Date: May 21, 2007
 * Time: 12:29:52 PM
 */
public class DB4OPool
{
  //  private static ObjectContainer db;
    private static Logger logger = Logger.getLogger(DB4OPool.class);
    private static String DB_NAME;

    static
    {
        try
        {
            // Get the database from the config
            DB_NAME = Config.getConfig().getStringValue(Consts.DATABASE_FILE);

            try
            {
          //      db = Db4o.openFile(DB_NAME);
            }
            catch (DatabaseFileLockedException e)
            {
                e.printStackTrace();
            }

            Thread backupThread = new Thread()
            {
                public void run()
                {
                    while (true)
                    {
                        // long time = 1000 * 60 ;
                        long time = 1000 * 60 * 60 * 24 * 7; // 1 week
                        try
                        {
                            Thread.sleep(time);
                        }
                        catch (InterruptedException e)
                        {
                            e.printStackTrace();
                        }

                        SimpleDateFormat format = new SimpleDateFormat("DDMM");
                        String file = DB_NAME + format.format(new Date()) + ".backup";

                        logger.info("Backing up database to " + file);

                       /* try
                        {
                            ((ExtObjectContainer) db).backup(file);
                        }
                        catch (IOException e)
                        {
                            e.printStackTrace();
                        }*/
                    }
                }
            };
            backupThread.setPriority(Thread.MIN_PRIORITY);
            backupThread.setDaemon(true);
            backupThread.setName("DB4O backup thread");
            backupThread.start();
        }
        catch (IllegalArgumentException e)
        {
            logger.debug(e);
        }
    }

    public static ObjectContainer getDB() throws DatabaseFileLockedException
    {
        ObjectContainer db4o = null;
        db4o = Db4o.openFile(DB_NAME);

        // When we delete settings, cascade
        ObjectClass aClass = db4o.ext().configure().objectClass(ProteusSettings.class);
        aClass.cascadeOnDelete(true);

        return db4o;

    }

    /*public static ObjectContainer reopenDB()
    {
        if ( db != null )
        {
            if ( ! db.ext().isClosed())
            {
                db.close();
            }
        }

        try
        {
            db = Db4o.openFile(DB_NAME);
        }
        catch (DatabaseFileLockedException e)
        {
            e.printStackTrace();
        }

        // When we delete settings, cascade
        ObjectClass aClass = db.ext().configure().objectClass(ProteusSettings.class);
        aClass.cascadeOnDelete(true);

        return db;
    }*/
}
