package ca.ualberta.proteus.db;

import net.java.ao.DatabaseProvider;
import net.java.ao.RawEntity;
import org.apache.commons.beanutils.PropertyUtils;

import java.lang.reflect.InvocationTargetException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 20, 2009
 * Time: 1:11:36 AM
 * To change this template use File | Settings | File Templates.
 */
public class EntityManager extends net.java.ao.EntityManager
{
    public EntityManager(DatabaseProvider provider)
    {
        super(provider);
    }

    public EntityManager(DatabaseProvider provider, boolean weaklyCache)
    {
        super(provider, weaklyCache);
    }

    public EntityManager(String uri, String username, String password)
    {
        super(uri, username, password);
    }

    /**
     *
     * @param type  class to create
     * @param entity Bean with properties to create with . Must have the same properties as the class defined by Type.
     * <code>
     * <pre>
     * i.e. WebHitIntf<br/>
     *         - WebHitEntity extends RawEntity <br/>
     *         - WebHit <br/>
     *  You can pass in WebHitEntity as type, and an instance of WebHit as entity
     * </pre>
     * </code>
     */
    public <T extends RawEntity<K>, K> T create(Class<T> type, Object entity)
    {
        Map<String, Object> map;
        try
        {
            map = PropertyUtils.describe(entity);
            Map<String, Object> clone = new HashMap<String, Object>(map);
            for(String key: clone.keySet())
            {
                if ( map.get(key) == null)
                {
                    map.remove(key);
                }
            }
            map.remove("class");
            return super.create(type, map);
        }
        catch (IllegalAccessException e)
        {
            e.printStackTrace();
        }
        catch (InvocationTargetException e)
        {
            e.printStackTrace();
        }
        catch (NoSuchMethodException e)
        {
            e.printStackTrace();
        }
        catch (SQLException e)
        {
            e.printStackTrace();
        }
        return null;
    }

    public void deleteAll(Class<? extends RawEntity<?>> type) throws SQLException
    {
        try
        {
            Connection conn = getProvider().getConnection();
            try
            {

                StringBuilder sql = new StringBuilder("DELETE FROM ");

                // tableNameConverterLock.readLock().lock();
                try
                {
                    sql.append(getTableNameConverter().getName(type));
                }
                finally
                {
                    //tableNameConverterLock.readLock().unlock();
                }

                Logger.getLogger("net.java.ao").log(Level.INFO, sql.toString());
                PreparedStatement stmt = conn.prepareStatement(sql.toString());

                stmt.executeUpdate();
                stmt.close();
            }
            finally
            {
                conn.close();
            }

        }
        finally
        {
            //entityCacheLock.writeLock().unlock();
        }

    }
}
