package ca.ualberta.proteus.db;

import org.apache.naming.java.javaURLContextFactory;

import javax.naming.Context;
import javax.naming.NamingException;
import javax.sql.DataSource;
import java.util.Hashtable;

/**
 * (c) Zigtag, Inc. 2007
 * User: scott
 * Date: Jun 11, 2007
 * Time: 12:08:35 PM
 */
public class JNDIUtil
{
    public static void addJNDIDatasource(String jndiName, DataSource ds)
    {
        /* For JUnit tests, bind the JNDI datasource context manually */

        // Set the system properties to use tomcat's JNDI stuff
        System.setProperty(Context.INITIAL_CONTEXT_FACTORY,
                "org.apache.naming.java.javaURLContextFactory");
        System.setProperty(Context.URL_PKG_PREFIXES,
                "org.apache.naming");

        // Build all subcontexts.
        Hashtable contextEnv = new Hashtable();
        Context namingContext;
        try
        {
            //namingContext = new NamingContext(contextEnv, "/");
            namingContext = new javaURLContextFactory().getInitialContext(contextEnv);
            Context javaCtx;
            Context jdbcContext;

            try
            {
                javaCtx = (Context) namingContext.lookup("java:");
                Context compCtx = (Context) javaCtx.lookup("comp");
                Context envCtx = (Context) compCtx.lookup("env");
                jdbcContext = (Context) javaCtx.lookup("comp/env/jdbc");
            }
            catch (NamingException e)
            {
                javaCtx = namingContext.createSubcontext("java:");
                Context compCtx = javaCtx.createSubcontext("comp");
                Context envCtx = compCtx.createSubcontext("env");
                jdbcContext = envCtx.createSubcontext("jdbc");
            }

            // Bind the appropriate datasource
            jdbcContext.bind(jndiName, ds);
        }
        catch (NamingException e)
        {
            // Never happens
            e.printStackTrace();
        }
    }

    public static DataSource getJNDIDatasource(String jndiName)
    {
        System.setProperty(Context.INITIAL_CONTEXT_FACTORY,
                "org.apache.naming.java.javaURLContextFactory");
        System.setProperty(Context.URL_PKG_PREFIXES,
                "org.apache.naming");

        // Build all subcontexts.
        Hashtable contextEnv = new Hashtable();
        Context namingContext;
        try
        {
            //namingContext = new NamingContext(contextEnv, "/");
            namingContext = new javaURLContextFactory().getInitialContext(contextEnv);
            Context javaCtx = (Context) namingContext.lookup("java:");
            Context jdbcContext = (Context) javaCtx.lookup("comp/env/jdbc");

            return (DataSource) jdbcContext.lookup(jndiName);
        }
        catch (NamingException e)
        {
            e.printStackTrace();
        }
        return null;
    }
}
