package ca.ualberta.proteus.db;

import ca.ualberta.proteus.program.ProteusImpl;

import java.util.List;

/**
 * (C) Zigtag Inc. 2007
 * <p/>
 * User: scott
 * Date: May 10, 2007
 * Time: 9:04:24 PM
 *
 * An implementation-neutral persistence queue
 *
 * Persistent queuing using the DB4O database
 */
public class PersistenceQueue implements AbstractPersistenceQueue
{
    static Class<? extends AbstractPersistenceQueue> impl;  
    static AbstractPersistenceQueue persistenceQueue;

    static
    {
        impl = MySQLPersistenceQueue.class;

        try
        {
            persistenceQueue = impl.newInstance();
        }
        catch (InstantiationException e)
        {
            e.printStackTrace();
        }
        catch (IllegalAccessException e)
        {
            e.printStackTrace();
        }
    }
    /**
     * Recovers a list of proteus runs after a crash
     *
     * @return the queue
     */
    public List<ProteusImpl> recover()
    {
        return persistenceQueue.recover();
    }

    /**
     * Adds a proteus thread to the persistent queue
     *
     * @param proteus
     */
    public void addToQueue(ProteusImpl proteus)
    {
       persistenceQueue.addToQueue(proteus);
    }

    public void addToQueue(List<ProteusImpl> proteusList)
    {
        persistenceQueue.addToQueue(proteusList);
    }

    /**
     * Remove a proteus from the queue 
     *
     * @param proteus
     */
    public void remove(ProteusImpl proteus)
    {
       persistenceQueue.remove(proteus);
    }

    public void clear()
    {
        persistenceQueue.clear();
    }
}
