package ca.ualberta.proteus.db.model;

import ca.ualberta.proteus.program.MethodSettings;
import ca.ualberta.proteus.program.predictSPTM.Organism;
import net.java.ao.schema.PrimaryKey;
import net.java.ao.schema.SQLType;
import org.biojava.bio.seq.Sequence;

import java.io.File;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 14, 2009
 * Time: 1:49:13 AM
 * To change this template use File | Settings | File Templates.
 */
public interface PersistableProteusSettings
{
    @SQLType(precision = 30000)
    String getSequenceStr();

    void setSequenceStr(String sequenceStr);

    boolean isTesting();

    void setTesting(boolean testing);

    @PrimaryKey
    String getID();

    void setID(String ID);

    MethodSettings getMethod();

    void setMethod(MethodSettings method);

    boolean isRunEnergyMinimization();

    void setRunEnergyMinimization(boolean runEnergyMinimization);

    boolean isRunHomodeller();

    void setRunHomodeller(boolean runHomodeller);

    String getTemplateID();

    void setTemplateID(String templateID);

    boolean isEvaluating();

    void setEvaluating(boolean evaluating);

    Organism getOrganism();

    void setOrganism(Organism organism);

    boolean isRunSecondaryStructure();

    void setRunSecondaryStructure(boolean runSecondaryStructure);

    boolean isRunOnlyTM();

    void setRunOnlyTM(boolean runOnlyTM);

    public Double getIdentityThreshold();

    public void setIdentityThreshold(Double identityThreshold);
	
    public File getStructure();

    public void setStructure(File structure);

    public Sequence getSequence();

    public void setSequence(Sequence sequence);
}
