package ca.ualberta.proteus.db.test;

import ca.ualberta.proteus.db.MySQLPersistenceQueue;
import ca.ualberta.proteus.program.ProteusImpl;
import junit.framework.TestCase;
import org.biojava.bio.BioException;

import java.io.IOException;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 14, 2009
 * Time: 1:12:24 AM
 * To change this template use File | Settings | File Templates.
 */
public class SQLManagerTest extends TestCase
{
    public void test1() throws IOException, BioException, SQLException
    {

        MySQLPersistenceQueue queue = new MySQLPersistenceQueue();

        // Delete all existing entries
        queue.clear();

        ProteusImpl proteus = new ProteusImpl("test/fasta.txt");
        proteus.getSettings().setID(String.valueOf(Math.random()));
        queue.addToQueue(proteus);

        List<ProteusImpl> list = queue.recover();
        assertEquals(1, list.size());

        queue.remove(list.get(0));

        List<ProteusImpl> list2 = queue.recover();
        assertEquals(0, list2.size());

    }

    public void testRunAfterQueue() throws IOException, BioException
    {
        MySQLPersistenceQueue queue = new MySQLPersistenceQueue();

        // Delete all existing entries
        queue.clear();

        ProteusImpl proteus = new ProteusImpl("test/fasta.txt");
        proteus.getSettings().setID(String.valueOf(Math.random()));
        queue.addToQueue(proteus);

        proteus.run();
    }

    public void testSerialize() throws IOException, BioException
    {
        MySQLPersistenceQueue queue = new MySQLPersistenceQueue();

        // Delete all existing entries
        queue.clear();

        ProteusImpl proteus = new ProteusImpl("test/fasta.txt");
        proteus.getSettings().setID(String.valueOf(Math.random()));
        queue.addToQueue(proteus);

        List<ProteusImpl> list = queue.recover();
        assertEquals(1, list.size());

        // Get it deserialized.
        ProteusImpl proteus2 = list.get(0);
        assertEquals(proteus.getSettings().getSequence(), proteus2.getSettings().getSequence());

    }

}
