package ca.ualberta.proteus.logging;

import ca.ualberta.proteus.program.transsec.Config;

import java.io.Serializable;

/**
 * A Simple logger not unlike Log4J
 */
public class ProteusLogger implements Logger, Serializable
{
    //public static boolean logging = true;
    protected static LEVEL loggingLevel = LEVEL.ERROR;
    protected static ProteusLogger logger;

    static
    {
        //logging = Config.getConfig().getBooleanValue("server");
        try
        {
            LEVEL.valueOf(Config.getConfig().getStringValue("logging"));
        }
        catch(IllegalArgumentException e)
        {
            // nada
        }
    }

    public void log(String s) {
        if ( aboveLevel(LEVEL.LOG ) )
        {
            System.out.println(s);
        }
    }

    /**
     * @return true if if the set logging level is higher than the level parameter
     */
    protected boolean aboveLevel(LEVEL level)
    {
        return level.ordinal() >= loggingLevel.ordinal();
    }

    public void error(String s) {
        if ( aboveLevel(LEVEL.ERROR) )
        {
            System.out.println("ERROR: " + s);
        }
    }

    public void warn(String s) {
        if ( aboveLevel(LEVEL.WARN ))
        {
            System.out.println("WARNING: " + s);
        }
    }

    public void debug(String s) {
        if ( aboveLevel(LEVEL.DEBUG ) )
        {
            System.out.println("DEBUG: " + s);
        }
    }

    public static ProteusLogger getLogger()
    {
        if ( logger == null )
        {
            logger = new ProteusLogger();
        }

        return logger;
    }
}