package ca.ualberta.proteus.program.homodeller;

import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.util.Consts;

import java.util.*;
import java.io.File;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Aug 31, 2006
 * Time: 10:45:14 PM
 * To change this template use File | Settings | File Templates.
 */
public class LoopDB implements Iterable<Loop>
{
    private List<Loop> data = new ArrayList<Loop>();
    private static LoopDB db;

    public static LoopDB getInstance()
    {
        if ( db == null )
        {
            db = new LoopDB();
            String dbFile = getDBFile();

            LoopDBReader reader = new LoopDBReader(db);
            reader.parseDB(new File(dbFile));
        }

        return db;
    }

    private static String getDBFile()
    {
        Config config = Config.getConfig(Consts.HOMODELLER, "config/homodeller.xml");
        return config.getStringValue("loop.db");
    }

    public int size()
    {
        return data.size();
    }

    /*public boolean isEmpty()
    {
        return data.isEmpty();
    }

    public boolean contains(Object o)
    {
        return data.contains(o);
    }
*/
    public Iterator<Loop> iterator()
    {
        return data.iterator();
    }

  /*
  public Object[] toArray()
  {
      return data.toArray();
  }

  public <T>T[] toArray(T[] a)
  {
      return data.toArray(a);
  }

  public boolean add(Loop o)
  {
      return data.add(o);
  }

  public boolean remove(Object o)
  {
      return data.remove(o);
  }

  public boolean containsAll(Collection<?> c)
  {
      return data.containsAll(c);
  }

  public boolean addAll(Collection<? extends Loop> c)
  {
      return data.addAll(c);
  }

  public boolean addAll(int index, Collection<? extends Loop> c)
  {
      return data.addAll(index, c);
  }

  public boolean removeAll(Collection<?> c)
  {
      return data.removeAll(c);
  }

  public boolean retainAll(Collection<?> c)
  {
      return data.retainAll(c);
  }*/

    public void clear()
    {
        data.clear();
    }

    public Loop get(int index)
    {
        return data.get(index);
    }

    public void addLoop(Loop loop)
    {
        data.add(loop);
    }

    public List<Loop> getLoopsBySize(int size)
    {
        List<Loop> rv = new ArrayList<Loop>();
        for ( Loop loop : data)
        {
            if ( loop.getLoopLength() == size )
            {
                rv.add(loop);
            }
        }

        return rv;
    }

    public void fillInLoopInfo(Loop loop)
    {
        try
        {
            String dbFile = getDBFile();
            new LoopDBReader(this).fillInLoopInfo(new File(dbFile), loop);
        }
        catch (IOException e)
        {
            e.printStackTrace();  
        }
    }
}
