package ca.ualberta.proteus.program.homodeller;

import org.biojava.bio.structure.AminoAcidImpl;
import org.biojava.bio.structure.Atom;
import org.biojava.bio.structure.io.PDBParseException;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 3, 2006
 * Time: 12:17:29 PM
 * To change this template use File | Settings | File Templates.
 */
public class LoopResidueGroup extends AminoAcidImpl
{
    protected String residueType;

    public String getResidueType()
    {
        return residueType;
    }

    /**
     * The secondary structure designation of this residue from VADAR, i.e. CCB, BCB, CCC, etc.
     * @param residueType
     */
    public void setResidueType(String residueType)
    {
        this.residueType = residueType;
    }

    /** string representation. */
    public String toString()
    {
        return super.toString() + "sec str: " + residueType;
    }

    public Object clone()
    {
        LoopResidueGroup n = new LoopResidueGroup();

        n.setPDBFlag(has3D());
        n.setPDBCode(getPDBCode());
        n.setResidueType(getResidueType());

        try
        {
            n.setPDBName(getPDBName());
        }
        catch (PDBParseException e)
        {
            e.printStackTrace();
        }

        n.setAminoType(getAminoType());

        // copy the atoms
        for (int i = 0; i < getAtoms().size(); i++)
        {
            Atom atom = (Atom) getAtoms().get(i);
            n.addAtom((Atom) atom.clone());
        }
        return n;
    }
}
