package ca.ualberta.proteus.program.homodeller;

import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.util.Consts;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 3, 2006
 * Time: 9:51:46 PM
 * To change this template use File | Settings | File Templates.
 */
public class SideDB implements Iterable<SideChain>
{
    private List<SideChain> data = new ArrayList<SideChain>();
    private static SideDB db;


    public static SideDB getInstance()
    {
        if ( db == null )
        {
            db = new SideDB();
            Config config = Config.getConfig(Consts.HOMODELLER, "config/homodeller.xml");
            String dbFile = config.getStringValue("side.db");

            SideDBReader reader = new SideDBReader(db);
            reader.parseDB(new File(dbFile));
        }

        return db;
    }

    public int size()
    {
        return data.size();
    }

    public boolean isEmpty()
    {
        return data.isEmpty();
    }

    /*public boolean contains(Object o)
    {
        return data.contains(o);
    }
*/
    public Iterator<SideChain> iterator()
    {
        return data.iterator();
    }
/*

    public Object[] toArray()
    {
        return data.toArray();
    }

    public <T>T[] toArray(T[] a)
    {
        return data.toArray(a);
    }

    public boolean add(SideChain o)
    {
        return data.add(o);
    }

    public boolean remove(Object o)
    {
        return data.remove(o);
    }

    public boolean containsAll(Collection<?> c)
    {
        return data.containsAll(c);
    }

    public boolean addAll(Collection<? extends SideChain> c)
    {
        return data.addAll(c);
    }

    public boolean addAll(int index, Collection<? extends SideChain> c)
    {
        return data.addAll(index, c);
    }

    public boolean removeAll(Collection<?> c)
    {
        return data.removeAll(c);
    }

    public boolean retainAll(Collection<?> c)
    {
        return data.retainAll(c);
    }
*/

    public void clear()
    {
        data.clear();
    }

    public SideChain get(int index)
    {
        return data.get(index);
    }

    public void addLoop(SideChain loop)
    {
        data.add(loop);
    }

    public List<SideChain> getSideChains(char aminoCode)
    {
        List<SideChain> rv = new ArrayList<SideChain>();
        for ( SideChain c: this )
        {
            if ( c.getAminoType().equals(aminoCode) )
            {
                rv.add(c);
            }
        }

        return rv;
    }
}
