/*
 * Created on May 9, 2008
 */
package ca.ualberta.proteus.program.homodeller.loop;

/**
 *
 *
 * @author Joseph Cruz
 */
public class CCDLoopScore {

	double pre_phi_delta;
    double pre_psi_delta;
    double post_phi_delta;
    double post_psi_delta;
    //   double NC_dist_delta;
    double similarityScore; // proportion in the range [0.0, 1.0]
    public double CA_CA_dist_delta;
    
    double post_PostDist = -1.0; // Distance between Post residue of structure and Post residue of a coil loop.
    //double post_PostAngle = -1.0; // Not yet implemented.
    	// Magnitude of the angle between N-C vector for Post residue of structure and N-C vector of Post
    	// residue of a coil loop. The smaller the value, the more the closely the coil loop Post residue is
    	// parallel to ("points at") the structure Post residue. (I'm not sure what the best measure for this
    	// is, though. -- David Arndt).
    
    /*
     * Get the score for a particular loop
     * This scoring method is based on 4 measures:
     * - Psi/psi angle similarity
     * - phi/phi angle similarity
     * - ca-ca distance
     * - sequence similarity between the loop and the query region we are replacing
     */
    double getScore()
    {
/*
        double denominator = ( pre_phi_delta / 360 + pre_psi_delta / 360
                        +   post_phi_delta / 360 + post_psi_delta / 360  + NC_dist_delta );
*/
        // TODO add back in post delta's
        double denominator = (pre_phi_delta / 360 + pre_psi_delta / 360 + CA_CA_dist_delta);
        double score;
        if (denominator == 0)
        {
            // perfect match!
            score = Double.MAX_VALUE;
        }
        else
        {
            // TODO this is an arbitrary measure formula
        	
            score = similarityScore + (1.0 / denominator);
            
            if (post_PostDist != -1.0) {
            	if (post_PostDist == 0.0) {
            		// Perfect match.
            		score += Double.MAX_VALUE;
            	}
            	else {
            		score += 5.0*(1.0 / post_PostDist);
            	}
            }
        }

        return score;
    }
}
