/*
 * Created on May 8, 2008
 */
package ca.ualberta.proteus.program.homodeller.loop;

import org.biojava.bio.seq.GappedSequence;
import org.biojava.bio.structure.Group;
import org.biojava.bio.structure.Structure;

/**
 *
 *
 * @author Joseph Cruz
 */
public interface Gap extends Comparable<Gap> {

	public static enum Type { Insertion, Deletion }
	
	public Type getType();
	
	public int getStart();
	
	public int getLength();
	
	public int getEnd();
	
	public int getFixedNTerminalPosition();
	
	public Group getFixedNTerminalGroup(GappedSequence querySequence, GappedSequence templateSequence, Structure newStructure);
	
	public int getFixedCTerminalPosition();
	
	public Group getFixedCTerminalGroup(GappedSequence querySequence, GappedSequence templateSequence, Structure newStructure);
	
	public int getLoopCoilLength(GappedSequence sequence);
}
