/*
 * Created on May 8, 2008
 */
package ca.ualberta.proteus.program.homodeller.loop;

/**
 *
 *
 * @author Joseph Cruz
 */
public class MergedGap extends AbstractGap {

	private Gap first;
	private Gap second;
	
	public MergedGap(Gap first, Gap second) {
		this.first = first;
		this.second = second;
	}
	
	public int getStart() {
		return this.getFirst().getStart();
	}
	
	public void setStart(int start) {
		Gap g = this.getFirst();
		while( g instanceof MergedGap )
			g = ((MergedGap)g).getFirst();
		((SimpleGap)g).setStart(start);
	}
	
	public int getEnd() {
		return this.getSecond().getEnd();
	}
	
	public void setEnd(int end) {
		Gap g = this.getSecond();
		while( g instanceof MergedGap )
			g = ((MergedGap)g).getSecond();
		((SimpleGap)g).setEnd(end);
	}
	
	public int getFixedNTerminalPosition() {
		return this.getFirst().getFixedNTerminalPosition();
	}
	
	public int getFixedCTerminalPosition() {
		return this.getSecond().getFixedCTerminalPosition();
	}
	
	public Gap getFirst() {
		return first;
	}

	public void setFirst(Gap first) {
		this.first = first;
	}

	public Gap getSecond() {
		return second;
	}

	public void setSecond(Gap second) {
		this.second = second;
	}
	
	public int getNTerminalSubgapLength() {
		if( first.getStart() < second.getStart() )
			return first.getLength();
		else if( first.getStart() > second.getStart() )
			return second.getLength();
		
		throw new IllegalStateException("The two gaps cannot have the same start site.");
	}
	
	public int getCTerminalSubgapLength() {
		if( first.getEnd() > second.getEnd() )
			return first.getLength();
		else if( first.getEnd() < second.getEnd() )
			return second.getLength();
		
		throw new IllegalStateException("The two gaps cannot have the same end site.");
	}
}
