/*
 * Created on May 9, 2008
 */
package ca.ualberta.proteus.program.homodeller.loop;

/**
 *
 *
 * @author Joseph Cruz
 */
public class SimplexLoopScore {

	double pre_phi_delta;
    double pre_psi_delta;
    double post_phi_delta;
    double post_psi_delta;
    //   double NC_dist_delta;
    double similarityScore; // proportion in the range [0.0, 1.0]
    public double CA_CA_dist_delta;

    /*
     * Get the score for a particular loop
     * This scoring method is based on 4 measures:
     * - Psi/psi angle similarity
     * - phi/phi angle similarity
     * - ca-ca distance
     * - sequence similarity between the loop and the query region we are replacing
     */
    double getScore()
    {
/*
        double denominator = ( pre_phi_delta / 360 + pre_psi_delta / 360
                        +   post_phi_delta / 360 + post_psi_delta / 360  + NC_dist_delta );
*/
        // TODO add back in post delta's
        double denominator = (pre_phi_delta / 360 + pre_psi_delta / 360 + CA_CA_dist_delta);
        double score;
        if (denominator == 0)
        {
            // perfect match!
            score = Double.MAX_VALUE;
        }
        else
        {
            // TODO this is an arbitrary measure formula
            score = similarityScore + 1 / denominator;
        }

        return score;
    }
}
