package ca.ualberta.proteus.program.homodeller.test;

import junit.framework.TestCase;
import org.biojava.bio.symbol.IllegalSymbolException;
import org.biojava.bio.structure.Structure;
import org.biojava.bio.structure.StructureException;
import ca.ualberta.proteus.biojava.PDBFileParser;
import ca.ualberta.proteus.program.homodeller.CCD;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

/**
 * (C) Zigtag Inc. 2007
 * <p/>
 * User: scott
 * Date: Apr 22, 2007
 * Time: 3:58:34 PM
 */
public class TestCCD extends TestCase
{
    /**
     * TODO
     *
     * @throws IllegalSymbolException
     */
    public void test1() throws IllegalSymbolException, IOException, StructureException
    {
        /**
         * QUERY: MTTAEKTLPRLKQRYREEIRESLQQQFGYANVMQIPGVVKVVVNMGVGDAARDAKLINGAVNDLALITGQKPEIRRARKSIAQFKLREGMPIGARVTLRGDRMWEFLDRLVAIALPRIRDFRGLNPKQFDGTGNYTFGLTEQSMFHEIDVDSIDRPRGMDITVVTSATTDDEGRALLRALGFPFKEN
           DATAB: LDVA------LKRKYYEEVRPELIRRFGYQNVWEVPRLEKVVINQGLGEAKEDARILEKAAQELALITGQKPAVTRAKKSISNFKLRKGMPIGLRVTLRRDR-WIFLEKLLNVALPRIRDFRGLNPNSFDGRGNYNLGLREQLIFPEITYDMVDALRG-DIAVVTTAETDEEARALLELLGFPFRK~         
         */
        File in = new File("test/homodeller/testCCD.pdb");

        PDBFileParser pdbReader = new PDBFileParser();
        Structure realFile = pdbReader.parsePDBFile(new FileInputStream(in) );

        int RAMA_THRESHOLD = 3;
        int num_res = 0;
        int N_anchor = 5;
        int C_anchor = 10;

        CCD.adjustSegmentCCD(realFile.getChain(0), num_res, N_anchor, C_anchor, RAMA_THRESHOLD);
    }
}
