package ca.ualberta.proteus.program.homodeller.test;

import ca.ualberta.proteus.program.homodeller.Angle;
import ca.ualberta.proteus.program.homodeller.PhipsiRunner;
import ca.ualberta.proteus.program.homodeller.HomodellerUtils;
import ca.ualberta.proteus.program.homodeller.TorsionUtils;
import junit.framework.TestCase;
import junit.framework.AssertionFailedError;
import org.biojava.bio.structure.io.PDBFileParser;
import org.biojava.bio.structure.*;

import java.util.TreeMap;
import java.io.BufferedReader;
import java.io.StringReader;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 13, 2006
 * Time: 9:43:34 PM
 * To change this template use File | Settings | File Templates.
 */
public class TestPhiPsi extends TestCase
{
    public void test1() throws IOException
    {
        String file = "ATOM      1  N   MET     1     -17.775  41.398  46.220  1.00  1.00    \n" +
                "ATOM      2  CA  MET     1     -16.791  40.917  45.201  1.00  1.00    \n" +
                "ATOM      3  C   MET     1     -16.728  39.422  45.076  1.00  1.00    \n" +
                "ATOM      4  O   MET     1     -17.049  38.703  45.989  1.00  1.00    \n" +
                "ATOM      5  CB  MET     1     -15.361  41.348  45.496  1.00  1.00    \n" +
                "ATOM      6  CG  MET     1     -14.798  41.991  44.270  1.00  1.00    \n" +
                "ATOM      7  SD  MET     1     -15.511  43.625  44.098  1.00  1.00    \n" +
                "ATOM      8  CE  MET     1     -14.955  44.413  45.619  1.00  1.00    \n" +
                "ATOM      9  N   ASN     2     -16.264  38.989  43.924  1.00  1.00    \n" +
                "ATOM     10  CA  ASN     2     -16.102  37.600  43.507  1.00  1.00    \n" +
                "ATOM     11  C   ASN     2     -15.736  37.742  42.066  1.00  1.00    \n" +
                "ATOM     12  O   ASN     2     -15.881  38.814  41.468  1.00  1.00    \n" +
                "ATOM     13  CB  ASN     2     -17.406  36.802  43.480  1.00  1.00    \n" +
                "ATOM     14  CG  ASN     2     -18.552  37.467  42.656  1.00  1.00    \n" +
                "ATOM     15  OD1 ASN     2     -18.490  37.650  41.424  1.00  1.00    \n" +
                "ATOM     16  ND2 ASN     2     -19.682  37.722  43.304  1.00  1.00    \n" +
                "ATOM     17  N   ILE     3     -15.321  36.644  41.516  1.00  1.00    \n" +
                "ATOM     18  CA  ILE     3     -14.816  36.592  40.185  1.00  1.00    \n" +
                "ATOM     19  C   ILE     3     -15.471  37.455  39.118  1.00  1.00    \n" +
                "ATOM     20  O   ILE     3     -14.839  38.352  38.547  1.00  1.00    \n" +
                "ATOM     21  CB  ILE     3     -14.385  35.219  39.794  1.00  1.00    \n" +
                "ATOM     22  CG1 ILE     3     -13.456  35.383  38.605  1.00  1.00    \n" +
                "ATOM     23  CG2 ILE     3     -15.608  34.396  39.475  1.00  1.00    \n" +
                "ATOM     24  CD1 ILE     3     -12.597  36.606  38.871  1.00  1.00    \n" +
                "ATOM     25  N   PHE     4     -16.749  37.239  38.926  1.00  1.00    \n" +
                "ATOM     26  CA  PHE     4     -17.479  38.021  37.969  1.00  1.00    \n" +
                "ATOM     27  C   PHE     4     -17.371  39.469  38.268  1.00  1.00    \n" +
                "ATOM     28  O   PHE     4     -17.375  40.303  37.419  1.00  1.00    \n" +
                "ATOM     29  CB  PHE     4     -18.928  37.583  38.043  1.00  1.00    \n" +
                "ATOM     30  CG  PHE     4     -19.007  36.150  37.657  1.00  1.00    \n" +
                "ATOM     31  CD1 PHE     4     -18.681  35.190  38.607  1.00  1.00    \n" +
                "ATOM     32  CD2 PHE     4     -19.282  35.741  36.355  1.00  1.00    \n" +
                "ATOM     33  CE1 PHE     4     -18.681  33.831  38.306  1.00  1.00    \n" +
                "ATOM     34  CE2 PHE     4     -19.250  34.387  36.033  1.00  1.00    \n" +
                "ATOM     35  CZ  PHE     4     -18.967  33.432  37.005  1.00  1.00    \n" +
                "ATOM     36  N   GLU     5     -17.269  39.782  39.479  1.00  1.00    \n" +
                "ATOM     37  CA  GLU     5     -17.154  41.144  39.768  1.00  1.00    \n" +
                "ATOM     38  C   GLU     5     -15.811  41.672  39.431  1.00  1.00    \n" +
                "ATOM     39  O   GLU     5     -15.698  42.756  38.902  1.00  1.00    \n" +
                "ATOM     40  CB  GLU     5     -17.548  41.361  41.201  1.00  1.00    \n" +
                "ATOM     41  CG  GLU     5     -18.608  42.421  41.255  1.00  1.00    \n" +
                "ATOM     42  CD  GLU     5     -19.910  41.884  40.815  1.00  1.00    \n" +
                "ATOM     43  OE1 GLU     5     -19.893  41.189  39.696  1.00  1.00    \n" +
                "ATOM     44  OE2 GLU     5     -20.917  42.137  41.432  1.00  1.00    \n" +
                "ATOM     45  N   MET     6     -14.813  40.891  39.715  1.00  1.00    \n" +
                "ATOM     46  CA  MET     6     -13.451  41.229  39.432  1.00  1.00    \n" +
                "ATOM     47  C   MET     6     -13.222  41.430  37.901  1.00  1.00    \n" +
                "ATOM     48  O   MET     6     -12.758  42.456  37.387  1.00  1.00    \n" +
                "ATOM     49  CB  MET     6     -12.670  40.052  40.039  1.00  1.00    \n" +
                "ATOM     50  CG  MET     6     -11.219  40.371  40.263  1.00  1.00    \n" +
                "ATOM     51  SD  MET     6     -10.383  38.900  40.860  1.00  1.00    \n" +
                "ATOM     52  CE  MET     6      -8.864  39.667  41.513  1.00  1.00    \n" +
                "ATOM     53  N   LEU     7     -13.542  40.407  37.139  1.00  1.00    \n" +
                "ATOM     54  CA  LEU     7     -13.431  40.440  35.695  1.00  1.00    \n" +
                "ATOM     55  C   LEU     7     -14.208  41.654  35.132  1.00  1.00    \n" +
                "ATOM     56  O   LEU     7     -13.687  42.439  34.352  1.00  1.00    \n" +
                "ATOM     57  CB  LEU     7     -14.042  39.143  35.113  1.00  1.00    \n" +
                "ATOM     58  CG  LEU     7     -13.068  37.994  34.947  1.00  1.00    \n" +
                "ATOM     59  CD1 LEU     7     -11.668  38.575  35.047  1.00  1.00    \n" +
                "ATOM     60  CD2 LEU     7     -13.351  36.877  35.993  1.00  1.00    \n" +
                "ATOM     61  N   ARG     8     -15.478  41.808  35.553  1.00  1.00    \n" +
                "ATOM     62  CA  ARG     8     -16.374  42.838  35.082  1.00  1.00    \n" +
                "ATOM     63  C   ARG     8     -15.726  44.160  35.308  1.00  1.00    \n" +
                "ATOM     64  O   ARG     8     -16.014  45.140  34.644  1.00  1.00    \n" +
                "ATOM     65  CB  ARG     8     -17.791  42.708  35.660  1.00  1.00    \n" +
                "ATOM     66  CG  ARG     8     -18.953  43.557  35.050  1.00  1.00    \n" +
                "ATOM     67  CD  ARG     8     -18.686  44.462  33.821  1.00  1.00    \n" +
                "ATOM     68  NE  ARG     8     -19.810  45.391  33.526  1.00  1.00    \n" +
                "ATOM     69  CZ  ARG     8     -19.714  46.653  33.055  1.00  1.00    \n" +
                "ATOM     70  NH1 ARG     8     -18.543  47.227  32.737  1.00  1.00    \n" +
                "ATOM     71  NH2 ARG     8     -20.837  47.355  32.875  1.00  1.00    \n" +
                "ATOM     72  N   ILE     9     -14.801  44.149  36.250  1.00  1.00    \n" +
                "ATOM     73  CA  ILE     9     -14.023  45.329  36.572  1.00  1.00    \n" +
                "ATOM     74  C   ILE     9     -12.842  45.436  35.661  1.00  1.00    \n" +
                "ATOM     75  O   ILE     9     -12.809  46.420  34.915  1.00  1.00    \n" +
                "ATOM     76  CB  ILE     9     -13.546  45.416  38.014  1.00  1.00    \n" +
                "ATOM     77  CG1 ILE     9     -14.616  46.010  38.923  1.00  1.00    \n" +
                "ATOM     78  CG2 ILE     9     -12.364  46.365  38.051  1.00  1.00    \n" +
                "ATOM     79  CD1 ILE     9     -14.013  46.800  40.064  1.00  1.00    \n" +
                "ATOM     80  N   ASP    10     -11.907  44.417  35.750  1.00  1.00    \n" +
                "ATOM     81  CA  ASP    10     -10.741  44.359  34.895  1.00  1.00    \n" +
                "ATOM     82  C   ASP    10     -11.028  44.498  33.374  1.00  1.00    \n" +
                "ATOM     83  O   ASP    10     -10.602  45.463  32.772  1.00  1.00    \n" +
                "ATOM     84  CB  ASP    10     -10.093  43.079  35.168  1.00  1.00    \n" +
                "ATOM     85  CG  ASP    10      -9.334  43.175  36.409  1.00  1.00    \n" +
                "ATOM     86  OD1 ASP    10      -8.775  44.161  36.719  1.00  1.00    \n" +
                "ATOM     87  OD2 ASP    10      -9.227  42.036  37.021  1.00  1.00    \n" +
                "ATOM     88  N   GLU    11     -11.834  43.588  32.786  1.00  1.00    \n" +
                "ATOM     89  CA  GLU    11     -12.286  43.519  31.361  1.00  1.00    \n" +
                "ATOM     90  C   GLU    11     -13.280  44.618  30.854  1.00  1.00    \n" +
                "ATOM     91  O   GLU    11     -13.411  44.930  29.649  1.00  1.00    \n" +
                "ATOM     92  CB  GLU    11     -12.952  42.157  31.066  1.00  1.00    \n" +
                "ATOM     93  CG  GLU    11     -11.950  41.000  31.189  1.00  1.00    \n" +
                "ATOM     94  CD  GLU    11     -10.678  41.223  30.436  1.00  1.00    \n" +
                "ATOM     95  OE1 GLU    11     -10.897  41.979  29.374  1.00  1.00    \n" +
                "ATOM     96  OE2 GLU    11      -9.617  40.674  30.714  1.00  1.00    \n" +
                "ATOM     97  N   GLY    12     -14.088  45.173  31.736  1.00  1.00    \n" +
                "ATOM     98  CA  GLY    12     -15.069  46.158  31.276  1.00  1.00    \n" +
                "ATOM     99  C   GLY    12     -16.057  45.520  30.339  1.00  1.00    \n" +
                "ATOM    100  O   GLY    12     -15.902  44.348  29.941  1.00  1.00    \n" +
                "ATOM    101  N   LEU    13     -17.069  46.292  29.978  1.00  1.00    \n" +
                "ATOM    102  CA  LEU    13     -18.053  45.815  29.020  1.00  1.00    \n" +
                "ATOM    103  C   LEU    13     -18.105  46.666  27.738  1.00  1.00    \n" +
                "ATOM    104  O   LEU    13     -17.986  47.903  27.756  1.00  1.00    \n" +
                "ATOM    105  CB  LEU    13     -19.414  45.591  29.658  1.00  1.00    \n" +
                "ATOM    106  CG  LEU    13     -20.513  45.348  28.647  1.00  1.00    \n" +
                "ATOM    107  CD1 LEU    13     -20.695  43.843  28.495  1.00  1.00    \n" +
                "ATOM    108  CD2 LEU    13     -21.818  45.978  29.116  1.00  1.00    \n" +
                "ATOM    109  N   ARG    14     -18.254  46.001  26.585  1.00  1.00    \n" +
                "ATOM    110  CA  ARG    14     -18.320  46.690  25.291  1.00  1.00    \n" +
                "ATOM    111  C   ARG    14     -19.041  45.825  24.295  1.00  1.00    \n" +
                "ATOM    112  O   ARG    14     -18.657  44.722  24.043  1.00  1.00    \n" +
                "ATOM    113  CB  ARG    14     -16.957  47.056  24.760  1.00  1.00    \n" +
                "ATOM    114  CG  ARG    14     -16.224  48.103  25.576  1.00  1.00    \n" +
                "ATOM    115  CD  ARG    14     -15.302  48.939  24.698  1.00  1.00    \n" +
                "ATOM    116  NE  ARG    14     -13.932  48.797  25.149  1.00  1.00    \n" +
                "ATOM    117  CZ  ARG    14     -12.844  49.266  24.551  1.00  1.00    \n" +
                "ATOM    118  NH1 ARG    14     -12.895  49.962  23.402  1.00  1.00    \n" +
                "ATOM    119  NH2 ARG    14     -11.666  49.021  25.163  1.00  1.00    \n" +
                "ATOM    120  N   LEU    15     -20.111  46.322  23.774  1.00  1.00    \n" +
                "ATOM    121  CA  LEU    15     -20.967  45.566  22.887  1.00  1.00    \n" +
                "ATOM    122  C   LEU    15     -20.496  45.407  21.444  1.00  1.00    \n" +
                "ATOM    123  O   LEU    15     -21.046  44.626  20.669  1.00  1.00    \n" +
                "ATOM    124  CB  LEU    15     -22.435  46.112  22.977  1.00  1.00    \n" +
                "ATOM    125  CG  LEU    15     -23.035  46.180  24.405  1.00  1.00    \n" +
                "ATOM    126  CD1 LEU    15     -23.417  47.624  24.792  1.00  1.00    \n" +
                "ATOM    127  CD2 LEU    15     -24.265  45.258  24.509  1.00  1.00    \n" +
                "ATOM    128  N   LYS    16     -19.518  46.188  21.051  1.00  1.00    \n" +
                "ATOM    129  CA  LYS    16     -19.056  46.160  19.665  1.00  1.00    \n" +
                "ATOM    130  C   LYS    16     -17.644  45.759  19.628  1.00  1.00    \n" +
                "ATOM    131  O   LYS    16     -16.857  46.447  20.283  1.00  1.00    \n" +
                "ATOM    132  CB  LYS    16     -19.050  47.555  18.996  1.00  1.00    \n" +
                "ATOM    133  CG  LYS    16     -20.238  47.869  18.087  1.00  1.00    \n" +
                "ATOM    134  CD  LYS    16     -20.938  49.182  18.436  1.00  1.00    \n" +
                "ATOM    135  CE  LYS    16     -21.526  49.940  17.245  1.00  1.00    \n" +
                "ATOM    136  NZ  LYS    16     -22.053  51.277  17.577  1.00  1.00    \n" +
                "ATOM    137  N   ILE    17     -17.371  44.738  18.799  1.00  1.00    \n" +
                "ATOM    138  CA  ILE    17     -16.026  44.219  18.528  1.00  1.00    \n" +
                "ATOM    139  C   ILE    17     -14.979  45.319  18.634  1.00  1.00    \n" +
                "ATOM    140  O   ILE    17     -15.251  46.434  18.220  1.00  1.00    \n" +
                "ATOM    141  CB  ILE    17     -15.966  43.671  17.116  1.00  1.00    \n" +
                "ATOM    142  CG1 ILE    17     -16.948  42.566  16.916  1.00  1.00    \n" +
                "ATOM    143  CG2 ILE    17     -14.641  43.015  16.802  1.00  1.00    \n" +
                "ATOM    144  CD1 ILE    17     -16.169  41.616  16.037  1.00  1.00    \n" +
                "ATOM    145  N   TYR    18     -13.874  45.049  19.299  1.00  1.00    \n" +
                "ATOM    146  CA  TYR    18     -12.824  46.014  19.476  1.00  1.00    \n" +
                "ATOM    147  C   TYR    18     -11.582  45.192  19.484  1.00  1.00    \n" +
                "ATOM    148  O   TYR    18     -11.702  43.970  19.300  1.00  1.00    \n" +
                "ATOM    149  CB  TYR    18     -13.044  46.762  20.806  1.00  1.00    \n" +
                "ATOM    150  CG  TYR    18     -12.880  45.923  22.108  1.00  1.00    \n" +
                "ATOM    151  CD1 TYR    18     -13.878  45.035  22.517  1.00  1.00    \n" +
                "ATOM    152  CD2 TYR    18     -11.765  46.056  22.946  1.00  1.00    \n" +
                "ATOM    153  CE1 TYR    18     -13.769  44.281  23.686  1.00  1.00    \n" +
                "ATOM    154  CE2 TYR    18     -11.613  45.286  24.102  1.00  1.00    \n" +
                "ATOM    155  CZ  TYR    18     -12.626  44.397  24.481  1.00  1.00    \n" +
                "ATOM    156  OH  TYR    18     -12.503  43.608  25.624  1.00  1.00    \n" +
                "ATOM    157  N   LYS    19     -10.417  45.789  19.777  1.00  1.00    \n" +
                "ATOM    158  CA  LYS    19      -9.162  45.021  19.819  1.00  1.00    \n" +
                "ATOM    159  C   LYS    19      -8.544  44.952  21.202  1.00  1.00    \n" +
                "ATOM    160  O   LYS    19      -8.412  45.967  21.818  1.00  1.00    \n" +
                "ATOM    161  CB  LYS    19      -8.179  45.599  18.822  1.00  1.00    \n" +
                "ATOM    162  CG  LYS    19      -8.556  45.363  17.362  1.00  1.00    \n" +
                "ATOM    163  CD  LYS    19      -7.349  45.142  16.469  1.00  1.00    \n" +
                "ATOM    164  CE  LYS    19      -7.135  46.302  15.503  1.00  1.00    \n" +
                "ATOM    165  NZ  LYS    19      -5.858  46.200  14.765  1.00  1.00    \n" +
                "ATOM    166  N   ASP    20      -8.182  43.789  21.719  1.00  1.00    \n" +
                "ATOM    167  CA  ASP    20      -7.612  43.744  23.062  1.00  1.00    \n" +
                "ATOM    168  C   ASP    20      -6.272  44.448  23.086  1.00  1.00    \n" +
                "ATOM    169  O   ASP    20      -5.835  45.075  22.101  1.00  1.00    \n" +
                "ATOM    170  CB  ASP    20      -7.572  42.301  23.653  1.00  1.00    \n" +
                "ATOM    171  CG  ASP    20      -6.373  41.458  23.299  1.00  1.00    \n" +
                "ATOM    172  OD1 ASP    20      -5.763  41.852  22.200  1.00  1.00    \n" +
                "ATOM    173  OD2 ASP    20      -6.023  40.494  23.967  1.00  1.00    \n" +
                "ATOM    174  N   THR    21      -5.604  44.367  24.215  1.00  1.00    \n" +
                "ATOM    175  CA  THR    21      -4.270  45.016  24.342  1.00  1.00    \n" +
                "ATOM    176  C   THR    21      -3.295  44.502  23.282  1.00  1.00    \n" +
                "ATOM    177  O   THR    21      -2.406  45.240  22.848  1.00  1.00    \n" +
                "ATOM    178  CB  THR    21      -3.580  44.974  25.758  1.00  1.00    \n" +
                "ATOM    179  OG1 THR    21      -3.582  43.665  26.322  1.00  1.00    \n" +
                "ATOM    180  CG2 THR    21      -4.195  45.991  26.714  1.00  1.00    \n" +
                "ATOM    181  N   GLU    22      -3.483  43.226  22.915  1.00  1.00    \n" +
                "ATOM    182  CA  GLU    22      -2.685  42.544  21.927  1.00  1.00    \n" +
                "ATOM    183  C   GLU    22      -3.045  42.987  20.523  1.00  1.00    \n" +
                "ATOM    184  O   GLU    22      -2.298  42.810  19.575  1.00  1.00    \n" +
                "ATOM    185  CB  GLU    22      -2.936  41.014  21.983  1.00  1.00    \n" +
                "ATOM    186  CG  GLU    22      -2.970  40.367  23.382  1.00  1.00    \n" +
                "ATOM    187  CD  GLU    22      -1.595  40.261  23.955  1.00  1.00    \n" +
                "ATOM    188  OE1 GLU    22      -1.083  41.446  24.095  1.00  1.00    \n" +
                "ATOM    189  OE2 GLU    22      -1.023  39.210  24.191  1.00  1.00    \n" +
                "ATOM    190  N   GLY    23      -4.219  43.507  20.361  1.00  1.00    \n" +
                "ATOM    191  CA  GLY    23      -4.590  43.844  19.023  1.00  1.00    \n" +
                "ATOM    192  C   GLY    23      -5.302  42.628  18.463  1.00  1.00    \n" +
                "ATOM    193  O   GLY    23      -5.091  42.252  17.312  1.00  1.00    \n" +
                "ATOM    194  N   TYR    24      -6.140  42.051  19.329  1.00  1.00    \n" +
                "ATOM    195  CA  TYR    24      -6.950  40.881  19.030  1.00  1.00    \n" +
                "ATOM    196  C   TYR    24      -8.445  41.205  19.058  1.00  1.00    \n" +
                "ATOM    197  O   TYR    24      -8.913  41.996  19.844  1.00  1.00    \n" +
                "ATOM    198  CB  TYR    24      -6.702  39.859  20.127  1.00  1.00    \n" +
                "ATOM    199  CG  TYR    24      -5.383  39.201  20.039  1.00  1.00    \n" +
                "ATOM    200  CD1 TYR    24      -4.706  39.096  18.830  1.00  1.00    \n" +
                "ATOM    201  CD2 TYR    24      -4.819  38.648  21.180  1.00  1.00    \n" +
                "ATOM    202  CE1 TYR    24      -3.477  38.448  18.751  1.00  1.00    \n" +
                "ATOM    203  CE2 TYR    24      -3.596  37.993  21.125  1.00  1.00    \n" +
                "ATOM    204  CZ  TYR    24      -2.927  37.902  19.909  1.00  1.00    \n" +
                "ATOM    205  OH  TYR    24      -1.712  37.281  19.884  1.00  1.00    \n" +
                "ATOM    206  N   TYR    25      -9.242  40.601  18.244  1.00  1.00    \n" +
                "ATOM    207  CA  TYR    25     -10.626  40.951  18.324  1.00  1.00    \n" +
                "ATOM    208  C   TYR    25     -11.309  40.429  19.519  1.00  1.00    \n" +
                "ATOM    209  O   TYR    25     -11.359  39.225  19.828  1.00  1.00    \n" +
                "ATOM    210  CB  TYR    25     -11.348  40.520  17.094  1.00  1.00    \n" +
                "ATOM    211  CG  TYR    25     -10.661  41.220  15.989  1.00  1.00    \n" +
                "ATOM    212  CD1 TYR    25     -10.582  42.609  15.990  1.00  1.00    \n" +
                "ATOM    213  CD2 TYR    25      -9.976  40.491  15.028  1.00  1.00    \n" +
                "ATOM    214  CE1 TYR    25      -9.927  43.275  14.957  1.00  1.00    \n" +
                "ATOM    215  CE2 TYR    25      -9.268  41.140  14.022  1.00  1.00    \n" +
                "ATOM    216  CZ  TYR    25      -9.256  42.529  13.984  1.00  1.00    \n" +
                "ATOM    217  OH  TYR    25      -8.611  43.158  12.959  1.00  1.00    \n" +
                "ATOM    218  N   THR    26     -11.912  41.359  20.162  1.00  1.00    \n" +
                "ATOM    219  CA  THR    26     -12.597  40.966  21.335  1.00  1.00    \n" +
                "ATOM    220  C   THR    26     -13.877  41.652  21.349  1.00  1.00    \n" +
                "ATOM    221  O   THR    26     -13.953  42.793  20.880  1.00  1.00    \n" +
                "ATOM    222  CB  THR    26     -11.835  41.537  22.494  1.00  1.00    \n" +
                "ATOM    223  OG1 THR    26     -10.622  40.877  22.524  1.00  1.00    \n" +
                "ATOM    224  CG2 THR    26     -12.643  41.412  23.803  1.00  1.00    \n" +
                "ATOM    225  N   ILE    27     -14.836  40.983  21.911  1.00  1.00    \n" +
                "ATOM    226  CA  ILE    27     -16.134  41.582  22.000  1.00  1.00    \n" +
                "ATOM    227  C   ILE    27     -16.562  41.289  23.406  1.00  1.00    \n" +
                "ATOM    228  O   ILE    27     -16.008  40.342  23.969  1.00  1.00    \n" +
                "ATOM    229  CB  ILE    27     -17.098  40.906  21.008  1.00  1.00    \n" +
                "ATOM    230  CG1 ILE    27     -18.472  41.546  21.103  1.00  1.00    \n" +
                "ATOM    231  CG2 ILE    27     -17.283  39.447  21.450  1.00  1.00    \n" +
                "ATOM    232  CD1 ILE    27     -18.878  42.467  19.971  1.00  1.00    \n" +
                "ATOM    233  N   GLY    28     -17.499  42.094  23.945  1.00  1.00    \n" +
                "ATOM    234  CA  GLY    28     -18.105  41.925  25.251  1.00  1.00    \n" +
                "ATOM    235  C   GLY    28     -17.222  42.092  26.470  1.00  1.00    \n" +
                "ATOM    236  O   GLY    28     -16.568  43.107  26.687  1.00  1.00    ";

        PhipsiRunner runner = new PhipsiRunner(file);
        TreeMap<Integer, Angle> phiPsiResult = runner.runPhiPsi();

        PDBFileParser parser = new PDBFileParser();
        Structure structure = parser.parsePDBFile(new BufferedReader(new StringReader(file)));

        Chain ch = structure.getChain(0);

        TreeMap<Integer, Angle> angles = HomodellerUtils.getAngles(ch);

        assertEquals(phiPsiResult.size(), angles.size());

        for ( Integer i : phiPsiResult.keySet())
        {
            Angle phipsi = phiPsiResult.get(i);
            Angle homodeller = angles.get(i);

            assertEqualsRounded(phipsi.getPhi(), homodeller.getPhi());
            assertEqualsRounded(phipsi.getPsi(), homodeller.getPsi());
            assertEqualsRounded(phipsi.getChi(), homodeller.getChi());
        }
    }

    public void testTorsion() throws IOException, StructureException
    {
        String file = "ATOM      1  N   MET     1     -17.775  41.398  46.220  1.00  1.00    \n" +
                "ATOM      2  CA  MET     1     -16.791  40.917  45.201  1.00  1.00    \n" +
                "ATOM      3  C   MET     1     -16.728  39.422  45.076  1.00  1.00    \n" +
                "ATOM      4  O   MET     1     -17.049  38.703  45.989  1.00  1.00    \n" +
                "ATOM      5  CB  MET     1     -15.361  41.348  45.496  1.00  1.00    \n" +
                "ATOM      6  CG  MET     1     -14.798  41.991  44.270  1.00  1.00    \n" +
                "ATOM      7  SD  MET     1     -15.511  43.625  44.098  1.00  1.00    \n" +
                "ATOM      8  CE  MET     1     -14.955  44.413  45.619  1.00  1.00    \n" +
                "ATOM      9  N   ASN     2     -16.264  38.989  43.924  1.00  1.00    \n" +
                "ATOM     10  CA  ASN     2     -16.102  37.600  43.507  1.00  1.00    \n" +
                "ATOM     11  C   ASN     2     -15.736  37.742  42.066  1.00  1.00    \n" +
                "ATOM     12  O   ASN     2     -15.881  38.814  41.468  1.00  1.00    \n" +
                "ATOM     13  CB  ASN     2     -17.406  36.802  43.480  1.00  1.00    \n" +
                "ATOM     14  CG  ASN     2     -18.552  37.467  42.656  1.00  1.00    \n" +
                "ATOM     15  OD1 ASN     2     -18.490  37.650  41.424  1.00  1.00    \n" +
                "ATOM     16  ND2 ASN     2     -19.682  37.722  43.304  1.00  1.00    ";

        PDBFileParser parser = new PDBFileParser();
        Structure structure = parser.parsePDBFile(new BufferedReader(new StringReader(file)));

        Chain ch = structure.getChain(0);

        Group group1 = ch.getGroup(0);
        Group group2 = ch.getGroup(1);

        Atom N = group1.getAtom("N");
        Atom CA = group1.getAtom("CA");
        Atom C = group1.getAtom("C");
        Atom N_1 = group2.getAtom("N");

        // psi
        double torsion = TorsionUtils.torsion(N, CA, C, N_1);

        assertEqualsRounded(157.125854, torsion);

        Atom C_1 = group1.getAtom("C");
        N = group2.getAtom("N");
        CA = group2.getAtom("CA");
        C = group2.getAtom("C");

        // phi
        torsion = TorsionUtils.torsion(C_1, N, CA, C);

        assertEqualsRounded(172.051544, torsion);

        N = group1.getAtom("N");
        CA = group1.getAtom("CA");
        Atom CB = group1.getAtom("CB");
        Atom COG = group1.getAtom("CG");

        torsion = TorsionUtils.torsion(N, CA, CB, COG);

        assertEqualsRounded(-128.558624, torsion);
    }


    private void assertEqualsRounded(double v, double v1, int decimals)
    {
        double rounder = Math.pow(10, decimals);
        double roundedV = Math.round(v * rounder) / rounder;
        double roundedV1 = Math.round(v1 * rounder) / rounder;
        assertEquals(roundedV , roundedV1 );

        rounder = Math.pow(10, 5);
        roundedV = Math.round(v * rounder) / rounder;
        roundedV1 = Math.round(v1 * rounder) / rounder;

        System.out.printf("Expected: %.5f\t Observed: %.5f\n", roundedV, roundedV1);
    }

    private void assertEqualsRounded(double v, double v1)
    {
        try
        {
            assertEqualsRounded(v, v1, 2);
        }
        catch (AssertionFailedError e)
        {
            if (Math.abs(v - v1) > 0.055)
            {
                throw e;
            }
            System.out.printf("Expected: %.5f\t Observed: %.5f\n", v, v1);
        }
    }
}
