package ca.ualberta.proteus.program.minimization.test;

import ca.ualberta.proteus.biojava.PDBFileParser;
import ca.ualberta.proteus.program.minimization.GAFolderRunner;
import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.util.Consts;
import ca.ualberta.proteus.util.PDBFileLoader;
import junit.framework.TestCase;
import org.biojava.bio.structure.Structure;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

/**
 * (C) Zigtag Inc. 2007
 * <p/>
 * User: scott
 * Date: Jan 25, 2007
 * Time: 12:38:48 AM
 */
public class TestGARunner extends TestCase
{
    public void testGARunner() throws IOException
    {
        Config config = Config.getConfig(Consts.HOMODELLER, "config/homodeller.xml");

        String pathname = config.getStringValue("pdb_dir");
        InputStream stream = PDBFileLoader.getPDBFile("1C0VA", new File[]{new File(pathname)});
        PDBFileParser parser = new PDBFileParser();
        Structure structure = parser.parsePDBFile(stream);

        GAFolderRunner runner = new GAFolderRunner(structure);
        Structure minimized = runner.runGAFolder();

        System.out.println(minimized.toPDB());
    }
}
