package ca.ualberta.proteus.program.thrifty;

import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.util.Consts;
import ca.ualberta.proteus.util.GenericProgramRunner;
import ca.ualberta.proteus.util.StreamHandler;

import java.io.File;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Oct 8, 2006
 * Time: 9:42:27 PM
 * To change this template use File | Settings | File Templates.
 */
public class PreditorRunner extends GenericProgramRunner
{
    private String filename;
    private File resultFile;

    public String getFilename()
    {
        return filename;
    }

    public void setFilename(String filename)
    {
        this.filename = filename;
    }

    public void run()
    {
        try
        {
            /*File infile = File.createTempFile("bnmb", ".bmnb");
            FileOutputStream file = new FileOutputStream(infile);
*/
            try
            {
                System.out.println("Running Preditor...");
                String cmd = Config.getConfig(Consts.THRIFTY, "config/thrifty.xml").getStringValue("preditor.command");

                cmd = String.format(cmd, filename);

                File programFile = new File(cmd.split(" ")[0]);
                assert programFile.exists() : "The Preditor command specified does not exist";

                File dir = programFile.getParentFile().getAbsoluteFile();

                cmd = "python " + cmd;

                resultFile = new File(dir, "/temp/results/" + filename + ".shifty_results.txt");

                Process proc = Runtime.getRuntime().exec( cmd, null, dir);

                // any error message?
                StreamHandler errorReader = new
                        StreamHandler(proc.getErrorStream(), "ERROR");

                // any output?
                StreamHandler outputReader = new
                        StreamHandler(proc.getInputStream(), "OUTPUT");

                // kick them off
                errorReader.start();
                outputReader.start();

                // any error???
                int exitVal = proc.waitFor();
                System.out.println("Preditor ExitValue: " + exitVal);

                if (exitVal != 0)
                {
                    System.out.println("Preditor failed");
                    System.out.println(errorReader.getInputString());
                    System.out.println(outputReader.getInputString());
                    return;
                }
            }
            catch (IOException e)
            {
                System.out.println("Error running Preditor");
                System.out.println(e);
            }
        }
        catch( Throwable t )
        {
            t.printStackTrace();
        }
    }

    public File getResultFile()
    {
        return resultFile;
    }
}
