package ca.ualberta.proteus.program.thrifty.test;

import junit.framework.TestCase;
import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.program.thrifty.MatrixEditor;
import ca.ualberta.proteus.util.Consts;

import java.io.*;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Oct 9, 2006
 * Time: 12:19:59 AM
 * To change this template use File | Settings | File Templates.
 */
public class TestMatrixEditor extends TestCase
{
    public void test() throws IOException
    {
        MatrixEditor editor = getMatrix();
        System.out.println(editor.toString());
    }

    private MatrixEditor getMatrix()
            throws IOException
    {
        Config config = Config.getConfig(Consts.THRIFTY, "config/thrifty.xml");
        File blastDataDir = new File(System.getenv("BLASTMAT"));

        if ( ! blastDataDir.exists())
        {
            throw new IllegalStateException("Blast data directory does not exist: BLASTMAT = " + System.getProperty("BLASTMAT"));
        }
        String matrix = config.getStringValue("structureMatrix");

        File matrixFile = new File(blastDataDir, matrix);

        // write the new one and cache the original
        BufferedReader reader = new BufferedReader(new FileReader(matrixFile));

        StringBuilder originalMatrix = new StringBuilder();
        String line;
        while ( ( line = reader.readLine()) != null )
        {
            originalMatrix.append(line).append('\n');
        }
        reader.close();

        MatrixEditor editor = new MatrixEditor(originalMatrix);
        return editor;
    }

    public void testModify() throws IOException
    {
        MatrixEditor matrix = getMatrix();
        matrix.modifyTo9StateMatrix();
        System.out.println(matrix.toString());
    }
}
