package ca.ualberta.proteus.program.tmbhunt;

import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.util.GenericProgramRunner;
import ca.ualberta.proteus.util.StreamHandler;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.io.SeqIOTools;

import java.io.*;
/**
 * Created by eclipse IDEA.
 * User: savita
 * Date: Feb21, 2007
 * Time: 11:50:22 AM
 * To change this template use File | Settings | File Templates.
 */

public class TMBHuntRunner extends GenericProgramRunner{
	private Sequence sequence;

    public TMBHuntRunner(Sequence sequence)
    {
        this.sequence = sequence;
    }

    public void run()
    {
        runTMBHuntRunner();
    }

    public boolean runTMBHuntRunner()
    {
        Config config = Config.getConfig();
      
        boolean isProteinbbtm = false;
        try
        {
            File tempFile;
            tempFile = File.createTempFile("tmbhunt", ".in");
            tempFile.deleteOnExit();

            FileOutputStream blastfile;
            blastfile = new FileOutputStream(tempFile);
            SeqIOTools.writeFasta(blastfile, sequence );
            blastfile.close();
            
            String tmbHuntCmd = config.getStringValue("tmbhunt");
            File runDir = new File(tmbHuntCmd).getParentFile();
            
            String cmd = "perl " + tmbHuntCmd + " " + tempFile.getPath() +" off ";
           // System.out.println("CMD: "+ cmd);
            Process proc = Runtime.getRuntime().exec(cmd, null, runDir.getAbsoluteFile());

            // any error message?
            StreamHandler errorReader = new
                    StreamHandler(proc.getErrorStream(), "ERROR");

            // any output?
            StreamHandler outputReader = new
                    StreamHandler(proc.getInputStream(), "OUTPUT");

            // kick them off
            errorReader.start();
            outputReader.start();

            int exitVal = proc.waitFor();

            if (exitVal != 0)
            {
                System.err.println(cmd);
                System.err.println("TMB Hunt failed " + errorReader.getInputString());
                return isProteinbbtm;
            }

            /** Wait for the output reader to completely do its thing **/
            /*while (! outputReader.jisFinished())
            {
                Thread.sleep(10);
            }*/
            outputReader.join();

            String output = outputReader.getInputString();

            BufferedReader reader = new BufferedReader(new StringReader(output));

            TMBHuntReader tmbreader = new TMBHuntReader();

            isProteinbbtm = tmbreader.parseTMBHuntOutput(reader);
            //StructureAnnotatedSequence rv = new StructureAnnotatedSequence(sequence);
            //rv.equals(protein);

            return isProteinbbtm;
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        catch (InterruptedException e)
        {
            e.printStackTrace();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        return isProteinbbtm;
    }
}
