package ca.ualberta.proteus.program.transsec;

import org.joone.log.ILogger;
import org.joone.log.LoggerFactory;
import org.joone.net.NeuralNet;

import java.io.*;
import java.util.zip.GZIPInputStream;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: May 17, 2005
 * Time: 9:53:17 PM
 * To change this template use File | Settings | File Templates.
 */
public class GzipNeuralNetLoader
{

    /**
     * Logger
     * */
    private static final ILogger log = LoggerFactory.getLogger (GzipNeuralNetLoader.class);

    NeuralNet nnet;

    public GzipNeuralNetLoader(String netName)
    {
        try {
            nnet = readNeuralNet(netName);
        }
        catch (Exception e)
        {
            log.error ( "Cannot create the NeuralNet with the following name : \"" + netName + "\"",
                        e);
        }
    }

    public NeuralNet getNeuralNet() {
        return nnet;
    }

    // Read the object of NeuralNet from the file with name NeuralNet
    private NeuralNet readNeuralNet(String NeuralNet) throws IOException, ClassNotFoundException {

        if (NeuralNet == null)
            return null;
        if (NeuralNet.equals(new String("")))
            return null;

        File NNFile = new File(NeuralNet);
        InputStream in = null;

        try
        {
            in = new FileInputStream(NNFile);
        }
        catch (FileNotFoundException e) {

        }

        if ( in == null ) {
            in = getClass().getResourceAsStream(NeuralNet);
        }

        if ( in == null ) {
            in = getClass().getResourceAsStream("/" + NeuralNet);
        }

        if ( in == null ) {
            throw new FileNotFoundException("Cannot load Neural net file '" + NNFile + "'");
        }

        GZIPInputStream fin = new GZIPInputStream( in );
        ObjectInputStream oin = new ObjectInputStream(fin);

        NeuralNet newNeuralNet = (NeuralNet)oin.readObject();

        oin.close();
        fin.close();
        return newNeuralNet;
    }
}
