package ca.ualberta.proteus.sequence;

import org.biojava.bio.symbol.SymbolList;
import org.biojava.bio.Annotation;
import org.biojava.bio.seq.FeatureRealizer;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Feb 27, 2006
 * Time: 8:26:55 PM
 * To change this template use File | Settings | File Templates.
 *
 * Overrided to enable equals and hashcode functionality
 */
public class SimpleSequence extends org.biojava.bio.seq.impl.SimpleSequence implements Cloneable
{
    public SimpleSequence(SymbolList sym, String urn, String name, Annotation annotation)
    {
        super(sym, urn, name, annotation);
    }

    public SimpleSequence(SymbolList sym, String urn, String name, Annotation annotation, FeatureRealizer realizer)
    {
        super(sym, urn, name, annotation, realizer);
    }

    public boolean equals(Object o)
    {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final SimpleSequence that = (SimpleSequence) o;

        if ( ! seqString().equals(that.seqString()) ) return false;
        if ( ! getAnnotation().equals(that.getAnnotation() ) ) return false;

        return true;
    }

    public int hashCode()
    {
        return seqString().hashCode() + getAnnotation().hashCode();
    }

    public SimpleSequence clone()
    {
        SymbolList symbolList = this.subList(1, this.length());
        return new SimpleSequence(symbolList, this.getURN(), this.getName(), this.getAnnotation());
    }
}
