package ca.ualberta.proteus.test;
import ca.ualberta.proteus.program.homodeller.HomodellerImpl;

/*
 * Created on Apr 17, 2008
 */

/**
 *
 *
 * @author Joseph Cruz
 */
public class HomodollerTest {

	// [query][template]
	private static final String TABLE[][] = {
//		//new String[] { "132L", "1LSY" },//no gaps - GOOD
//		//new String[] { "135L", "1HHL" },//no gaps - GOOD
		new String[] { "1A3D", "4BP2" },//TODO deletion between residues 15-16, insertion between last 2 residues - floating gap
//		new String[] { "1AAPA", "1ADZ" },//deletion between residues 2-3 - GOOD
		new String[] { "1AAPA", "1BIK" },//TODO deletion between residues 11-12 - floating gap
//		new String[] { "1AAPA", "8PTI" },//deletion at C-terminal - GOOD
//		new String[] { "1ALA", "1AVR" },//deletion at C-terminal - GOOD
//		new String[] { "1AZRA", "1AIZA" },//deletion at C-terminal - GOOD
		new String[] { "1B7DA", "1CN2" },//TODO deletion between residues 16-17; 30-31 - pepmake failed, OK
//		//new String[] { "1BPT", "1AAP" },//no gaps - GOOD
//		new String[] { "1CAD", "8RXNA" },//insertion at N-terminal & deletion at C-terminal - GOOD
//		new String[] { "1CBS", "1CBI" },//insertion (residue 117) - GOOD
//		new String[] { "1CRB", "1OPBC" },//insertion at C-terminal - GOOD
		new String[] { "1CTF", "1DD3" },//TODO deletion between residues 39-40 - pepmake failed, OK
//		new String[] { "1DHFA", "1DR7" },//deletion at N-terminal & C-terminal - GOOD
//		//new String[] { "1EMY", "1YMC" },//no gaps - GOOD
//		new String[] { "1ETB1", "1TTCA" },//deletion at N-terminal & C-terminal - GOOD
//		new String[] { "1FAFA", "1GH6A" },//deletion between residues 63-64; 72-73 - GOOD
//		new String[] { "1FKF", "1YAT" },//deletion between residues 1-2 - GOOD
//		//new String[] { "1HNA", "3GSTB" },//no gaps - GOOD
//		new String[] { "1HSAA", "2VAAA" },//insertion at C-terminal - GOOD
		new String[] { "1HUEA", "1HUU" },//TODO insertion residues 59-68 - scrunched loop
//		new String[] { "1MRJ", "1MOM" },//insertion at C-terminal - GOOD
//		new String[] { "1NHKR", "1NDC" },//deletion between residues 133-134; 141-142 - GOOD
		new String[] { "1NOA", "1AKP" },//TODO insertion residue 60, deletion between residues 78:79; 107-108 - pepmake failed, OK
//		new String[] { "1POH", "1PTF" },//deletion at C-terminal - GOOD
//		new String[] { "1PVAA", "1CDP" },//insertion at C-terminal - GOOD
//		new String[] { "1PVAA", "1RRO" },//insertion at C-terminal - GOOD
//		new String[] { "1PZA", "1PMY" },//deletion at C-terminal - GOOD
//		new String[] { "1ROPA", "1GTO" },//deletion at C-terminal - GOOD
		//new String[] { "1RZL", "1JTB" },//no gaps - GOOD
//		new String[] { "1TADB", "1GIA" },//insertion at N-terminal & C-terminal - GOOD
		new String[] { "1THBA", "1PBXA" },//TODO deletion between residues 46 & 47 - pepmake failed, scrunched loop
//		new String[] { "2CHF", "1CHN" },//insertion at N-terminal - GOOD
//		new String[] { "2GBP", "3GBP" },//insertion at N-terminal & C-terminal - GOOD
		new String[] { "2PSPA", "1E9T" },//TODO insertion at N-terminal - GOOD, new start at residue 18, insertion residues 29-47 (12-13); 54-63 (37-46) - scrunched loops
		//new String[] { "2WRPR", "1JHG" },//TODO Problem sequence, no diff, input stream null
		new String[] { "3IL8", "1MI2" },//TODO deletion at N-terminal & insertion residue 12 - GAP, pepmake failed, Problem sequence, no diff b/n old and new verions of LoopInserter
//		new String[] { "4P2P", "2BPP" },//insertion residue 120 - GOOD
		//new String[] { "5HVPB", "1IVPA" },//no gaps - GOOD
//		new String[] { "5PTI", "1ADZ" },//deletion between residues 56-57 - GOOD
//		new String[] { "5PTI", "1BIK" },//deletion between residues 52-53 - GOOD
//		new String[] { "8DFR", "2DHFA" }//insertion at N-terminal & C-terminal - GOOD
	};

	public static void main(String[] args) throws Exception {
		int listIndex = 5;	// use -1 to run through all structures
		int startIndex = 0;
		
		if( listIndex != -1 ) {
			startIndex = listIndex;
		}

		for( int i = startIndex; i < TABLE.length; i++ ) {
			String query = TABLE[i][0];
			String template = TABLE[i][1];
			
			HomodellerImpl.main(new String[] { "-q", query, "-t", template, "-o", query + "_FROM_" + template + "_test.pdb" });
			
			if( listIndex != -1 )
				break;
		}
	}
}
