package ca.ualberta.proteus.util;

import org.biojava.bio.seq.Sequence;
import org.biojava.bio.symbol.Alignment;

import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 18, 2006
 * Time: 10:07:10 PM
 * To change this template use File | Settings | File Templates.
 */
public abstract class AlignmentProgramRunner extends GenericProgramRunner
{
    protected Sequence querySequence;
    protected List<Sequence> blastSequences;
    protected Alignment alignment;
    protected boolean addToDB = false;
    protected boolean useCache = false;

    public Alignment getAlignment()
    {
        if ( alignment == null ) {
            // TODO - maybe make it recover by waiting for it to finish?
            throw new ProcessNotCompleteException("ClustalW has not finished running yet!");
        }
        return alignment;
    }

    /**
     * Set this value to determine whether the alignment is added to the database
     * @param b
     */
    public void setAddToDB(boolean b)
    {
        addToDB = b;
    }

    /**
     * Set this value to determine whether the alignment should be created fresh or obtained
     * from the cache
     * @param b
     */
    public void setUseCache(boolean b)
    {
        useCache = b;
    }
}
