package ca.ualberta.proteus.util;

import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.io.SeqIOTools;

import java.io.*;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

/**
 * Created by IntelliJ IDEA.
 * User: Smontgomerie
 * Date: Apr 19, 2005
 * Time: 2:41:39 PM
 * To change this template use File | Settings | File Templates.
 */
public class BlastDB {
    private static final String DB_FILE = "blast.db.gz";
    private static final String DB_NAME = "BLAST results";
    private static Map<String, List<Sequence>> blastList = new HashMap<String,List<Sequence>>();
    private BlastDB db = null;

    private BlastDB getInstance() {
        throw new IllegalStateException("Not implemented");

        /*if ( db == null )
            return loadDB();
        else
            return db;
            */
    }

    /**
     * Reads in the blast database file
     * @return
     */
    private BlastDB loadDB() {
        try {
            BufferedReader in = new BufferedReader( new InputStreamReader( new GZIPInputStream(new FileInputStream(DB_FILE)) ) );

            // can't use the SeqIOTools readers because this is our own DB format
            String line;
//            String name;
            while ( (line = in.readLine()) != null ) {
                // find beginning of BLAST record
                if ( line.startsWith(">>")) {
//                    name = line.substring(2);
                    while ( (line = in.readLine()) != null ) {

                    }
                }
            }
        }
        catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        return null;
    }

    public static boolean contains(Sequence sequence) {
        return false;  //Todo change body of created methods use File | Settings | File Templates.
    }

    public static List<Sequence> get(Sequence sequence) {
        return null;  //Todo change body of created methods use File | Settings | File Templates.
    }

    /**
     * Writes out the contents of the database file
     */
    private static void writeDB() {
        try {
            synchronized(blastList) {
                OutputStream out = new GZIPOutputStream(new FileOutputStream(DB_FILE));

                for ( Iterator it = blastList.keySet().iterator(); it.hasNext(); ) {
                    String seqName = (String) it.next();
                    List<Sequence> seqList = blastList.get(seqName);
                    String s = ">>" + seqName + "\n";
                    out.write( s.getBytes() );
                    for ( Iterator<Sequence> seqIt = seqList.iterator(); seqIt.hasNext(); ) {
                        Sequence seq = seqIt.next();
                        SeqIOTools.writeFasta(out, seq);
                    }
                }

                out.close();
            }
        }
        catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }

    /**
     *
     * @param name
     * @param seqList
     * @deprecated 
     */
    public static void add(String name, List<Sequence> seqList) {
        //blastList.put(name, seqList);
        //writeDB();
    }
}
