package ca.ualberta.proteus.util;

import org.biojava.bio.seq.ProteinTools;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.symbol.Alignment;
import org.biojava.bio.symbol.IllegalSymbolException;
import org.biojava.bio.symbol.SimpleAlignment;
import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * @author Scott Montgomerie
 * Date: Mar 8, 2005
 * Time: 2:49:31 PM
 * To change this template use File | Settings | File Templates.
 */
public class ClustalWAdapter implements ContentHandler
{
    private Map<String, Sequence> sequenceCollection = null; //<String, Sequence>
    Sequence currentSequence = null;
    String currentSequenceName = null;

    public void setDocumentLocator(Locator locator)
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void startDocument() throws SAXException
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void endDocument() throws SAXException
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void startPrefixMapping(String prefix, String uri) throws SAXException
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void endPrefixMapping(String prefix) throws SAXException
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException
    {
        if ( localName.equals("SequenceCollection")) {
            this.sequenceCollection = new HashMap();
        }
        else if ( localName.equals("Sequence")) {
            currentSequenceName = atts.getValue("sequenceName");
        }
    }

    public void endElement(String uri, String localName, String qName) throws SAXException
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void characters(char ch[], int start, int length) throws SAXException
    {
        /*SymbolTokenization tokenization = null;
        try
        {
            tokenization = ProteinTools.getAlphabet().getTokenization("token");
        }
        catch (BioException e)
        {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }*/

        //SymbolList symList = null;

        String str = String.valueOf(ch);
        if ( currentSequenceName.startsWith("CLUSTAL") || str.startsWith("CLUSTAL"))
        {
            // Skip the version line in the file
            // CLUSTAL 2.0.1 multiple sequence alignment
            return;
        }

        // If the input file has residue numbers leading or trailing , remove them
        str = str.replaceAll("\\d+", "");

        try
        {
            //symList = new SimpleSymbolList(tokenization, String.valueOf( ch ));
            currentSequence = ProteinTools.createGappedProteinSequence(str, currentSequenceName);
        }
        catch (IllegalSymbolException e)
        {
            e.printStackTrace();  
        }

        sequenceCollection.put(currentSequenceName, currentSequence );
    }

    public void ignorableWhitespace(char ch[], int start, int length) throws SAXException
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void processingInstruction(String target, String data) throws SAXException
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void skippedEntity(String name) throws SAXException
    {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public Alignment getAlignment() {
        if ( sequenceCollection == null )
        {
            // TODO - maybe make it recover by waiting for it to finish?
            throw new ProcessNotCompleteException("ClustalW has not finished running yet!");
        }
        return new SimpleAlignment(sequenceCollection);
    }
}
