package ca.ualberta.proteus.util;

/**
 * Created by IntelliJ IDEA.
 * User: Smontgomerie
 * Date: Jun 26, 2005
 * Time: 12:29:02 AM
 * To change this template use File | Settings | File Templates.
 */
public class Consts
{
    public static final String JNET  = "jnet";
    public static final String FINAL  = "final";
    public static final String PSIPRED  = "psipred";
    public static final String PROTEUS  = "proteus";
    public static final String TRANSSEC = "transsec";
    public static final String FINAL_WITH_HOMOLOGY = "final_w_hom";
    public static final String ALIGNMENT = "alignment";
    public static final String REDUCED_SEQUENCES = "reduced_sequences";
    public static final String BLAST_SEQUENCES = "blast_sequences";
    //public static final String HOMOLOG = "homolog";
    public static final String HOMOLOG_EVALUES = "hom_evalue";
    public static final String TM_HOMOLOG_EVALUES = "TM_HOMOLOG_EVALUES";
    public static final String SP_HOMOLOG_EVALUES = "SP_HOMOLOG_EVALUES";

    public static final String ALIGNED_QUERY = "alignedQuery";
    public static final String ALIGNED_HOMOLOG = "alignedHomolog";
    //public static final String HOMOLOG_NAME = "homolog_name";
    public static final String HOMOLOG_LIST = "homolog_list";
    public static final String ALIGNED_HOMOLOG_LIST = "aligned_homolog_list";
    public static final String LOGGER = "logger";
    public static final String PROTEUS_OBJECT = "proteus_object";
    public static final String PROTEUS_ID = "proteus_id";
    public static final String SETTINGS = "settings";
    public static final String HOMODELLER_RESULTS = "homodeller_results";
    public static final String HOMODELLER_RESULT = "homodeller_result";
    public static final String HOMODELLER_TEMPLATE_BAD = "homodeller_template_bad";
    public static final String PROTEUS_SETTINGS = "proteus_settings";
    public static final String TIME_ELAPSED = "time_elapsed";
    public static final String IS_TM = "is_TM";
    public static final String ALL_ALIGNED_HOMOLOG_LIST = "all_aligned_homolog_list";
    public static final String IMAGE_NAME = "image_name";
    public static final String SEQUENCE_NAME = "sequence_name";
    public static final String SUBMIT_TIME = "submit_time";
    public static final String SEQSEE_DB = "seqsee_db";
    public static final String DB_RELOAD_INTERVAL = "DB_RELOAD_INTERVAL";
    public static final String HOMODELLER = "HOMODELLER";
    public static final String THRIFTY = "THRIFTY";
    public static final String QUERY = "QUERY";
    public static final String TRANSMEMBRANE = "TRANSMEMBRANE";
    public static final String SIGNAL_PEPTIDE = "SIGNAL_PEPTIDE";
    public static final String MINIMIZED_STRUCTURE = "MINIMIZED_STRUCTURE";
    public static final String TM_HOMOLOGS = "TM_HOMOLOGS";
    public static final String SP_HOMOLOGS = "SP_HOMOLOGS";
    public static final String ALIGNED_TM_HOMOLOG = "ALIGNED_TM_HOMOLOG";
    public static final String ALIGNED_SP_HOMOLOG = "ALIGNED_SP_HOMOLOG";
    public static final String TRANSMEMBRANE_HOMOLOG = "TRANSMEMBRANE_HOMOLOG";
    public static final String TM_IMAGE_NAME = "TM_IMAGE_NAME";
    public static final String HOMODELLER_ERROR = "HOMODELLER_ERROR";
    public static final String TM_HOMOLOG = "TM_HOMOLOG";
    public static final String SP_HOMOLOG = "SP_HOMOLOG";
    public static final String TMBHUNT_SCORE = "TMBHUNT_SCORE";
    public static final String TMBHUNT_EVALUE = "TMBHUNT_EVALUE";
    public static final String IS_BBTM = "is_BBTM";

    public static final String APPNAME = "Proteus 2.0";


    public static final String DATABASE_FILE = "databaseFile";

    public enum Steps { TM_SEARCH, BLAST, XALIGN, PSIPRED, JNET, PROTEUS, HOMOLOG, HOMODELLER, ENERGY_MINIMIZATION }

    public enum Homolog {
    	Transmembrane("TMPDB"),
    	BetaBarrel("BBDB"),
    	GramPositiveSignalPeptide("SPDB.gram+"),
    	GramNegativeSignalPeptide("SPDB.gram-"),
    	EukaryoticSignalPeptide("SPDB.euk");
    	
    	private String stringValue;
    	private Homolog(String stringValue) {
    		this.stringValue = stringValue;
    	}
    	
    	public String getStringValue() {
    		return this.stringValue;
    	}
    }
}
