package ca.ualberta.proteus.util;

import ca.ualberta.proteus.logging.ProteusLogger;
import ca.ualberta.proteus.program.transsec.Config;

import javax.mail.*;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import java.util.Arrays;
import java.util.Properties;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Aug 3, 2005
 * Time: 11:44:30 PM
 * To change this template use File | Settings | File Templates.
 */
public class EmailUtils
{

    static ProteusLogger logger = ProteusLogger.getLogger();

    public static void sendMessage(final String from, final String to, final String subject, final String content)
    {
        /// spawn a new thread so that the emailing doesn't hold things up
        new Thread()
        {
            public void run()
            {
                sendMessageInternal(from, to, subject, content);
            }
        }.start();
    }

    private static void sendMessageInternal(String from, String to, String subject, String content)
    {
        /*  Session sess = null;

                  try
                  {
                      Context initCtx = new InitialContext();
                      Context envCtx = (Context) initCtx.lookup("java:comp/env");
                      sess = (Session) envCtx.lookup("mail/Session");
                  }
                  catch (NamingException e)
                  {
                          // Windows users won't be able to send mail because they don't have a MTA on their boxes.
                          // This is really a development problem only so we're just going to handle it.

                     // throw new RuntimeException("Could not obtain mail session reference.", e);
                  }
          */
        Properties props = new Properties();
        String emailServer = null;
        try
        {
            emailServer = Config.getConfig().getStringValue("emailServer");
        }
        catch(IllegalArgumentException e)
        {
            logger.warn(e.getMessage());
        }
        if ( emailServer != null )
            props.put("mail.smtp.host", emailServer);
        else
        {
            logger.warn("Can't send email - Email server not found in config file");
            return;
        }

        Session sess = Session.getDefaultInstance(props, null);

        try
        {
            Message message = new MimeMessage(sess);
            message.setFrom(new InternetAddress(from));
            InternetAddress toAddr[] = new InternetAddress[1];
            toAddr[0] = new InternetAddress(to);
            message.setRecipients(Message.RecipientType.TO, toAddr);
            message.setSubject(subject);

            message.setContent(content, "text/html");

            Transport.send(message);
        }
        catch (SendFailedException e)
        {
            logger.warn("Could not send email." + e.getMessage() + "\nBad address(es): " + Arrays.toString(e.getInvalidAddresses()));
        }
        catch (MessagingException e)
        {
            throw new RuntimeException("Could not send email!", e);
        }
    }

}
