package ca.ualberta.proteus.util;

import java.io.File;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: May 10, 2005
 * Time: 8:12:53 PM
 * To change this template use File | Settings | File Templates.
 */
public abstract class GenericProgramRunner extends Thread
{
    protected boolean finished = false;
    protected final String RUN_DATA_DIR = "rundata";

    public GenericProgramRunner()
    {
        finished = false;
    }

    public abstract void run();

    public boolean isFinished()
    {
        return finished;
    }

    /**
     * Returns a string that represents a unique ID for a file, based on the current time in milliseconds
     * and thread ID, so you can have many threads concurrently creating the same type of file with unique ID's
     * Note - you should append a suffix to this file name if it is a file name you're using
     * @return
     */
    protected String getUniqueIdentifier()
    {
        return String.valueOf( System.currentTimeMillis() ) + String.valueOf( Thread.currentThread().getId() );
    }

    /**
     * Each program can put its temporary file output into this directory.
     * This function ensures this directory exists.
     */
    protected void ensureRunDataDirExists()
    {
        File tmpDir = new File(RUN_DATA_DIR);
        if ( ! tmpDir.exists())
            tmpDir.mkdir();
    }
}
