package ca.ualberta.proteus.util;

import ca.ualberta.proteus.program.transsec.PredictionFilter;
import ca.ualberta.proteus.sequence.ScoreAnnotatedSequence;
import ca.ualberta.proteus.sequence.StructureAnnotatedSequence;

/**
 * Created by IntelliJ IDEA.
 * @author Scott Montgomerie
 * Date: Mar 20, 2005
 * Time: 12:52:26 PM
 * To change this template use File | Settings | File Templates.
 */
public class SimpleFilter implements PredictionFilter
{
    public ScoreAnnotatedSequence filter(ScoreAnnotatedSequence unfilteredPrediction)
    {
        String unfilteredStr = unfilteredPrediction.getStructureAnnotation().seqString().toUpperCase();

        unfilteredStr = internalFilter(unfilteredStr);

        unfilteredPrediction.setStructureAnnotation(ProteusTools.createStructure(unfilteredStr));
        return unfilteredPrediction;
    }


    public StructureAnnotatedSequence filter(StructureAnnotatedSequence unfilteredPrediction)
    {
        String unfilteredStr = unfilteredPrediction.getStructureAnnotation().seqString().toUpperCase();

        unfilteredStr = internalFilter(unfilteredStr);

        unfilteredPrediction.setStructureAnnotation(ProteusTools.createStructure(unfilteredStr));
        return unfilteredPrediction;
    }

    private String internalFilter(String unfilteredStr)
    {
        // TODO take this out
        unfilteredStr = unfilteredStr.replace('C', '-');
        // unfilteredStr = unfilteredStr.replace('E', 'B');

        for (int j = 0; j < 2; j++)
        {
            for (int i = 0; i < 2; i++)
            {
                // do this twice to make sure we get all the substitutions
                unfilteredStr = unfilteredStr.replaceAll("--(B|H)--", "-----");

                unfilteredStr = unfilteredStr.replaceAll("-B$|-H$", "--"); // end of sequence that starts with a single prediction is bad
                unfilteredStr = unfilteredStr.replaceAll("--B-$|--H-$", "----");

                unfilteredStr = unfilteredStr.replaceAll("B-B-B", "BBBBB");
                unfilteredStr = unfilteredStr.replaceAll("H-H-H", "HHHHH");

                unfilteredStr = unfilteredStr.replaceAll("-B-B-", "-BBB-");
                unfilteredStr = unfilteredStr.replaceAll("-H-H-", "-HHH-");


                unfilteredStr = unfilteredStr.replaceAll("HHB-", "HH--");
                unfilteredStr = unfilteredStr.replaceAll("-HBB", "--BB");

                unfilteredStr = unfilteredStr.replaceAll("-B-BB", "-BBBB");
                unfilteredStr = unfilteredStr.replaceAll("-H-HH", "-HHHH");

                unfilteredStr = unfilteredStr.replaceAll("-H-BB", "---BB");
                unfilteredStr = unfilteredStr.replaceAll("-B-HH", "---HH");

                unfilteredStr = unfilteredStr.replaceAll("--H-B-", "------");
                unfilteredStr = unfilteredStr.replaceAll("--B-H-", "------");

                unfilteredStr = unfilteredStr.replaceAll("--HB-|--BH-", "-----");

                unfilteredStr = unfilteredStr.replaceAll("H-B-H|B-H-B", "-----");			//replaceAll H-B-H with -----",

                unfilteredStr = unfilteredStr.replaceAll("BB-BB-", "BBBBB-");
                unfilteredStr = unfilteredStr.replaceAll("HH-HH-", "HHHHH-");

                unfilteredStr = unfilteredStr.replaceAll("HBH", "HHH");
                unfilteredStr = unfilteredStr.replaceAll("BHB", "BBB");

                unfilteredStr = unfilteredStr.replaceAll("BBBH-", "BBBB-"); // used to be BBH-
                unfilteredStr = unfilteredStr.replaceAll("HHHB-", "HHHH-");

                unfilteredStr = unfilteredStr.replaceAll("--BH--", "------"); // used to be BH-
                unfilteredStr = unfilteredStr.replaceAll("--HB--", "------"); //new

                unfilteredStr = unfilteredStr.replaceAll("BBHHBB", "BBBBBB");
                unfilteredStr = unfilteredStr.replaceAll("HHBBHH", "HHHHHH");

                unfilteredStr = unfilteredStr.replaceAll("--HH--", "------"); // new

                unfilteredStr = unfilteredStr.replaceAll("BBHH-", "BB---");

                unfilteredStr = unfilteredStr.replaceAll("BBBBHHHH", "BBB-HHHH");  // insert a coil between two adjacent structures

                unfilteredStr = unfilteredStr.replaceAll("--(T|H)--", "-----");

                unfilteredStr = unfilteredStr.replaceAll("-T$|-H$", "--"); // end of sequence that starts with a single prediction is bad
                unfilteredStr = unfilteredStr.replaceAll("--T-$|--H-$", "----");

                unfilteredStr = unfilteredStr.replaceAll("T-T-T", "TTTTT");
                unfilteredStr = unfilteredStr.replaceAll("H-H-H", "HHHHH");

                unfilteredStr = unfilteredStr.replaceAll("-T-T-", "-TTT-");
                unfilteredStr = unfilteredStr.replaceAll("-H-H-", "-HHH-");


                unfilteredStr = unfilteredStr.replaceAll("HHT-", "HH--");
                unfilteredStr = unfilteredStr.replaceAll("-HTT", "--TT");

                unfilteredStr = unfilteredStr.replaceAll("-T-TT", "-TTTT");
                unfilteredStr = unfilteredStr.replaceAll("-H-HH", "-HHHH");

                unfilteredStr = unfilteredStr.replaceAll("-H-TT", "---TT");
                unfilteredStr = unfilteredStr.replaceAll("-T-HH", "---HH");

                unfilteredStr = unfilteredStr.replaceAll("--H-T-", "------");
                unfilteredStr = unfilteredStr.replaceAll("--T-H-", "------");

                unfilteredStr = unfilteredStr.replaceAll("--HT-|--TH-", "-----");

                unfilteredStr = unfilteredStr.replaceAll("H-T-H|T-H-T", "-----");			//replaceAll H-T-H with -----",

                unfilteredStr = unfilteredStr.replaceAll("TT-TT-", "TTTTT-");
                unfilteredStr = unfilteredStr.replaceAll("HH-HH-", "HHHHH-");

                unfilteredStr = unfilteredStr.replaceAll("HTH", "HHH");
                unfilteredStr = unfilteredStr.replaceAll("THT", "TTT");

                unfilteredStr = unfilteredStr.replaceAll("TTTH-", "TTTT-"); // used to be BBH-
                unfilteredStr = unfilteredStr.replaceAll("HHHT-", "HHHH-");

                unfilteredStr = unfilteredStr.replaceAll("--TH--", "------"); // used to be BH-
                unfilteredStr = unfilteredStr.replaceAll("--HT--", "------"); //new

                unfilteredStr = unfilteredStr.replaceAll("TTHHTT", "TTTTTT");
                unfilteredStr = unfilteredStr.replaceAll("HHTTHH", "HHHHHH");

                unfilteredStr = unfilteredStr.replaceAll("--HH--", "------"); // new

                unfilteredStr = unfilteredStr.replaceAll("TTHH-", "TT---");

                unfilteredStr = unfilteredStr.replaceAll("TTTTHHHH", "TTT-HHHH");  // insert a coil between two adjacent structures

            }

            StringBuffer sb = new StringBuffer(unfilteredStr);
            unfilteredStr = sb.reverse().toString();
        }

        unfilteredStr = unfilteredStr.replace('-', 'C');
        // unfilteredStr = unfilteredStr.replace('B', 'E');
        return unfilteredStr;
    }
}
