package ca.ualberta.proteus.util.db;

public class PredictionDBFactory
{
    final static DBType defaultType = DBType.SQL;

    public static PredictionDB getDB(DBType type)
    {
        switch (type)
        {
            case XML:
               return XMLPredictionDB.getInstance();
            case DB4O:
               return PredictionDB4O.getInstance();
            case SQL:
               return SQLPredictionDB.getInstance();
            default:
                throw new IllegalStateException("Invalid DB type");
        }
    }

    public static PredictionDB getDB()
    {
        return getDB(defaultType);
    }


    /**
     *  Returns the DB whether it's at run time or evaluation time
     * @return a PredictionDB
     */
    public static PredictionDB getRunTimeDB( boolean evaluating )
    {
        return evaluating ? getDB( DBType.SQL ) : getDB( DBType.XML);
    }
}
