package ca.ualberta.proteus.util.db;

import ca.ualberta.proteus.sequence.ScoreAnnotatedSequence;
import ca.ualberta.proteus.util.db.PredictionDB4O;
import ca.ualberta.proteus.util.db.PredictionDB;
import ca.ualberta.proteus.util.db.PredictionDBFactory;
import ca.ualberta.proteus.util.db.DBType;
import ca.ualberta.proteus.util.test.Threading2DTest;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.ProteinTools;
import org.biojava.bio.symbol.IllegalSymbolException;
import junit.framework.Test;
import junit.framework.TestSuite;
import junit.framework.TestCase;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Mar 1, 2006
 * Time: 7:58:17 PM
 * To change this template use File | Settings | File Templates.
 */
public class PredictionDBTest extends TestCase
{
    public static Test suite()
    {
        return new TestSuite(Threading2DTest.class);
    }

    public static void main(String[] args)
    {
        new junit.textui.TestRunner().doRun(suite());
    }

    public void testGet() throws IllegalSymbolException
    {
        String name = "1c5z_B";
        String seq = "IIGGEFTTIENQPWFAAIYRRHVTYVCGGSLMSPCWVISATHCFIKKDYIVYLGRSRLNSN";
        seq += "TQGEMKFEVENLILHKDYSADAHHNDIALLKIRSCAQPSRTIQTICLP";
        seq += "SMYNDPQFGTSCEITGFGKEASTDYLYPEQLKMTVVKLISHRECQQYYGSEVTTKMLCAADW";
        seq += "KTDSCQGDSGGPLVCSLQGRMTLTGIVSWGRGCALKKPGVYTRVSHFLPWIRSHT";

        Sequence sequence = ProteinTools.createProteinSequence(seq, name);

        PredictionDB db = PredictionDBFactory.getDB(DBType.DB4O);

        ScoreAnnotatedSequence proteus = db.get(sequence, "PROTEUS");
        ScoreAnnotatedSequence jnet = db.get(sequence, "JNET");
        ScoreAnnotatedSequence psipred = db.get(sequence, "PSIPRED");

        assertNotNull(proteus);
        assertNotNull(jnet);
        assertNotNull(psipred);
    }

    public void addToMySQL()
    {
        PredictionDB4O db = PredictionDB4O.getInstance();
        db.exportToExternalDB();
    }
}
