package ca.ualberta.proteus.util.db;

import junit.framework.Test;
import junit.framework.TestSuite;
import junit.framework.TestCase;
import ca.ualberta.proteus.util.io.SeqSeeDB;
import ca.ualberta.proteus.sequence.ScoreAnnotatedSequence;
import org.biojava.bio.BioException;
import org.biojava.bio.seq.Sequence;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: May 4, 2006
 * Time: 11:12:34 PM
 * To change this template use File | Settings | File Templates.
 */
public class SQLDBTest extends TestCase
{
    public SQLDBTest(String name)
    {
        super(name);
    }

    public static Test suite()
    {
        return new TestSuite(SQLDBTest.class);
    }

    public void testConnection()
    {
        DBUtils.getConnection();
    }

    public void testAddSequence() throws BioException
    {
        SeqSeeDB db = SeqSeeDB.getInstance();
        SQLPredictionDB.addSequence( db.getSequence(0) );

        SQLPredictionDB.get( db.getSequence(0).getName() );
    }

    public void testGetSequence() throws BioException
    {
        SeqSeeDB db = SeqSeeDB.getInstance();

        Sequence dbSequence = db.getSequence(0);
        SQLPredictionDB.addSequence( dbSequence );

        Sequence sequence = SQLPredictionDB.get(dbSequence.getName());

        assertEquals(sequence.seqString(), dbSequence.seqString());
    }

    public void testAddPrediction() throws BioException
    {
        SeqSeeDB db = SeqSeeDB.getInstance();

        PredictionDB4O predictionDB = PredictionDB4O.getInstance();

        int i=0;
        while ( true )
        {
            Sequence sequence = db.getSequence(i++);
            SQLPredictionDB.addSequence( sequence );

            ScoreAnnotatedSequence psipred = predictionDB.get(sequence, "PSIPRED");
            ScoreAnnotatedSequence jnet = predictionDB.get(sequence, "JNET");
            ScoreAnnotatedSequence proteus = predictionDB.get(sequence, "PROTEUS");

            if ( psipred != null )
            {
                PredictionDB sqlDB = PredictionDBFactory.getDB(DBType.SQL);

                sqlDB.add(sequence, "PSIPRED", psipred);
                sqlDB.add(sequence, "JNET", jnet);
                sqlDB.add(sequence, "PROTEUS", proteus);

                ScoreAnnotatedSequence structurePrediction = sqlDB.get(sequence, "PSIPRED");

                // it should be added
                assertEquals(structurePrediction.seqString(), psipred.seqString());
                assertEquals(structurePrediction.getStructureAnnotation().seqString(), psipred.getStructureAnnotation().seqString());
                // can't test scores - mySQL schema doesn't store all 3 scores, just the best one

                System.out.println("Added " + sequence.getName());
                break;
            }
        }
    }
}
