package ca.ualberta.proteus.util.test;

import ca.ualberta.proteus.util.ProteusTools;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.biojava.bio.BioException;
import org.biojava.bio.seq.Sequence;

import java.io.File;
import java.io.IOException;
import java.util.List;

/**
 * Created by Scott Montgomerie
 * Date: Jul 11, 2006
 */
public class FastaParserTest extends TestCase
{
    public static Test suite()
        {
            return new TestSuite(FastaParserTest.class);
        }

        public static void main(String[] args)
        {
            new junit.textui.TestRunner().doRun(suite());
        }

        public void testParse() throws BioException, IOException
        {
            List<Sequence> sequences = ProteusTools.parseFasta(new File("test/fastaParserTest"));

            for ( Sequence s : sequences)
            {
                System.out.println(s.getName());
                System.out.println(s.seqString());
            }
        }

        public void testParse1Sequence() throws BioException, IOException
        {
            List<Sequence> sequences = ProteusTools.parseFasta(new File("test/test1.fa"));

            for ( Sequence s : sequences)
            {
                System.out.println(s.getName());
                System.out.println(s.seqString());
            }

            assertEquals(1, sequences.size());
        }
}
