package ca.ualberta.proteus.util.test;

import ca.ualberta.proteus.util.BlastRunner;
import ca.ualberta.proteus.util.io.SeqSeeDB;
import ca.ualberta.proteus.util.XAlignRunner;
import ca.ualberta.proteus.util.BlastSettings;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.biojava.bio.Annotation;
import org.biojava.bio.BioException;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.symbol.Alignment;
import org.biojava.utils.ChangeVetoException;

import java.util.Iterator;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: ici
 * Date: Sep 29, 2005
 * Time: 8:08:46 PM
 * To change this template use File | Settings | File Templates.
 */
public class XAlignTest extends TestCase {
    public XAlignTest(String name) {
        super(name);
    }

    public void setUp() throws Exception {
        super.setUp();
    }

    public void tearDown() throws Exception {
        super.tearDown();
    }

    public static Test suite() {
        return new TestSuite(XAlignTest.class);
    }

    public static void main(String[] args) {
        new junit.textui.TestRunner().doRun(suite());
    }

    public void testXAlign() {
        Sequence sequence = null;
        //sequence = (Sequence) SeqSeeDB.getInstance().getRandomSequences(1).get(0);
        try {
            sequence = (Sequence) SeqSeeDB.getInstance().getSequence("1EF5A");
        }
        catch (BioException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

        List blastSequences = null;
        BlastSettings settings = new BlastSettings();
        settings.setSequence(sequence);
        settings.setBlastType(BlastSettings.BLASTTYPE.PSIBLAST);
        settings.setEvalue(0.001);

        BlastRunner blastRunner = new BlastRunner(settings);
        blastRunner.run();

        /// wait for the thread to complete
        while (!blastRunner.isFinished()) {
            try {
                Thread.sleep(10);
            }
            catch (InterruptedException e) {
            }
        }

        blastSequences = blastRunner.getUnalignedResult();

        try {
            sequence.getAnnotation().setProperty("description_line", "QUERY");
        }
        catch (ChangeVetoException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        blastSequences.add(sequence);

        Alignment alignment = null;

        XAlignRunner runner = new XAlignRunner(sequence, blastSequences);
        runner.setUseCache(false);
        runner.run();

        alignment = runner.getAlignment();

        for (Iterator it = alignment.symbolListIterator(); it.hasNext();) {
            Sequence seq = (Sequence) it.next();
            System.out.println(seq.getName() + ": " + seq.seqString());

            Annotation annotation = seq.getAnnotation();
            if ( annotation.containsProperty("subjectDescription"))
                System.out.println(annotation.getProperty("subjectDescription"));
        }

    }
}
