package ca.ualberta.proteus.web;

import ca.ualberta.proteus.program.ProteusImpl;
import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.util.Consts;
import ca.ualberta.proteus.logging.RuntimeCatalog;
import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.File;
import java.io.IOException;
import java.util.Date;

/**
 * Created by IntelliJ IDEA.
 * User: Smontgomerie
 * Date: Jun 19, 2005
 * Time: 10:03:19 PM
 * To change this template use File | Settings | File Templates.
 */
public class InfoAction extends Action
{
    private static final Logger log4jlogger = Logger.getLogger(InfoAction.class);

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm,
                                 HttpServletRequest request, HttpServletResponse response)
            throws Exception
    {
        String ID = request.getParameter("ID");

        HttpSession session = request.getSession();
        ProteusImpl proteus = (ProteusImpl) session.getAttribute(Consts.PROTEUS_OBJECT + ID);
        if ( proteus != null ) {
            RuntimeCatalog logger = proteus.getLogger();
            request.setAttribute(Consts.LOGGER, logger);
            request.setAttribute(Consts.PROTEUS_ID, proteus.getID());
            request.setAttribute(Consts.PROTEUS_SETTINGS, proteus.getSettings());

            Date timeElapsed;
            timeElapsed = proteus.getStartTime();
            if ( timeElapsed == null )
                timeElapsed = new Date();
            timeElapsed = new Date( new Date().getTime() - timeElapsed.getTime() );
            request.setAttribute(Consts.TIME_ELAPSED, timeElapsed );

            return finish(logger, ID, request, actionMapping);
        }
        else
        {
            //request.setAttribute("message", "Proteus ID " + ID  + " does not exist");
            //return actionMapping.findForward("globalException");

            File storageDirectory = new File( Config.getConfig().getStringValue("storageDir"));
            if ( !storageDirectory.exists())
                storageDirectory.mkdir();

            RuntimeCatalog logger;
            try
            {
                logger = PersistentProteusResultStorage.restore(ID, storageDirectory);

                request.setAttribute(Consts.LOGGER, logger);
                request.setAttribute(Consts.PROTEUS_ID, ID);

                return finish(logger, ID, request, actionMapping);
            }
            catch ( IOException e)
            {
                System.out.println(e);
                request.setAttribute("message", "Proteus ID " + ID  + " does not exist");
                request.setAttribute("trace", e.getStackTrace());
                return actionMapping.findForward("globalException");
            }
        }
        //return actionMapping.findForward("success");
    }

    private ActionForward finish(RuntimeCatalog logger, String ID, HttpServletRequest request, ActionMapping actionMapping)
    {
        /*
        if ( logger.waitFor() )
        {
            return actionMapping.findForward("final");
        }
        else
        */
            return actionMapping.findForward("success");
    }
}
