package ca.ualberta.proteus.web;

import ca.ualberta.proteus.logging.RuntimeCatalog;

import java.io.*;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 10, 2005
 * Time: 6:28:29 PM
 * To change this template use File | Settings | File Templates.
 */
public class PersistentProteusResultStorage {

    public static void store(String ID, RuntimeCatalog proteus, File storageDirectory) throws IOException, ClassNotFoundException {
        File f = new File(storageDirectory, ID);
        FileOutputStream fos = new FileOutputStream(f);

        ObjectOutputStream out = new ObjectOutputStream(fos);
        out.writeObject(proteus);
        out.close();
    }

    public static RuntimeCatalog restore(String sessionID, File storageDirectory) throws IOException, ClassNotFoundException {
        if ( storageDirectory == null )
            throw new FileNotFoundException("Storage directory is null!");

        int tries = 0;
        while ( tries++ < 5 )
        {
            File f = new File(storageDirectory, sessionID);
            if ( !f.exists() )
            {
                // Maybe it's still getting serialized, wait for a bit
                try
                {
                    Thread.sleep(2000);
                }
                catch (InterruptedException e)
                {
                    e.printStackTrace();
                }
                continue;
            }

            try
            {
                FileInputStream fos = new FileInputStream(f);
                ObjectInputStream in = new ObjectInputStream( fos);
                return (RuntimeCatalog) in.readObject();
            }
            catch(IOException e)
            {
                try
                {
                    // Maybe it's still getting serialized, wait for a bit
                    Thread.sleep(2000);
                }
                catch (InterruptedException e1)
                {
                    e1.printStackTrace();
                }
                System.err.println(e);
            }
        }
        return null;
    }
}
