package ca.ualberta.proteus.web;

import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.db.DB4OPool;
import org.apache.log4j.Logger;
import org.apache.struts.action.ActionServlet;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.*;
import java.io.File;
import java.io.IOException;

public class ProteusActionServlet extends ActionServlet
        implements HttpSessionListener
{
    private static final Logger logger = Logger.getLogger(ProteusActionServlet.class);

    public void init() throws ServletException
    {
        super.init();

        ServletContext servletContext = getServletContext();

        Config.initializeFromWebContext(servletContext);

        File storageDirectory = new File( Config.getConfig().getStringValue("storageDir"));
        if ( !storageDirectory.exists())
        {
            storageDirectory.mkdir();
        }

        SubmissionQueue.load();                

        logger.info("Proteus initialized");
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        super.doGet(request, response);
    }

    public void sessionCreated(HttpSessionEvent event)
    {
        logger.debug("Session " + event.getSession().getId() + " created");
    }

    public void sessionDestroyed(HttpSessionEvent event)
    {
        HttpSession session = event.getSession();

        session.invalidate();
         /*
        if (logger.isDebugEnabled())
        {
            DateFormat df = DateFormat.getDateTimeInstance();
            String debugMsg = "Session " + session.getId() + " destroyed\n"
                    + "Created: " + df.format(new Date(session.getCreationTime())) + "\n"
                    + "Last accessed : " + df.format(new Date(session.getLastAccessedTime()));
            logger.debug(debugMsg);
        }
        */
    }

    public void destroy()
    {
        // logger.info("Closing DB4O database");
        // DB4OPool.getDB().close();
    }
}
