package ca.ualberta.proteus.web;

import ca.ualberta.proteus.sequence.ScoreAnnotatedSequence;
import ca.ualberta.proteus.sequence.StructureAnnotatedSequence;
import ca.ualberta.proteus.util.Consts;
import ca.ualberta.proteus.program.MethodSettings;
import ca.ualberta.proteus.program.ProteusSettings;
import ca.ualberta.proteus.logging.RuntimeCatalog;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Apr 4, 2006
 * Time: 8:12:01 PM
 * To change this template use File | Settings | File Templates.
 */
public class ProteusHelperUtils
{

    public static StructureAnnotatedSequence getStructureForStats(RuntimeCatalog logger)
    {
        ProteusSettings settings = (ProteusSettings) logger.getLogObject(Consts.SETTINGS);
        MethodSettings method = settings.getMethod();

        /* Get the stats for % sequence composition */
        ScoreAnnotatedSequence combined = (ScoreAnnotatedSequence) logger.getLogObject(Consts.FINAL);
        ScoreAnnotatedSequence psipred = (ScoreAnnotatedSequence) logger.getLogObject(Consts.PSIPRED);
        ScoreAnnotatedSequence jnet = (ScoreAnnotatedSequence) logger.getLogObject(Consts.JNET);
        ScoreAnnotatedSequence proteusSequence = (ScoreAnnotatedSequence) logger.getLogObject(Consts.TRANSSEC);
        if ( proteusSequence == null )
            proteusSequence = (ScoreAnnotatedSequence) logger.getLogObject(Consts.PROTEUS);

        StructureAnnotatedSequence structureForStats;
        switch( method )
        {
            case ALL:
                structureForStats = combined;
                break;
            case PSIPRED:
                structureForStats = psipred;
                break;
            case JNET:
                structureForStats = jnet;
                break;
            case TRANSSEC:
                structureForStats = proteusSequence;
                break;
            default:
                structureForStats = combined;
                break;
        }

        // failsafe??
        if ( structureForStats == null )
        {
            structureForStats = combined;
        }

        return structureForStats;
    }
}
