package ca.ualberta.proteus.web;

import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.program.ProteusImpl;
import ca.ualberta.proteus.sequence.GappedStructureAnnotatedSequence;
import ca.ualberta.proteus.util.Consts;
import ca.ualberta.proteus.util.Threading2D;
import ca.ualberta.proteus.logging.RuntimeCatalog;
import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.structure.Structure;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: Smontgomerie
 * Date: Aug 12, 2005
 * Time: 12:32:17 PM
 * To change this template use File | Settings | File Templates.
 */
public class ViewPDBAction extends Action
{
    private static final Logger logger = Logger.getLogger(InfoAction.class);
    //private static final boolean testing = Config.getConfig().getBooleanValue("testing");

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm,
                                 HttpServletRequest request, HttpServletResponse response)
            throws Exception
    {
        HttpSession session = request.getSession();
        ActionForward forward = actionMapping.findForward("success");

        Structure PDB = null;// = (Structure) session.getAttribute("PDB");
        String ID = request.getParameter("ID");
        String PDBID = request.getParameter("PDBID");
        ProteusImpl proteus = (ProteusImpl) session.getAttribute(Consts.PROTEUS_OBJECT + ID);

        RuntimeCatalog logger;
        if ( proteus == null ) {
            File storageDirectory = new File( Config.getConfig().getStringValue("storageDir"));
            if ( !storageDirectory.exists())
                storageDirectory.mkdir();
            try
            {
                logger = PersistentProteusResultStorage.restore(ID, storageDirectory);
            }
            catch ( IOException e)
            {
                System.out.println(e);
                ViewPDBAction.logger.error(e);
                request.setAttribute("message", "Proteus ID " + ID  + " does not exist");
                request.setAttribute("trace", e.getStackTrace());
                return actionMapping.findForward("globalException");
            }
        }
        else
            logger = proteus.getLogger();

        //assert logger != null : "Logger is null";

        List<GappedStructureAnnotatedSequence> homologList = null;

        if ( logger != null )
        {
            homologList = ((List<GappedStructureAnnotatedSequence>) logger.getLogObject(Consts.ALL_ALIGNED_HOMOLOG_LIST));
        }

        Sequence homologSequence = null;
        if ( homologList != null )
        {
            for ( Sequence seq: homologList )
            {
                if ( seq.getName().equals(PDBID))
                {
                    homologSequence = seq;
                    break;
                }
            }

            GappedStructureAnnotatedSequence alignedQuery = (GappedStructureAnnotatedSequence) logger.getLogObject(Consts.ALIGNED_QUERY);
            //GappedStructureAnnotatedSequence alignedHomolog = (GappedStructureAnnotatedSequence) logger.getLogObject(Consts.ALIGNED_HOMOLOG);

            // temp solution
            Threading2D threading2D = new Threading2D();
            try
            {
                if (homologSequence != null)
                {
                    request.setAttribute("PDBName", homologSequence.getName());

                    int queryFirstNonGap = alignedQuery.firstNonGap();
                    int lastNonGap = alignedQuery.lastNonGap();
                    PDB = threading2D.getResult(homologSequence.getName(), queryFirstNonGap, lastNonGap);
                }
                else
                    PDB = threading2D.getResult();  // default for testing
            }
            catch (FileNotFoundException e)
            {
                ViewPDBAction.logger.warn(e.getMessage());
                session.setAttribute("error", e.getMessage());

                try {
                    PDB = threading2D.getResult();
                }
                catch ( FileNotFoundException e1)
                {
                    logger.warn(e1.getMessage());
                    session.setAttribute("error", e1.getMessage());
                }
            }

            session.setAttribute("PDB", PDB);
        }
        else
        {
            Threading2D threading2D = new Threading2D();
            PDB = threading2D.getResult("1K9JA", 0, 1000);
            session.setAttribute("PDB", PDB);
        }

        return forward;
    }

}
