package ca.ualberta.proteus.web;

import ca.ualberta.proteus.db.model.WebHitEntity;
import ca.ualberta.proteus.db.model.WebHitIntf;
import ca.ualberta.proteus.web.db.SQLWebHitCounter;
import org.biojava.bio.seq.Sequence;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.HashMap;

/**
 * (C) Zigtag Inc. 2007
 * <p/>
 * User: scott
 * Date: May 21, 2007
 * Time: 12:00:41 PM
 */
public abstract class WebHitCounter
{
    static WebHitCounter instance;

    public static WebHitCounter getInstance()
    {
        if (instance == null)
        {
            instance = new SQLWebHitCounter();
        }
        

        return instance;
    }

    public static class WebHit implements WebHitIntf
    {
        private String address;
        private String email;
        private String remoteAddr;
        private String userAgent;
        private WebHitEntity.Type type;
        private String sequence;
        private String ID;
        private Date date;
        private String proteusID;

        public String getAddress()
        {
            return address;
        }

        public void setAddress(String address)
        {
            this.address = address;
        }

        public String getEmail()
        {
            return email;
        }

        public void setEmail(String email)
        {
            this.email = email;
        }

        public String getRemoteAddr()
        {
            return remoteAddr;
        }

        public void setRemoteAddr(String remoteAddr)
        {
            this.remoteAddr = remoteAddr;
        }

        public String getUserAgent()
        {
            return userAgent;
        }

        public void setUserAgent(String userAgent)
        {
            this.userAgent = userAgent;
        }

        public WebHitEntity.Type getType()
        {
            return type;
        }

        public void setType(WebHitEntity.Type type)
        {
            this.type = type;
        }

        public String getSequence()
        {
            return sequence;
        }

        public void setSequence(String sequence)
        {
            this.sequence = sequence;
        }

        public String getID()
        {
            return ID;
        }

        public void setID(String ID)
        {
            this.ID = ID;
        }

        public void setDate(Date date)
        {
            this.date = date;
        }

        public Date getDate()
        {
            return date;
        }

        public void setProteusID(String id)
        {
            this.proteusID = id;
        }

        public String getProteusID()
        {
            return proteusID;
        }
    }

    public abstract void logHit(HttpServletRequest request);

    public void logSubmission(HttpServletRequest request, Sequence sequence, String email, String ID)
    {
        logSubmission(request, sequence, email, ID, true);
    }

    public abstract void logSubmission(HttpServletRequest request, Sequence sequence, String email, String ID, boolean flush);

    public abstract void flush();

    public abstract int getNumHits();

    public abstract int getSubmissions();

    public abstract HashMap<Date, WebHit> getHits();
}
