package ca.ualberta.proteus.web;

import ca.ualberta.proteus.util.ProteusTools;
import ca.ualberta.proteus.util.XAlignRunner;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.biojava.bio.BioException;
import org.biojava.bio.seq.ProteinTools;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.impl.SimpleSequence;
import org.biojava.bio.seq.io.SymbolTokenization;
import org.biojava.bio.symbol.Alignment;
import org.biojava.bio.symbol.SimpleSymbolList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 11, 2005
 * Time: 5:09:22 PM
 * To change this template use File | Settings | File Templates.
 */
public class XAlignAction extends Action
{

    public ActionForward execute(ActionMapping actionMapping, ActionForm actionForm,
                                 HttpServletRequest request, HttpServletResponse response) throws IOException, ClassNotFoundException, BioException
    {
        XAlignForm xAlignForm = (XAlignForm) actionForm;
        String sequenceList = xAlignForm.getSequenceList();

        System.out.println("Running XAlign Web Interface...");

        XAlignRunner runner = new XAlignRunner(null, readFastaList(sequenceList));
        runner.setUseCache(false);
        runner.setAddToDB(false);
        runner.setKeepOutput( true );
        runner.run();

        Alignment alignment = runner.getAlignment();

        for (Iterator it = alignment.symbolListIterator(); it.hasNext();)
        {
            Sequence seq = (Sequence) it.next();
            System.out.println(seq.getName() + ": " + seq.seqString());
        }
        request.setAttribute("xalign", runner);
        return actionMapping.findForward("success");
    }

    private List<Sequence> readFastaList(String sequenceList) throws BioException, IOException
    {
        ArrayList<Sequence> result = new ArrayList<Sequence>();
        BufferedReader reader = new BufferedReader(new StringReader(sequenceList));
        SymbolTokenization tokenizer = ProteinTools.getAlphabet().getTokenization("token");

        String line = null;
        while (true) {
            if ( line == null )
                line = reader.readLine();

            if ( line != null )
                line = line.replaceAll("\\s+", "");
            else
                // is it still null?  Means EOF...
                break;

            String header = "";
            StringBuilder sequenceStr = new StringBuilder();
            if (line != null && line.startsWith(">"))
                header = line.substring(1);
            else
                sequenceStr.append(line);

            while ((line = reader.readLine()) != null)
            {
                if (line.contains(">"))
                    break;
                sequenceStr.append(line);
            }

            String seqStr = ProteusTools.cleanSequence(sequenceStr.toString());

            SimpleSymbolList newList = new SimpleSymbolList(tokenizer, seqStr);
            Sequence sequence = new SimpleSequence(newList, "", header, null);
            result.add(sequence);
        }

        return result;
    }

}
