package ca.ualberta.proteus.web.db.test;

import ca.ualberta.proteus.db.model.WebHitEntity;
import ca.ualberta.proteus.db.model.WebHitIntf;
import ca.ualberta.proteus.web.WebHitCounter;
import ca.ualberta.proteus.web.db.SQLWebHitCounter;
import junit.framework.TestCase;

import java.sql.SQLException;
import java.util.Date;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Sep 19, 2009
 * Time: 11:53:27 PM
 * To change this template use File | Settings | File Templates.
 */
public class SQLWebHitCounterTest extends TestCase
{
    public void test1() throws SQLException
    {
        SQLWebHitCounter webHitCounter = new SQLWebHitCounter();

        int beforeSize = webHitCounter.getHits().size();

        WebHitCounter.WebHit hit = new WebHitCounter.WebHit();
        hit.setAddress("127.0.0.1");
        hit.setDate(new Date());
        WebHitEntity entity = webHitCounter.logHit(hit);

        assertEquals(beforeSize + 1, webHitCounter.getHits().size());

        // Clean up the database
        entity.getEntityManager().delete(entity);

        assertEquals(beforeSize, webHitCounter.getHits().size());
    }

    public void test2() throws SQLException
    {
        SQLWebHitCounter webHitCounter = new SQLWebHitCounter();

        int beforeSize = webHitCounter.getHits(WebHitIntf.Type.RESULT).size();

        WebHitCounter.WebHit hit = new WebHitCounter.WebHit();
        hit.setAddress("127.0.0.1");
        hit.setDate(new Date());
        hit.setType(WebHitIntf.Type.RESULT);
        WebHitEntity entity = webHitCounter.logHit(hit);

        assertEquals(beforeSize + 1, webHitCounter.getHits(WebHitIntf.Type.RESULT).size());

        // Clean up the database
        entity.getEntityManager().delete(entity);

        assertEquals(beforeSize, webHitCounter.getHits(WebHitIntf.Type.RESULT).size());
    }

    public void testSingle() throws SQLException
    {
        SQLWebHitCounter webHitCounter = new SQLWebHitCounter();

        WebHitCounter.WebHit hit = new WebHitCounter.WebHit();
        hit.setAddress("127.0.0.1");
        hit.setDate(new Date());
        hit.setType(WebHitIntf.Type.RESULT);
        WebHitEntity entity = webHitCounter.logHit(hit);

        assertEquals(entity.getID(), Integer.valueOf(webHitCounter.getHit(entity.getID()).getID()).intValue());

        // Clean up the database
        entity.getEntityManager().delete(entity);

    }


}
