package ca.ualberta.proteus.web.test;

import junit.framework.TestCase;
import ca.ualberta.proteus.web.DB4OWebHitCounter;
import ca.ualberta.proteus.web.WebHitCounter;
import ca.ualberta.proteus.program.transsec.Config;
import ca.ualberta.proteus.util.Consts;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: Feb 7, 2008
 * Time: 11:02:22 PM
 * To change this template use File | Settings | File Templates.
 */
public class DB4OWebHitTest extends TestCase
{
    public void test()
    {
        Config.getConfig().setStringValue(Consts.DATABASE_FILE, "test.db4o");

        /*Start cleared*/
        DB4OWebHitCounter counter = new DB4OWebHitCounter();
        counter.clear();

        /*Verify*/
        assertEquals(0, counter.getNumHits());

        /* Add a hit */
        WebHitCounter.WebHit hit = new WebHitCounter.WebHit();
        hit.setSequence("ABC");
        hit.setUserAgent("TEST");
        counter.logHit(hit);

        /*Verify*/
        assertEquals(1, counter.getNumHits());

        /*Clear it*/
        counter.clear();

        /*Verify*/
        assertEquals(0, counter.getNumHits());

        /*Add 3 more*/
        counter.logHit(hit);
        counter.logHit(hit);
        counter.logHit(hit);

        /*Verify*/
        assertEquals(3, counter.getNumHits());
        assertEquals(3, counter.getHits().size());

        /* Load it up from disk - it should be the exact same since it's persisted to disk*/

        DB4OWebHitCounter counter2 = new DB4OWebHitCounter();
        assertEquals(3, counter2.getNumHits());
        assertEquals(3, counter2.getHits().size());

        /*Clear it*/
        counter.clear();

        /*Verify in another instance if it's persisted*/
        counter2 = new DB4OWebHitCounter();
        assertEquals(0, counter2.getNumHits());
    }
}
