package ca.ualberta.proteus.web.test;

import ca.ualberta.proteus.util.io.SeqSeeDB;
import ca.ualberta.proteus.web.PersistentProteusResultStorage;
import ca.ualberta.proteus.program.ProteusImpl;
import ca.ualberta.proteus.logging.RuntimeCatalog;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.db.IllegalIDException;

import java.io.File;
import java.io.IOException;

public class PersistentStorageTest extends TestCase {
    public static Test suite() {
        return new TestSuite(PersistentStorageTest.class);
    }

    public static void main(String[] args) {
        new junit.textui.TestRunner().doRun(suite());
    }

    public void testStorageRestore() throws IllegalIDException, IOException, ClassNotFoundException {
        SeqSeeDB db = SeqSeeDB.getInstance();
        Sequence sequence = db.getSequence("1D3YB");

        ProteusImpl proteus = new ProteusImpl(sequence);
        proteus.getLogger().log("Start");
        proteus.getLogger().logObject("Sequence", sequence);

        File storageDirectory = new File("temp");
        if ( ! storageDirectory.exists() )
            storageDirectory.mkdir();
        PersistentProteusResultStorage.store("1", proteus.getLogger(), storageDirectory);

        RuntimeCatalog newLogger = PersistentProteusResultStorage.restore("1", storageDirectory);
        assert( newLogger.getLogObject("Sequence") != null );
        assert( newLogger.getLogBuffer().length() > 0);
    }

}
