#!/usr/bin/perl
# Program name: gen_dis_angle.pl
# Purpose:      Create an angle constraint and distance constraint file"
# To execute:   perl gen_dis_angle.pl <pdbfile> <path_name>


$num=@ARGV;
if($num<2){
    #print "Usage:perl  gen_dis_angle.pl PDBfile output\n";
    print "Usage:perl  gen_dis_angle.pl PDBfile pathname\n";
    exit(0);
    
 }
 
$basedir = $ARGV[1];
$output_file = $basedir.'output';
#printf("output_file = %s\n",$output_file);

open(infile,$ARGV[0]);
@data=<infile>;
close(infile);

#$acfile=$ARGV[1].'.ac';    
#$dcfile=$ARGV[1].'_caon.dc';
#$thriftydc=$ARGV[1].'_thrifty.dc';
#$phipsi=$ARGV[0].'.phipsi';
 
$acfile=$output_file.'.ac';
$thriftydc = $output_file.'.dc';
$phipsi=$output_file.'.phipsi';

#printf("acfile = %s\n", $acfile); 

system("/usr/local/bin/phipsi -f $ARGV[0] -o $phipsi");
open( infile, "$phipsi");
@angle=<infile>;
close(infile);
 
#$diff = 15.0;
$diff = 5.00;


#printf("Num of lines = %d\n",$#angle);

open(output,">$acfile");
for ($i=0;$i<=$#angle;$i++){
    
    if($angle[$i]=~/^\s\d+\s+/){
	
        @temps=split(/\s+/,$angle[$i]);
	if($temps[6] eq "NA"){
	    $temps[6]=360.0;
	}
	if($temps[5]<160 && $temps[5]>-160){
	    
	    print "Warning, Omega angle < 160\n";
	}
	if($temps[3]==360.0) { 
	    #printf output "$temps[2]   $temps[1]   0.00   0.00   %6.3f   %6.3f  $temps[5] $temps[5]  $temps[6]  $temps[6] \n",  $temps[4]-3, $temps[4]+3;
	    printf output "$temps[2]   $temps[1]   0.00   0.00   %6.3f   %6.3f  $temps[5] $temps[5]  $temps[6]  $temps[6] \n",  $temps[4]-$diff, $temps[4]+$diff;
        }
	elsif($temps[4]==360.0) { 
	    #printf output "$temps[2]   $temps[1]   %6.3f   %6.3f   0.00  0.00  $temps[5] $temps[5]  $temps[6]  $temps[6] \n", $temps[3]-3, $temps[3]+3;
	    printf output "$temps[2]   $temps[1]   %6.3f   %6.3f   0.00  0.00  $temps[5] $temps[5]  $temps[6]  $temps[6] \n", $temps[3]-$diff, $temps[3]+$diff;
	}
	else {
	    #printf output "$temps[2]   $temps[1]   %6.2f   %6.2f   %6.2f %6.2f  $temps[5] $temps[5]  $temps[6]  $temps[6] \n",$temps[3]-3, $temps[3]+3, $temps[4]-3,$temps[4]+3;
	    printf output "$temps[2]   $temps[1]   %6.3f   %6.3f   %6.3f %6.3f  $temps[5] $temps[5]  $temps[6]  $temps[6] \n",$temps[3]-$diff, $temps[3]+$diff, $temps[4]-$diff,$temps[4]+$diff;
	}
	$numres=$temps[1];
	
    }
}

close(output);

system("/usr/bin/perl /usr/local/bin/gen_distance_thrifty.pl $ARGV[0] $numres CA ON >$thriftydc");
#system("perl gen_distance.pl $ARGV[0] $numres CA ON OH CB CO> $dcfile");
#print "output files: $acfile, $dcfile, $thriftydc\n";
