#!/usr/bin/perl
require "PDB.pl";
###########################################
## Name: gen_distance.pl 
## Purpose: get the CA-CA, O-N, or O-H distance for each pair of residues
## Input: PDB file, Number of residues, at least one type of distance
## Output: stdout
## REQUIRE: PDB.pl
## Usage: perl gen_distance.pl pdbfile NumRes [CA] [OH] [ON] \n";
###########################################


if(@ARGV<2)
{
    print "Usage: perl gen_distance.pl pdbfile NumRes [CA] [OH] [ON] \n";
    exit(0);
}

%pdbdata=&readpdb($ARGV[0]);   
$numres=$ARGV[1];

$numarg=@ARGV;
#printf " The number of at=rguments is %d\n",$numarg;

$atoms='';
for($i=2;$i<$numarg;$i++)
{
    $atoms.= "$ARGV[$i],";
} 
$CA=0; $OH=0; $ON=0;
if($atoms=~/CA,/)
{ $CA=1;}
if($atoms=~/OH,/)
{ $OH=1;}
if($atoms=~/ON,/)
{ $ON=1;}
if($atoms=~/CG,/)
 {$CG=1;}
if($atoms=~/CB,/)
  {$CB=1;}
if($atoms=~/CO,/)
   {$CO=1; }
for ($i=1;$i<$numres;$i++)
{
    for ($j=$i+2;$j<$numres+1;$j++)
    {
        if($CA ==1)
	{
	    $dist=&caldistance($i,"CA", $j, "CA");
	    if($dist !=0){
		print "CA  $i   CA  $j   ", ($dist), "   ",  ($dist),"\n";
	    }
        }
	if($OH==1)
	{
	    $dist=&caldistance($i,"O", $j, "H");
	    if( $dist !=0){
		print "O   $i   H   $j   $dist  $dist\n";
	    }
            $dist=&caldistance($i,"H", $j, "O");
            if( $dist !=0){
                print "H   $i   O   $j   $dist  $dist\n";
            }

	}
        if($ON==1)
	{
	    $dist=&caldistance($i,"O", $j, "N");
	    if($dist!=0){
		print "O   $i   N   $j   $dist  $dist\n";
	    }
            $dist=&caldistance($i,"N", $j, "O");
            if($dist!=0){
                print "N   $i   O   $j   $dist  $dist\n";
            }

	}
       if($CG==1)
       {
            $dist=&caldistance($i,"CG", $j, "CA");
            if($dist !=0&& $dist<6){
                print "CG   $i   CA   $j   $dist  $dist\n";
            }
                       $dist=&caldistance($i,"CA", $j, "CG");
            if($dist !=0&& $dist<6){
                print "CA   $i   CG   $j   $dist  $dist\n";
            }
            $dist=&caldistance($i,"CB", $j, "CG");
            if($dist !=0 && $dist<6 ){
                print "CB   $i   CG   $j   $dist  $dist\n";
            }
            $dist=&caldistance($i,"CG", $j, "CB");
            if($dist !=0 && $dist<6){
                print "CG   $i   CB   $j   $dist  $dist\n";
            }

       }
       if($CO==1)
       {
            $dist=&caldistance($i,"C", $j, "CA");
            if($dist !=0){
                print "C   $i   CA   $j   $dist  $dist\n";
            }
            $dist=&caldistance($i,"CA", $j, "C");
            if($dist !=0){
                print "CA   $i   C   $j   $dist  $dist\n";
            }

       }
      if($CB==1)
       {
            $dist=&caldistance($i,"CB", $j, "CB");
            if($dist !=0){
                print "CB   $i   CB   $j   $dist  $dist\n";
            }
       }


    }
}

sub caldistance
{
    $i=shift;
    $atomi=shift;
    $j=shift;
    $atomj=shift;
#   print " $i $pdbdata{$i}->{$atomi}->{x}, $pdbdata{$i}->{$atomi}->{y}, $pdbdata{$i}->{$atomi}->{z} "; 
#   print " $j $pdbdata{$j}->{$atomj}->{x}, $pdbdata{$j}->{$atomj}->{y}, $pdbdata{$j}->{$atomj}->{z} ";
    if(exists($pdbdata{$i}->{$atomi}) && exists($pdbdata{$j}->{$atomj})){
    $distx=($pdbdata{$i}->{$atomi}->{x}-$pdbdata{$j}->{$atomj}->{x});
    $distx*=$distx;
    $disty=($pdbdata{$i}->{$atomi}->{y}-$pdbdata{$j}->{$atomj}->{y});
    $disty*=$disty;
    $distz=($pdbdata{$i}->{$atomi}->{z}-$pdbdata{$j}->{$atomj}->{z});
    $distz*=$distz;
    $dist=sqrt($distx+$disty+$distz);
    $dist=~s/(\d+\.\d{4}).*/$1/;
    return $dist;
    }
   else { return 0;}
}
