#!/usr/bin/perl
require "/usr/local/bin/PDB.pl";
###########################################
## Name: gen_distance.pl 
## Purpose: get the CA-CA, O-N, or O-H distance for each pair of residues
## Input: PDB file, Number of residues, at least one type of distance
## Output: stdout
## REQUIRE: PDB.pl
## Usage: perl gen_distance.pl pdbfile NumRes [CA] [OH] [ON] \n";
###########################################


if(@ARGV<3)
{
    print "Usage: perl gen_distance_thrifty.pl pdbfile NumRes [CA] [OH] [ON] \n";
    exit(0);
}
if(!($ARGV[1]=~/\d+/))
 {
    print "Usage: perl gen_distance_thrifty.pl pdbfile NumRes [CA] [OH] [ON] \n";
    exit(0);
}  
  

%pdbdata=&readpdb($ARGV[0]);   
$numres=$ARGV[1];

$numarg=@ARGV;
$atoms='';
for($i=2;$i<$numarg;$i++)
{
    $atoms.= "$ARGV[$i],";
} 
$CA=0; $OH=0; $ON=0;
if($atoms=~/CA,/)
{ $CA=1;}
if($atoms=~/OH,/)
{ $OH=1;}
if($atoms=~/ON,/)
{ $ON=1;}


#Added by Raj on June 23, 2004
#for ($i=1;$i<$numres;$i++){
#    for ($j=$i+2;$j<$numres+1;$j++){
#	if($CA ==1){
#	    $dist=&caldistance($i,"CA", $j, "CA");
#	    print "CA  $i   CA  $j   ", ($dist-$dist*0.05), "   ",  ($dist+$dist*0.05),"\n";
#	}
#	if($OH==1){
#	    $dist=&caldistance($i,"O", $j, "H");
#	    	print "O   $i   H   $j   ",($dist-$dist*0.05), "   ",  ($dist+$dist*0.05),"\n";
#	}
#	if($ON==1){
#	    $dist=&caldistance($i,"O", $j, "N");
#	    	print "O   $i   N   $j   ",($dist-$dist*0.05), "   ",  ($dist+$dist*0.05),"\n";
#	}
#
#    }
#}


# Commented by Raj on Jun 23, 20004.
for ($i=1;$i<$numres;$i++){
    for ($j=$i+2;$j<$numres+1;$j++){
	if($CA ==1){
	    
	    $dist=&caldistance($i,"CA", $j, "CA");
	    if($dist>4){
		#print "CA  $i   CA  $j   ", ($dist-$dist*0.05), "   ",  ($dist+$dist*0.05),"\n";
		print "CA  $i   CA  $j    $dist    $dist\n";
	    }
	    #else {
	#	print "CA  $i   CA  $j   ", (4), "   ",  (8),"\n";
	 #   }
	}
	if($OH==1){
	    
	    $dist=&caldistance($i,"O", $j, "H");
	    if($dist<2.5){
		print "O   $i   H   $j   $dist  $dist\n";
	    }
	}
	if($ON==1){
	    
	    $dist=&caldistance($i,"O", $j, "N");
	    if($dist<3.5){
		print "O   $i   N   $j   $dist  $dist\n";
	    }
	}
	
    }
}

sub caldistance
{
    $i=shift;
    $atomi=shift;
    $j=shift;
    $atomj=shift;
#   print " $i $pdbdata{$i}->{$atomi}->{x}, $pdbdata{$i}->{$atomi}->{y}, $pdbdata{$i}->{$atomi}->{z} "; 
#   print " $j $pdbdata{$j}->{$atomj}->{x}, $pdbdata{$j}->{$atomj}->{y}, $pdbdata{$j}->{$atomj}->{z} ";
    
    $distx=($pdbdata{$i}->{$atomi}->{x}-$pdbdata{$j}->{$atomj}->{x});
    $distx*=$distx;
    $disty=($pdbdata{$i}->{$atomi}->{y}-$pdbdata{$j}->{$atomj}->{y});
    $disty*=$disty;
    $distz=($pdbdata{$i}->{$atomi}->{z}-$pdbdata{$j}->{$atomj}->{z});
    $distz*=$distz;
    $dist=sqrt($distx+$disty+$distz);
    $dist=~s/(\d+\.\d{3}).*/$1/;
    
    return $dist;
    
}
