#ifndef __SECSTRUCT_H__
#define __SECSTRUCT_H__

#include "main_shiftx.h"

#ifdef _WIN32
  #define isnan _isnan
#endif
  
#define HYDRO_H		0
#define  NH_BOND 0.86
#define  CNH     118.9

#define PYMOL_SS_COLOR_H "red"
#define PYMOL_SS_COLOR_B "yellow"
#define PYMOL_SS_COLOR_C "green"

// Function prototypes

long secondary_score_from_PDB_file(char *infile, char *target, long *inStruct, int *ssErrors, int print_SecStr,
		int print_SecStr_list, int output_PyMOL_files, char *base_PDB_filename, int *resCount);
long secondary_score(ResData *resDatas, int numRes, RESIDUE *Rz, char *target, int sec_str_is_assigned,
	long *inStruct, int *ssErrors, int *resCount);
void print_secondary_structure_info(RESIDUE *Rz, int rno, int print_SecStr,
		int print_SecStr_list, int output_PyMOL_files, char *base_PDB_filename);

#endif
