#ifndef __CREATE_CONSTRAINT_H__
#define __CREATE_CONSTRAINT_H__

#include "util.h"

# define AC_WRITE_FORMAT            "%-4s  %4d  %11.2f %11.2f %11.2f %11.2f %11.2f %11.2f %11.2f %11.2f\n" 
# define PHIPSI_LINE_READ_FORMAT    "%5d %3s %s %s  %s %s\n"


# define MAX_FILES           80
# define MAX_CHAINS          80

//# define TRUE                 1
//# define FALSE                0

# define MAX_LINE_LEN_CONS  512
# define MAX_ATOMS_CONS          5000 
//int MAX_ATOMS;           

# define MAX_ATOM_NO        100 /* Assumption that the max number of atoms
                                   that an user will input will be 100 */
# define MAX_RESD_NO        100 /* Same assumption as atoms*/
# define MAX_COL             10

# define USE_ALL_ATOMS        1
# define USE_CA_ATOMS         2
# define USE_BBONE_ATOMS      3
# define USE_SELECTED_ATOMS   4
# define USE_SELECTED_RESDS   5

#define BACK_BONE         "BB"
#define ALPHA_CARBON      "CA"
#define ALL_ATOMS         "ALL"
#define HEAVY_ATOMS       "HV"  // All atoms except Hydrogens..


#define ANGLE_DIFF         3.00  //The angles are changed by +- of their original values by this amount. 


typedef struct{
  char resd_name[4];
  int resd_num;
  //float phi,psi,omega,chi;
  char phi[12],psi[12],omega[12],chi[12];
}PHIPSI;

typedef struct{
  float x,y,z;
}POINT;

typedef struct {
  char whole_line[MAX_LINE_LEN_CONS];
  int pdb_atomno;
  //int pdb_resdno;
  char pdb_resdno[7]; // Nov 15
  char pdb_atom_name[6];
  char pdb_resd_name[5];
  float x,y,z;
  POINT pt;
  char portion_before_coord[MAX_LINE_LEN_CONS];
} PDB;

typedef struct{
  char *atom_name;
  char *whole_line;
}ATOM_LINE;


typedef struct{
  int num_of_atoms,num_of_bbatoms;
  int num_of_hvatoms;
  int num_of_caatoms;
  ATOM_LINE* atom_line;
}RESD;


typedef struct {
  PDB *pdb;
  RESD *rsd;
  int num_of_bbatoms,num_of_resds;
  int num_of_cas, num_of_atoms;
  int num_of_heavyatoms;
  int chain_num;
} CHAIN;
/*-- END GLOBAL VARIABLE --*/






#endif 
