/**********************************************************
 * Program     : preditor_parser.h	 
 * Purpose     : Header file for preditor_parser.c
 * Author      : Rajarshi Maiti
 * Contact     : rajarshi@cs.ualberta.ca
 * Created     : November 1, 2006
 * Compile     : make all 	 
 * Modified    :	
 * Modified by :	
 ***********************************************************/

#ifndef _PREDITOR_PARSER_H_
#define _PREDITOR_PARSER_H_

//#define MAX_BUFFER_LEN  256
//#define TRUE_P            1
//#define FALSE_P           0

#define PREDITOR_ANGLE_NA -666.0
	// Indicates that an angle is not available in a Preditor output file.

/* 
   Struct to store one line of preditor output. Also used to store info parsed from one line in a phipsi file.
*/
struct angle_info {
  int res_no;
  char res;
  double phi, psi, omega, chi;
  double phi_err, psi_err, chi_confidence;
};

typedef struct angle_info ANGLE_INFO;

/*
  Struct to store one line of the error file
*/
struct err_node{
  int res_no;
  float phi_err, psi_err, omega_err;
  char res;
  struct err_node* next;
};

typedef struct err_node ERR_NODE;

//void print_node(ANGLE_INFO *node);
//void print_list(ANGLE_INFO* head);
//void free_list(ANGLE_INFO *head);
//ANGLE_INFO* create_node(int res_no, char res, float phi, float psi, float omega, float chi);
int parse_preditor_output(char *infile, ANGLE_INFO **head);
ERR_NODE* create_err_node(int res_no, char res, float phi_err, float psi_err, float omega_err);
int parse_error_file(char *infile, ERR_NODE **head);

#endif

