#ifndef __READFILESHIFT_H_
#define __READFILESHIFT_H_

#include "main_shiftx.h"

/* Global variables. */

extern RESIDUE *Residues[];

extern MATRIX *experimental_chem_shifts;
extern int num_residues_expt_chem_shifts;
extern MATRIX *Predicted_Chem_Shifts[];
extern MATRIX *randomCoilShifts;

extern int *pred_aln;
extern int *expt_aln;
extern int aln_length;

/* Function prototypes. */

void read_query_seq(char *file, MATRIX **inputquery, int *seqlen);
char *create_csfile(char *input);
void print_shifts(MATRIX*, int);
void loadRandomCoilShifts();
void get_alignment_data(ResData *res, int numRes, MATRIX *expt_shifts, int num_resds_expt);
void subtract_random_coil_shifts(MATRIX *sh, MATRIX *rc, int num_resds);
float get_chem_shift_score_from_PDB_file(ResData *res, int numRes, char *PDB_filename, char *chem_shifts_filename, float *corr_coeffs);
float get_chem_shift_score(ResData *resDatas, int numRes, RESIDUE *shiftx_residues, MATRIX *pred_chem_shifts, float *corr_coeffs);

#endif
