#ifndef __SIMPRED_SHIFT_H_
#define __SIMPRED_SHIFT_H_

#include "pepmake.h"

/* A Note about how the shifts are read in readfileshifts.c()
   shifts[0] is HA
   shifts[1] is HN
   shifts[2] is N
   shifts[3] is CA
   shifts[4] is CB
   shifts[5] is CO
*/

#define SHIFTS_WRITE_FORMAT  "%-3d   %c   %-10.4f %-10.4f %-10.4f %-10.4f %-10.4f %-10.4f\n"
#define SHIFTS_HEADER        " NUM RES   HA     H       N        CA      CB       C\n"
#define SHIFTS_HEADER_BORDER " --- --- ------ ------ -------- ------- ------- --------\n"

#define RANDOM_COIL_SHIFTS   "random_coil_shifts.txt"


struct Score{
 float   sum;
 float   liab;
 float   phi;
 float   psi;
};
typedef struct Score SCORE;

struct num{
  int num;
  int num2; 
  float   liab2;
  float   liab;
  float   phi;
  float   psi;
};
typedef struct num NUM;

struct seq {
  int *shift_num;
  int len;
  char *title;
  char *pRes;
  char *sRes;
  float *shifts;
};
typedef struct seq SEQ_REC;

/*
 * Comments added by David Arndt, Feb 27, 2007.
 *
 * Stores the chemical shift values for a single residue.
 */
struct matrix{
  int num; // Residue number.
  char AA; // One-letter amino acid abbreviation.
  char struc; 
  float shifts[16];
	// Chemical shift values:
	//
	// index   shift type
	// =====   ==========
	//   0         HA
	//   1         HN
	//   2         N
	//   3         CA
	//   4         CB
	//   5         CO
};
typedef struct matrix MATRIX;

struct colum{
  char col[10][50];
};
typedef struct colum COLUM;

struct tripeptide {
  int num;
  float sum;
  float  score;
  char title[50];
  char pRes[3];
  float shifts[3][10];
  struct tripeptide *next;
};
typedef struct tripeptide TRIPEPTIDE;

#endif
