#ifndef CS_H
#define    CS_H

#ifndef MAIN_SHIFTX_H
#include "main_shiftx.h"
#endif

#define   N_HA    0
#define   N_HN    1
#define   N_N15   2
#define   N_CA    3
#define   N_CB    4
#define   N_CO    5

/*
 * Comments added by David Arndt, Feb 27, 2007.
 */
typedef struct CSHIFT
{
	char            type; // Single-letter amino acid abbreviation for the current residue.
	unsigned int    n; // Residue number.
	float           ca; // CA chemical shift value (Alpha 13C).
	float           cb; // CB chemical shift value (Beta 13C).
	float           ha; // HA chemical shift value (Alpha 1H).
	float           co; // CO chemical shift value (Carbonyl 13C).
	float           hn; // HN chemical shift value (Amide 1H).
	float           n15; // N chemical shift value (Amide 15N).
	float			hside[NHATOMS];
	float           hb;
	/* ADDNEW */
	struct CSHIFT   *next, *last;
		// Pointers to the next and previous CSHIFT structs, respectively, in a
		// doubly-linked list of CSHIFT structs.
} CSHIFT;

CSHIFT   *CreateCS( CSHIFT *cs );
CSHIFT   *CopyCS( CSHIFT *oldcs );
void     FreeCShifts( CSHIFT *cs );
CSHIFT   *FindCS( CSHIFT *cs, int n );
void     AddCShifts( CSHIFT *a, CSHIFT *b );
void     AddCShiftsHB( CSHIFT *a, CSHIFT *b );
void     AdjustCYS( CSHIFT *cs, CSHIFT *ss );
void ProcessCShifts(CSHIFT *cs);

#endif
