#ifndef DISPLAY_H

#ifndef CS_H
#include "cs.h"
#endif

/*
 * Comments added by David Arndt, Feb 27, 2007.
 */
typedef struct DISPLAY_DATA
{
  int     length; // The number of residues in the peptide.
  int     properties; // The number of properties associated with each residue.
  int     nucleus; // The type of chemical shift. One of N_HA, N_HN, N_N15, N_CA, N_CB, N_CO.
  int     fill;
  int     *num; // Array of ID numbers of each residue.
  char    *res; // Array of single-letter amino acid abbreviations.
  char    **label;
	// 2-D char array for labels appearing in the header. label[i] holds header label i.
  float   **cs; // 2-dimensional array of chemical shift values. cs[res_index][]
} DISPLAY_DATA;

DISPLAY_DATA  *CreateDisplayData( int len, int prop, int nuc );
void           display_selected_nucleus( DISPLAY_DATA *d );
void           FreeDisplayData( DISPLAY_DATA *d );
void           InitializeDisplayData( DISPLAY_DATA *d, CSHIFT *cs, char *label );
void           FillDisplayData( DISPLAY_DATA *d, CSHIFT *cs, char *label, int t );
void           FillDisplayDataHB( DISPLAY_DATA *d, CSHIFT *cs );
void           FillDisplayDataCYS( DISPLAY_DATA *d, CSHIFT *orig, CSHIFT *ss );
void           FillDisplayDataPRO( DISPLAY_DATA *d, RES *pro );
void           FillDisplayDataNN( DISPLAY_DATA *d );
void FillDisplayDataOPT( DISPLAY_DATA *d, CSHIFT *cs , CSHIFT *oldcs);

#define LABEL_SIZE  8
#define DISPLAY_H

#endif
