#ifndef  SSBOND_H

#ifndef  VECTOR_H
#include "vector.h"
#endif

typedef struct SSBOND
{
  int              resA;
  char			   insCodeA;	
  int              resB;
  char			   insCodeB;
  VECTOR           CA_A;
  VECTOR           SG_A;
  VECTOR           CA_B;
  VECTOR           SG_B;
  struct SSBOND   *next;
} SSBOND;

void  ReadSSPairs( FILE *fpt, SSBOND **ss, char useChain );
void     FreeSSBond( SSBOND  *ss );
void     ReadSSCoordinates( RESIDUE *r, SSBOND *bonds );
CSHIFT   *DiSulfideBonds( SSBOND *bonds );
typedef struct CYSres
{
     int res;
     float CA_var[3];
		// The suffix _var was added to this variable by David Arndt, here and in the function ReadSSPairs(),
		// to avoid conflicts with the CA constant defined in pepmake.h. Feb 27, 2007.
     float SG[3];
     char chain;
     
} CYSres;
#define SSBOND_H

#endif
