/*
 * Copyright Biotools Incorporated 2004
 *
 * Contains memory allocation functions that initialize memory when
 * allocating.
 */

#include <stdlib.h>
#include <string.h>

/*
 * Allocate memory and initialize it to all zeroes.
 * Return memory on success and NULL on failure.
 */
void *bti_malloc(size_t size)
{
  void *mem = NULL;
  void *rc = NULL;

  if ( size <= 0 )
    return NULL;

  mem = malloc(size);
  if (mem == NULL)
  {
    return NULL;
  }
  rc = memset(mem, 0, size);
  if (rc != mem)
  {
    return NULL;
  }
  return mem;
}


