
/*
	file:		print.c
	purpose:	print file for phipsi. 
*/

#include "phipsi.h"
#include <stdlib.h>

extern	char *get_date();


/*************************************************************/
/* Print info about this run. 
*/
void print_run(fp)
FILE *fp;
{

	fprintf(fp, "\n");
	fprintf(fp, "************************************************************\n");
	fprintf(fp, "\n");
	fprintf(fp, "   Program............: phipsi (version %s)\n", VERSION);
	fprintf(fp, "   Description........: Calculate Main-Chain Torsion Angles\n");
        char* date = get_date();
	fprintf(fp, "   Date...............: %s\n\n", date);
//        free(date);

	fprintf(fp, "\n");
	fprintf(fp, "************************************************************\n");
	fprintf(fp, "\n");

}	/* print_run */


/*************************************************************/
/* print one set of angles 
*/
void print_angles(phipsi, chi, resName, resNum)
float	phipsi[SIZE_PHIPSI_ARRAY];
float	chi;
char	*resName;
int 	resNum;
{
float	phi, psi, omega;

#define FIX180(a) ( a == -180 ? 180 : a )

	phi = FIX180(phipsi[0]);
	psi = FIX180(phipsi[1]); 
	omega = FIX180(phipsi[2]);

	if (chi != VOID)
		fprintf(outfp, "\n %-4d  %-4s  %6.1f  %6.1f  %6.1f  %6.1f", 
		resNum, resName, phi, psi, omega, chi);
	else
		fprintf(outfp, "\n %-4d  %-4s  %6.1f  %6.1f  %6.1f    999", 
		resNum, resName, phi, psi, omega);

}	/* print_angles */

