#include <stdlib.h>
#include "phipsi.h"

char	*read_pdb();
int		nextexp = 0;

/*************************************************************/
/* get rid of header on top of pdb file then write small
*  header to output file.
*/
int read_write_header()
{
char    fld1[MAX_LINE_LEN], line[MAX_LINE_LEN], firstchar;
int     done;

	done = FALSE;
	firstchar = getc(pdbfp);

	while ( (firstchar != EOF) && (!done) ) {

		switch (firstchar) {

			/* SOURCE field  - print to output */
			case 'S':   fscanf(pdbfp, "%s", fld1);
						if ( 0 != strcmp(fld1, "OURCE") )
							break;
						fgets(line, MAX_LINE_LEN-1, pdbfp);
						/*fprintf(outfp, "SOURCE: %s", line);*/
						break;

			/* HEADER field  - print to output */
			case 'H':   fscanf(pdbfp, "%s", fld1);
						if ( 0 != strcmp(fld1, "EADER") )
							break;
						fgets(line, MAX_LINE_LEN-1, pdbfp);
						/*fprintf(outfp, "HEADER: %s", line);*/
						break;

			/* COMPND field  - print to output */
			case 'C':   fscanf(pdbfp, "%s", fld1);
						if ( 0 != strcmp(fld1, "OMPND") )
							break;
						fgets(line, MAX_LINE_LEN-1, pdbfp);
						/*(fprintf(outfp, "COMPOUND: %s", line);*/
						break;

			/* ATOM found - stop reading header */
			case 'A' :  firstchar = getc(pdbfp);
						if (firstchar == 'T')
							done = TRUE;
						else
							fgets(line, MAX_LINE_LEN-1, pdbfp);
						break;

			default: fgets(line, MAX_LINE_LEN-1, pdbfp);

		}

		if (!done)
			firstchar = getc(pdbfp);
	}
	fprintf(outfp, "\n\n");
	rewind(pdbfp);
	return 1;
}   /* read_write_header */


/*************************************************************/
/* read one set of coordinates from archive file
*/
int read_atom(atom, atomCB, atomCOG)
ATOM_REC	*atom, *atomCB, *atomCOG;
{
int		ret;
char *line = NULL;

  line = read_pdb(pdbfp, atom, 0);
  ret = (line != NULL);
  while (ret) {
		if ( strcmp(atom->atomName, expatm[nextexp]) == 0 ) {
   	     	nextexp = (nextexp+1) % 3;
			break;
		}
		else if ( strcmp(atom->atomName, "CB") == 0 ) {
			atomCB->resNum = atom->resNum;	
			atomCB->x = atom->x;	
			atomCB->y = atom->y;	
			atomCB->z = atom->z;	
		}

		else if ( ( strcmp(atom->atomName, "CG") == 0 ) || 
		   ( strcmp(atom->atomName, "CG1") == 0 ) ||
		   ( strcmp(atom->atomName, "SG") == 0 ) ||
		   ( strcmp(atom->atomName, "OG") == 0 ) ||
		   ( strcmp(atom->atomName, "OG1") == 0 ) ) {
			atomCOG->resNum = atom->resNum;	
			atomCOG->x = atom->x;	
			atomCOG->y = atom->y;	
			atomCOG->z = atom->z;	
		}
    if (line != NULL)
    {
      free(line);
    }
    line = read_pdb(pdbfp, atom, 0);
    ret = (line != NULL);
	}
  if (line != NULL)
  {
    free(line);
  }
	return(ret);

}	/* read_atom */
