#include <stdio.h>
 #include <stdlib.h>
 #include <math.h>
 #include <string.h>
 #define PI 3.141592654
 #define MAX_LENGTH 300
 
 void vector( double [][1], double [][1], double [][1]);
 double normalize( double [][1]);
 void translate( double [][1], double [][1], double [][1]);            /*translates a point to another point*/
 void ReverseTranslate( double [][1], double [][1], double [][1]);
 void formTrans( double [][1], double [][1], double [][1]);            /* forms the translation matrix */
 void formReverseTrans( double [][1], double [][1], double [][1]);

 double dotProduct( double [][1], double [][1]);
 void form1by3( double [][1], double [][1]);
 void form3by1( double[][1], double[][1]);
 void Multiply( double [][1], double [][3],  double [][1],int ,int ,int );
 void Rot_X_clock( double [][1], double [][3]);
 void Rot_Z_clock( double [][1], double [][3]);
 void Rot_X_anticlock( double [][1], double [][3]);
 void Rot_Z_anticlock( double [][1], double [][3]);

 double alpha( double [][1]);
 double beta( double [][1]);
 double costheta( double[][1], double[][1]);
 double sintheta( double[][1], double[][1]);


 void printPoint( double[][1],int);
 void print3by1( double [][1]);
 void print3by3( double [][3]);

 void store(double [][3],FILE *);
 void main_function(double [][3],double [][3],FILE *,FILE *);


 /************************************************************************/
void vector( double pta[][1], double ptb[][1], double vectPtr[][1])
 {
  int i;
  for(i = 0; i < 3; i++)
   {
    vectPtr[i][0] = ptb[i][0] - pta[i][0];

   }
 }


 double normalize( double pt[][1])
  {
    double length = sqrt(pow(pt[0][0],2) + pow(pt[1][0],2) + pow(pt[2][0],2)) ;
   return length;
  }

void translate ( double pt[][1],  double tmatrix[][1],  double pointPtr[][1])
{
 int i;
 for(i=0; i < 3; i++)
  {
   pointPtr[i][0] = pt[i][0] + tmatrix[i][0];

   }
} 
  
void ReverseTranslate ( double pt[][1],  double anti_tmatrix[][1],  double pointPtr[][1])
{
 int i;
 for(i=0; i < 3; i++)
  {
   pointPtr[i][0] = pt[i][0] + anti_tmatrix[i][0];

   }
} 

void formTrans( double pta[][1], double ptb[][1], double nPtr[][1]) /* this function forms the translation matrix */
{
 int i;
 for(i = 0; i < 3; i++)
  {
   nPtr[i][0] = pta[i][0] - ptb[i][0];

  }
}

void formReverseTrans( double pta[][1], double ptb[][1], double nPtr[][1]) /* this function forms the translation matrix */
{
 int i;
 for(i = 0; i < 3; i++)
  {
   nPtr[i][0] = pta[i][0] + ptb[i][0];

  }
}

 double dotProduct( double u[][1], double v[][1])
 {
   double result;
   result = (u[0][0]*v[0][0] + u[1][0]*v[1][0] + u[2][0]*v[2][0]);
 return result;
 } 


 double costheta( double v1[][1], double v2[][1])
 {
   double product = dotProduct(v1,v2);
   double norm1 = normalize(v1);
   double norm2 = normalize(v2);
   double result = product/(norm1*norm2);
  return result;
 }


 double sintheta( double v1[][1], double v2[][1])
 {
   double  cos_theta = costheta(v1,v2);
   double result =  sqrt(1.00 - pow(cos_theta,2));
  return result;
 } 

 double alpha( double pt[][1])
{
  if(pt[0][0]==0.0 && pt[1][0]==0.0)
	  return(0.00);
  else
	{
   double tan_alpha = pt[1][0]/pt[0][0];
   double alpha_rad = atan(tan_alpha);
  return(alpha_rad);
	}
}

 double beta( double pt[][1])
{
  if(pt[1][0]==0.0 && pt[2][0]==0.0)
	  return(0.00);
  else
  {
   double tan_beta = pt[2][0]/pt[1][0];
   double beta_rad = atan(tan_beta);
  return(beta_rad);
  }
}


void form3by1( double pt[][1], double matrixpt[][1])
{
   int i;
   for (i = 0; i < 3; i++)
    {
     matrixpt[i][0] = pt[i][0];
    }
} 

void form1by3( double matrixpt[][1], double pt[][1])
{
   int i;
   for (i = 0; i < 3; i++)
    {
      pt[i][0] = matrixpt[i][0];
    }
} 

 

void printPoint( double pt[][1],int number) /* this function prints a point or a vector */
{
 int i;
 for (i = 0; i< number; i++)
  {
   printf("%lf",pt[i][0]);
   printf("\t");
  }
} 
 
 

void print3by1( double matrix[][1])  /*  this function prints a 3x1 matrix */
{
 int i;
 for(i = 0; i < 3; i++)
  {
   printf("%lf",matrix[i][0]);
   printf("\n");
  }
}



 void print3by3( double matrix[][3])  /*  this function prints a 3x3 matrix */
{
 int i,j;
 for(i = 0; i < 3; i++)
  {
   for(j = 0; j < 3; j++)
   {
    printf("%lf\t",matrix[i][j]);
   }
   printf("\n");
  }
} 
 

void Multiply( double pt[][1],  double matrix[][3],  double newpt[][1],int row,int column1,int column2)
{
 int i,j,k; 
 
 for (i = 0; i < row; i++)
   {
    for(j = 0; j < column2; j++)  
     {
       newpt[i][j] = 0;
       for(k = 0; k < column1; k++)
      newpt[i][j] = newpt[i][j] + matrix[i][k]*pt[k][j];
     }
   }
 
} 
 
void Rot_X_clock( double vect[][1], double xt[][3])
 {
   double angle = beta(vect);
 
  double x[3][3] = { {1,          0,          0 }, 
                    {0, cos(angle),  sin(angle)},                 
                    {0, -sin(angle), cos(angle)}}; 
                                        
                   
 
 int i,j;
 for (i = 0;i < 3; i++)
  {
    for (j = 0;j < 3; j++) 
     {
      xt[i][j] = x[i][j];
     } 
  }

 } 



void Rot_X_anticlock( double vect[][1], double xt[][3])
 {
    double angle = beta(vect);
 
  double x[3][3] = { {1,          0,          0  }, 
                     {0, cos(angle),  -sin(angle)},                 
                     {0, sin(angle), cos(angle)  }}; 
                                        
 int i,j;
 for (i = 0;i < 3; i++)
  {
    for (j = 0;j < 3; j++) 
     {
      xt[i][j] = x[i][j];
     } 
  }

 } 
 
 
 void Rot_Z_clock( double vect[][1], double zt[][3])
 {
    double angle = alpha(vect);
 
  double z[3][3] = { {cos(angle),    sin(angle), 0 }, 
                     {-sin(angle), cos(angle),  0 },
                     {0,         0,              1 }}; 
                                        
 int i,j;
 for (i = 0;i < 3; i++)
  {
    for (j = 0;j < 3; j++) 
     {
      zt[i][j] = z[i][j];
     } 
  }

 } 
 
 void Rot_Z_anticlock( double vect[][1], double zt[][3])
 {
    double angle = alpha(vect);
 
  double z[3][3] = { {cos(angle), -sin(angle), 0 }, 
                    {sin(angle), cos(angle),  0 },                 
                    {0,         0,            1 }}; 
                                        
                   
 
 int i,j;
 for (i = 0;i < 3; i++)
  {
    for (j = 0;j < 3; j++) 
     {
      zt[i][j] = z[i][j];
     } 
  }

 }
 
 void store(double array[3][3],FILE *inPtr)
{

 char *status;
 double value[3];
 
 int count;
 char line[300];
 int i = 0;int j;
 

 for( status = fgets(line,300, inPtr); 
      status != 0;
      status = fgets(line,300, inPtr))
  { 
   
    count = sscanf(line,"%lf%lf%lf",&value[0],&value[1],&value[2]);

        for(j=0;j<3;j++)
	{
	   array[i][j]=value[j];
	}
 i=i+1;   
  }

} 

 /***********************************************************************************************/
 /*****************                     MAIN FUNCTION               *****************************/
 /***********************************************************************************************/
 
 
void main_function(double abc_values[][3],double pqr_values[][3],FILE *inPtr,FILE *outPtr)
{
	double origin[3][1]={ {0},{0},{0}};
double a[3][1];               double b[3][1];          double c[3][1];
double at[3][1];              double bt[3][1];         double ct[3][1];
double p[3][1];               double q[3][1];          double r[3][1];             double point[3][1];
double pt[3][1];              double qt[3][1];         double rt[3][1];            double pointt[3][1];
double pRevt[3][1];           double qRevt[3][1];      double rRevt[3][1];      double pointRevt[3][1];

double v1[3][1];              double v2[3][1];         double v3[3][1];            double v4[3][1];
double v1t[3][1];	          double v2t[3][1];        double v3t[3][1];           double v4t[3][1];
double v1t_3x1[3][1];          double v2t_3x1[3][1];     double v3t_3x1[3][1];        double v4t_3x1[3][1];
double v1t_1x3[3][1];         double v2t_1x3[3][1];    double v3t_1x3[3][1];          double v4t_1x3[3][1];
double v1t_Rx[3][1];         double v2t_Rx[3][1];    double v3t_Rx[3][1];            double v4t_Rx[3][1];
  double v3t_newantiRx[3][1];     double v4t_newantiRx[3][1];
double v1t_Rz[3][1];          double v2t_Rz[3][1];    double v3t_Rz[3][1];           double v4t_Rz[3][1];
 double v3t_newantiRz[3][1];     double v4t_newantiRz[3][1];
 double v2t_TwiceRx[3][1]; double v3t_newantiRx_1x3[3][1]; double v4t_TwiceRx[3][1];
                                double v2t_final[3][1];  double v3t_new[3][1];            double v4t_final[3][1];
                                                            double v4t_newantiTwiceRx[3][1];
                                                       double v4t_newantiRx_1x3[3][1];
 double v4t_finalrotated_3x1[3][1];
   double v5[3][1];
											     double v5t[3][1];
											  
											     double v5t_3x1[3][1];

											     double v5t_1x3[3][1];
											     double v5t_Rx[3][1];
											     double v5t_newantiRx[3][1];
											     double v5t_Rz[3][1];
											     double v5t_newantiRz[3][1];
											     double v5t_TwiceRx[3][1];
											     double v5t_final[3][1];
											     double v5t_newantiTwiceRx[3][1];
											     double v5t_newantiRx_1x3[3][1];
											    
											     double v5t_finalrotated_3x1[3][1];
 
 
 											     
  double T_Matrix1[3][1];              double T_Matrix2[3][1];
  double Reverse_T_Matrix1[3][1];

  double Rx_clock1[3][3];	           double Rx_clock2[3][3];
  double Rx_anticlock1[3][3];
  double Rz_clock1[3][3];             double Rz_clock2[3][3];
  double Rz_anticlock1[3][3];
  double Rx_finalclock1[3][3];          double Rx_finalclock2[3][3];  
  double Rx_finalanticlock1[3][3];
  
  double Rot_Z_180clock[3][3] = {{-1.00, 0.00,  0.00 },
                                 {-0.00, -1.00, 0.00 },                 
                    		 { 0.00,  0.00, 1.00 }}; 
                                        
  

  double Rot_X_180clock[3][3] = { {1.00, 0.00, 0.00 },
                                  {0.00,-1.00, 0.00 },
                                  {0.00, 0.00,-1.00 }};




  double v3t_3x1_before[3][1];       
  double v3t_3x1_after[3][1];         
  double v3t_1x3_after[3][1];              double v4t_final_before[3][1];	 double v5t_final_before[3][1];
  					 double v4t_final_after[3][1];      double v5t_final_after[3][1];
                                         double v4t_final_after_1x3[3][1];     double v5t_final_after_1x3[3][1];
                                   double  v4t_final_after_180[3][1];     double  v5t_final_after_180[3][1];
                                              
  
  
  
 int i,j;
 char *status;
 int count;
 char line[300];
 int filecounter = 0;
 
 
  
  /*             COPYING THE VALUES OF POINTS A,B C, P,Q AND R   ******/
  for(i = 0;i < 3;i++)
  {
	   a[i][0] = abc_values[0][i];
           b[i][0] = abc_values[1][i];
           c[i][0] = abc_values[2][i];
   }

   for(i = 0;i < 3;i++)
  {
	   p[i][0] = pqr_values[0][i];
           q[i][0] = pqr_values[1][i];
           r[i][0] = pqr_values[2][i];
   }
   

   /************************************************************************************/
   
 

 
 vector(a,b,v1);	
 vector(a,c,v2);     /* forming the vectors ab and ac */
  
 formTrans(origin,a,T_Matrix1);         /* forming the translation matrix between a and the origin */
 formReverseTrans(origin,a,Reverse_T_Matrix1);
   

 translate(a, T_Matrix1, at);    /*  translating the three points, a b and c */
 translate(b, T_Matrix1, bt);  
 translate(c, T_Matrix1, ct);
 
 vector(at,bt,v1t);  
 vector(at,ct,v2t);     /* forming vectors with the translated points */
 form3by1(v1t , v1t_3x1);
 form3by1(v2t , v2t_3x1);   /* changing the vectors into 3 by 1 matrices  */
 

		 
		 /*************************** RX FOR FIRST VECTOR*******************************************************/
 Rot_X_clock(v1t,Rx_clock1);	      /* rotation matrix Rx(clockwise) for translated vector v1 */
 Rot_X_anticlock(v1t,Rx_anticlock1);  /* rotation matrix Rx(anticlockwise) for translated vector v1 */

 Multiply(v1t_3x1 , Rx_clock1 , v1t_Rx,3,3,1);    /*multiply matrix v1t with Rx  */

		 /************************** RZ FOR FIRST VECTOR*******************************************************/
 Rot_Z_clock(v1t_Rx,Rz_clock1);		  /*  rotation matrix Rz(clockwise) for translated vector v1  */
 Rot_Z_anticlock(v1t_Rx,Rz_anticlock1);  /* rotation matrix Rz(anticlockwise) for translated vector v1 */
 
 Multiply(v1t_Rx , Rz_clock1 ,v1t_Rz ,3,3,1);   /* multipling with Rz after v1t has been multiplied with Rx */
 
 form1by3(v1t_Rz,v1t_1x3);
/********************PRINTING POINTS***********************************/
	/* printf("printing v1 before the if block\n");
	printPoint(v1t_1x3,3);printf("\n"); */

 /**************************************************************************************************************************/ 
                         /****** PERFORMING ROTATIONS ON TRANSLATED VECTOR V2T   ******/
 
 Multiply(v2t_3x1 , Rx_clock1 , v2t_Rx,3,3,1);  /* multiplying matrix v2t with Rx */
 Multiply(v2t_Rx, Rz_clock1 , v2t_Rz,3,3,1);  /* multiplying matrix v2t with Rz */
	form1by3(v2t_Rz,v2t_1x3);   /* forming a vector after both the multiplications are done */
 
 Rot_X_clock(v2t_1x3,Rx_finalclock1);	/* Rx_finalclock1 is the rotation matrix for vector v2 to bring it onto the xy plane*/
 Rot_X_anticlock(v2t_1x3,Rx_finalanticlock1);
 
Multiply(v2t_Rz , Rx_finalclock1 , v2t_TwiceRx,3,3,1);  
	form1by3(v2t_TwiceRx,v2t_final);      /* v2t_final lies on the xy plane and is the final form of vector v2  */
 /********************PRINTING POINTS***********************************/
	/* printf("printing v2 before the if block\n");
	printPoint(v2t_final,3);printf("\n"); */


/***************************************************************************************************************************/
/******************************************** SECOND SET OF POINTS**********************************************************/
/***********************************************THIRD VECTOR****************************************************************/

 vector(p,q,v3);
 vector(p,r,v4);     /* forming the vectors pq and pr  */



 formTrans(origin,p,T_Matrix2);   /* forming the translation matrix between p and the origin */

 translate(p, T_Matrix2, pt);    /* translating the three points, p b and c */
 translate(q, T_Matrix2, qt);
 translate(r, T_Matrix2, rt);

 
 
 vector(pt,qt,v3t);
 vector(pt,rt,v4t);         /* forming vectors with the translated points */

 form3by1(v3t , v3t_3x1);
 form3by1(v4t , v4t_3x1);   /*changing the vectors into 3 by 1 matrices */


 /*************************** RX FOR THIRD VECTOR*******************************************************/
 Rot_X_clock(v3t,Rx_clock2);	          /*rotation matrix Rx(clockwise) for translated vector v3 */
 Multiply(v3t_3x1 , Rx_clock2 , v3t_Rx,3,3,1);    /*multiply matrix v3t with Rx */



 /******************** RZ FOR THIRD VECTOR***************************/
 Rot_Z_clock(v3t_Rx,Rz_clock2);		         /* rotation matrix Rz(clockwise) for translated vector v3 */

 Multiply(v3t_Rx , Rz_clock2 ,v3t_Rz ,3,3,1);    /*multipling with Rz after v3t has been multiplied with Rx */

 form1by3(v3t_Rz,v3t_1x3);
        form3by1(v3t_1x3,v3t_3x1_before);
   /* printf("printing v3 before the if block\n");
	printPoint(v3t_1x3,3);printf("\n"); */
			/**************** FOURTH VECTOR***************************/
          /********************** PERFORMING ROTATIONS ON TRANSLATED VECTOR V4T   *******************/

 Multiply(v4t_3x1 , Rx_clock2 , v4t_Rx,3,3,1);  /* multiplying matrix v4t with Rx */

 Multiply(v4t_Rx , Rz_clock2 ,v4t_Rz ,3,3,1);  /* multiplying Rz with v4t after it has been multiplied by Rx */
	form1by3(v4t_Rz,v4t_1x3);           /* forming a vector after both the multiplications are done*/



 Rot_X_clock(v4t_1x3,Rx_finalclock2);	/* Rx_finalclock2 is the rotation matrix for vector v4 to bring it onto the xy plane*/


 
 Multiply(v4t_Rz, Rx_finalclock2 , v4t_TwiceRx,3,3,1);


form1by3(v4t_TwiceRx,v4t_final);      /* v4t_final lies on the xy plane and is the final form of vector v4 */
            form3by1(v4t_final,v4t_final_before);
 /* printf("printing v4 before the if block\n");
	printPoint(v4t_final,3);printf("\n");   */

  


  if ((v1t_1x3[0][0]*v3t_1x3[0][0]) < 0.000 && (v2t_final[0][0]*v4t_final[0][0]) < 0.000 )
		   {
	                Multiply(v3t_3x1_before,Rot_Z_180clock,v3t_3x1_after,3,3,1);
	                Multiply(v4t_final_before,Rot_Z_180clock,v4t_final_after,3,3,1);






				 if((v1t_1x3[0][0]*v3t_3x1_after[0][0]) > 0.00 && (v2t_final[1][0]*v4t_final_after[1][0]) < 0.00)
			 		{

                                         Multiply(v4t_final_after,Rot_X_180clock,v4t_final_after_180,3,3,1);
                                        /*v4t_final_after_180[0][0] = v4t_final_after[0][0];
		        	        v4t_final_after_180[1][0] = - v4t_final_after[1][0];
		  			v4t_final_after_180[2][0] = v4t_final_after[2][0]; */

					form1by3(v3t_3x1_after,v3t_1x3_after);	form1by3(v4t_final_after_180,v4t_final_after_1x3);
                                       /*  printf("printing v3 and v4 in the second if block\n");
                                         printPoint(v3t_1x3_after,3);printf("\n");  printPoint(v4t_final_after_1x3,3);printf("\n");  */
                                        }
			else
                        {
		 	form1by3(v3t_3x1_after,v3t_1x3_after);	form1by3(v4t_final_after,v4t_final_after_1x3);
                    /*    printf("printing v3 and v4 in the first else block\n");
                        printPoint(v3t_1x3_after,3);printf("\n");  printPoint(v4t_final_after_1x3,3);printf("\n"); */
		        }
                   }
	  else       /***  second else if block  ***/
 		if((v1t_1x3[0][0]*v3t_1x3[0][0]) < 0.00 && (v2t_final[1][0]*v4t_final[1][0]) < 0.00)
		{
		Multiply(v3t_3x1_before,Rot_Z_180clock,v3t_3x1_after,3,3,1);
	        Multiply(v4t_final_before,Rot_Z_180clock,v4t_final_after,3,3,1);
		form1by3(v3t_3x1_after,v3t_1x3_after);	form1by3(v4t_final_after,v4t_final_after_1x3);

              /*   printf(" printing v3 and v4 after the flip\n");
			 printPoint(v3t_1x3_after,3);printf("\n");
	        printPoint(v4t_final_after_1x3,3);printf("\n"); */
				}
                     /** third if block **/
 	else
	if( (v1t_1x3[0][0]*v3t_1x3[0][0]) > 0.00 && (v2t_final[1][0]*v4t_final[1][0]) < 0.00 )
		{

                 Multiply(v4t_final_before,Rot_X_180clock,v4t_final_after,3,3,1);
                 /* v4t_final_after[0][0] = v4t_final[0][0];
		  v4t_final_after[1][0] = - v4t_final[1][0];
		  v4t_final_after[2][0] = v4t_final[2][0];  */
		  form1by3(v3t_1x3,v3t_1x3_after);  form1by3(v4t_final_after,v4t_final_after_1x3);
		/* printf("printing v3 and v4 in the third if block\n");
		 printPoint(v3t_1x3_after,3);printf("\n");
		 printPoint(v4t_final_after_1x3,3);printf("\n"); */
		}

                      /** fourth if block **/
         else
	if( (v1t_1x3[0][0]*v3t_1x3[0][0]) > 0.00 && (v2t_final[0][0]*v4t_final[0][0]) < 0.00 && (v2t_final[1][0]*v4t_final[1][0]) < 0.00 )
		{

                 Multiply(v4t_final_before,Rot_X_180clock,v4t_final_after,3,3,1);
                 /* v4t_final_after[0][0] = v4t_final[0][0];
		  v4t_final_after[1][0] = - v4t_final[1][0];
		  v4t_final_after[2][0] = v4t_final[2][0]; */
		  form1by3(v3t_1x3,v3t_1x3_after);  form1by3(v4t_final_after,v4t_final_after_1x3);
		/* printf("printing v3 and v4 in the fourth if block\n");
		 printPoint(v3t_1x3_after,3);printf("\n");
		 printPoint(v4t_final_after_1x3,3);printf("\n"); */
		}


                                    /** fifth if block **/
                 else
		  if( (v1t_1x3[0][0]*v3t_1x3[0][0]) < 0.00 && (v2t_final[1][0]*v4t_final[1][0]) > 0.00 )
		  {
			  Multiply(v3t_3x1_before,Rot_Z_180clock,v3t_3x1_after,3,3,1);
	                  Multiply(v4t_final_before,Rot_Z_180clock,v4t_final_after,3,3,1);
		          form1by3(v3t_3x1_after,v3t_1x3_after);	form1by3(v4t_final_after,v4t_final_after_1x3);
                      /*    printf("printing v3 and v4 in the fifth if block\n");
                          printPoint(v3t_1x3_after,3);printf("\n");  printPoint(v4t_final_after_1x3,3);printf("\n");   */
                   }
    else
	   {
	   	form1by3(v3t_3x1_before,v3t_1x3_after);	form1by3(v4t_final_before,v4t_final_after_1x3);
             /*  printf("printing v3 and v4 in the last else block\n");
               printPoint(v3t_1x3_after,3);printf("\n");  printPoint(v4t_final_after_1x3,3);printf("\n");*/
           }







 /************************************** PROCESSING POINT  P  *******************************************************/
ReverseTranslate(pt, Reverse_T_Matrix1, pRevt);


 /************************************** PROCESSING POINT Q    ****************************************************/
form3by1(v3t_1x3_after,v3t_new);
Multiply(v3t_new , Rz_anticlock1 , v3t_newantiRz,3,3,1);

Multiply(v3t_newantiRz , Rx_anticlock1 , v3t_newantiRx,3,3,1);
form1by3(v3t_newantiRx , v3t_newantiRx_1x3);

		ReverseTranslate(v3t_newantiRx_1x3, Reverse_T_Matrix1, qRevt);




 /******************************* PROCESSING POINT R **************************************/
 form3by1(v4t_final_after_1x3,v4t_finalrotated_3x1);
 Multiply(v4t_finalrotated_3x1 , Rx_finalanticlock1 , v4t_newantiTwiceRx,3,3,1); /* MULTIPLYING POINT R BY THE antiRX MATRIX */
 Multiply(v4t_newantiTwiceRx , Rz_anticlock1 , v4t_newantiRz,3,3,1);     /* MULTIPLYING POINT R BY THE antiRZ MATRIX */

 Multiply(v4t_newantiRz , Rx_anticlock1 , v4t_newantiRx,3,3,1);         /*THE THIRD ROTATION IS ANTI CLOCKWISE ABOUT THE X AXIS  */
	                      form1by3(v4t_newantiRx , v4t_newantiRx_1x3);

ReverseTranslate(v4t_newantiRx_1x3, Reverse_T_Matrix1, rRevt); /*THE FINAL OPERATION IS TRANSLATION BY THE TRANSLATION MATRIX */







                            /************** STEPS TO MODIFY ANY ARBITRARY POINT ******************/
 /******************* CODE TO OPEN A FILE,MODIFY EACH POINT AND WRITE THE MODIFIED VALUES TO ANOTHER FILE ********************/




 	for( status = fgets(line,300, inPtr);
      		status != 0;
      		status = fgets(line,300, inPtr))
	{

    count = sscanf(line,"%lf%lf%lf",&point[0][0],&point[1][0],&point[2][0]);
    vector(p,point,v5);

 	translate(point, T_Matrix2, pointt);
        vector(pt,pointt,v5t);
	form3by1(v5t , v5t_3x1);

 	Multiply(v5t_3x1 , Rx_clock2 , v5t_Rx,3,3,1);  /* multiplying matrix v5t with Rx */

	Multiply(v5t_Rx , Rz_clock2 ,v5t_Rz ,3,3,1);  /* multiplying Rz with v5t after it has been multiplied by Rx */

	form1by3(v5t_Rz,v5t_1x3);           /* forming a vector after both the multiplications are done*/

 	Multiply(v5t_Rz , Rx_finalclock2 , v5t_TwiceRx,3,3,1);

	form1by3(v5t_TwiceRx,v5t_final);      /* v5t_final lies on the xy plane and is the final form of vector v5t */
        form3by1(v5t_final,v5t_final_before);




         /* CHANGING THE PROCEDURE FOR V5 VALUES........ */

  if((v3t_1x3[0][0]*v3t_1x3_after[0][0]) < 0.00 && (v4t_final[0][0]*v4t_final_after_1x3[0][0]) < 0.00 && (v4t_final[1][0]*v4t_final_after_1x3[1][0]) < 0.00 )
	 {
	  Multiply(v5t_final_before,Rot_Z_180clock,v5t_final_after,3,3,1);
          form1by3(v5t_final_after,v5t_final_after_1x3);

         }

   else
   if((v3t_1x3[0][0]*v3t_1x3_after[0][0]) < 0.00 && (v4t_final[0][0]*v4t_final_after_1x3[0][0]) < 0.00 && (v4t_final[1][0]*v4t_final_after_1x3[1][0]) > 0.00 )
			 {
                                Multiply(v5t_final_before,Rot_Z_180clock,v5t_final_after,3,3,1);
                                Multiply(v5t_final_after,Rot_X_180clock,v5t_final_after_180,3,3,1);

                                /*v5t_final_after_180[0][0] = -v5t_final_before[0][0];
		                v5t_final_after_180[1][0] =  v5t_final_before[1][0];
		  		v5t_final_after_180[2][0] = -v5t_final_before[2][0]; */

				form1by3(v5t_final_after_180,v5t_final_after_1x3);

                        }


       else
 	 if((v3t_1x3[0][0]*v3t_1x3_after[0][0]) > 0.00 && (v4t_final[1][0]*v4t_final_after_1x3[1][0]) < 0.00)
		{

                 Multiply(v5t_final_before,Rot_X_180clock,v5t_final_after_180,3,3,1);
                /* v5t_final_after_180[0][0] =  v5t_final_before[0][0];
	         v5t_final_after_180[1][0] = -v5t_final_before[1][0];
		 v5t_final_after_180[2][0] = -v5t_final_before[2][0];  */

                 form1by3(v5t_final_after_180,v5t_final_after_1x3);


		}

        else
	{
	   form1by3(v5t_final_before,v5t_final_after_1x3);

        }



                 form3by1(v5t_final_after_1x3,v5t_finalrotated_3x1);

        Multiply(v5t_finalrotated_3x1,Rx_finalanticlock1,v5t_newantiTwiceRx,3,3,1);/*MULTIPLYING ARBITRARY POINT BY THE RX MATRIX */

	Multiply(v5t_newantiTwiceRx , Rz_anticlock1 , v5t_newantiRz,3,3,1); /*MULTIPLYING ARBITRARY POINT  BY THE RZ MATRIX  */

	Multiply(v5t_newantiRz , Rx_anticlock1 , v5t_newantiRx,3,3,1);  /* THE THIRD ROTATION IS ANTI CLOCKWISE ABOUT THE X AXIS */
	                      form1by3(v5t_newantiRx , v5t_newantiRx_1x3);

      ReverseTranslate(v5t_newantiRx_1x3,Reverse_T_Matrix1,pointRevt);/*THE FINAL OPERATION IS TRANSLATION BY THE TRANSLATION MATRIX */
 /* printf("Printing the final values\n");
	  printPoint(pointRevt,3);printf("\n");*/

      /*	fprintf (outPtr,"%-3s %-3s %-3s",atom,acid,residueNum);*/
		for(j=0;j<3;j++)
			{
			fprintf(outPtr,"%7.3lf ",pointRevt[j][0]);
			if(j==2)
				{
				fprintf(outPtr,"\n");
				}
			}
 	filecounter=filecounter+1;
	}

}







/***************** MAIN PROGRAM BEGINS FROM HERE *************************/

int superimpose(char abcfile[],char pqrfile[],char inputfile[],char outputfile[])
{
	FILE *firstfileinPtr,  *secondfileinPtr;
	FILE *thirdfileinPtr,  *fourthfileoutPtr;
 double firstvalues[3][3];
 double secondvalues[3][3];





  /* Open file where the A,B and C values are stored  */
  firstfileinPtr = fopen(abcfile, "r");
  if (firstfileinPtr == NULL) {
    fprintf(stderr, "Bad first file name\n");
    exit(-1);
  }
 store(firstvalues,firstfileinPtr);                    /* Store the values of A, B and C in firstvalues     */
             fclose(firstfileinPtr);


  /* Open the file where the P,Q and R values are stored */
  secondfileinPtr = fopen(pqrfile, "r");
  if (secondfileinPtr == NULL) {
    fprintf(stderr, "Bad second file name\n");
    exit(-1);
  }

    store(secondvalues,secondfileinPtr);                /* Store the values of P,Q and R in secondvalues      */
                          fclose(secondfileinPtr);

  /*thirdfileinPtr = fopen("ASPpts.txt","r");  */
  thirdfileinPtr = fopen(inputfile, "r");
  if (thirdfileinPtr == NULL) {
	  fprintf(stderr, "Bad third file name\n");
	exit(-1);
  }


  /* fourthfileoutPtr = fopen("ASProtd.txt","w");  */
 fourthfileoutPtr = fopen(outputfile, "w");
  if (fourthfileoutPtr == NULL) {
	  fprintf(stderr, "Can't create output file\n");
	exit(-1);
  }


 main_function(firstvalues,secondvalues,thirdfileinPtr,fourthfileoutPtr);



 fclose(thirdfileinPtr);
 fclose(fourthfileoutPtr);
    
   
  return(0);
 }



