#ifndef __PEPMAKE_H__
#define __PEPMAKE_H__

#include "vec3D.h"
#include "pdbfile.h"

#define USE_OMEGA 1
#define USE_SIDECHAINS 1
#define MAX_ATOMS 30

typedef struct ResData {
  int badcontact;
  double phi, psi, omega, chi;
  int id;
  int numAtoms;
  Vec3D atoms[MAX_ATOMS];
  char names[MAX_ATOMS][4];
  Vec3D template[MAX_ATOMS];
  char resName[4];
} ResData;

/* names of the atoms in each template position */
extern char *atomNames[6];

#define CA	0
#define C1	1
#define O	2
#define N	3
#define CA2	4
#define H	5
#define CB	6
#define CG      7 


int countResidues(char *fname);
void buildPeptide(ResData *residues, int numRes);
void readGAfolderAngles(ResData *residues, int n);
void readAngles(char *fname, ResData *residues, int n);
void printPDBAtoms(FILE *out, ResData *residues, int numRes);
void initResData(ResData *r);
void OutofPlane( Vec3D aa, Vec3D bb, Vec3D cc, double Wmag, double theta1,double theta2, Vec3D W);

void buildFinalPeptide(ResData *residues, int numRes) ; //For checking phi-psi discrepancies between running pepmake standalone and in "minimize"


#endif 
