
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <strings.h>
#include "simplex.h"

#include "util.h"
#include "pepmake.h" 
#include "ga_util.h" 
#include "vec3D.h"
#include "phipsi.h"


/* GLOBAL VARIABLES */
int ndim;
int mpts;
int nfunk = 0;  /* I think this is equal to the number of function evaluations that has been done */
float ftol;
float *y;
float **p;
float *psum;
float smallestDiff = 100000000;
Res_Dis *actualDis;
 
char rdcFile[10];
RDC *targetRDC;
float* rdcValueArray;
int* rdcIndexArray;
int rdcSize;
char** resArray;
int* resNoArray;

int delete = 1;
int fin_initSimplex = FALSE;
float SEQLENGTH;
float orig_phi[1000], orig_psi[1000];
/*float phi_diff[1000], psi_diff[1000];*/



//float DESIRED_DISTANCE = 13.563;
float DEG_OF_VAR = 10.00;
float GUESS = 6.00;


float des_CN_dist = 0.00;    //13.56;
float des_CA_CA_dist = 0.00; //11.45;
float des_NC_dist = 0.00;    //11.44; 

/*--------------------------------------------------------
 * Prints program usage information.
 *-------------------------------------------------------*/
void usage_simplex (void) {
  printf("USAGE: ./minimize <pdbfile>\n");

} /* END usage () */





/*********************************************************************/
/*WHAT IS THE PURPOSE OF PSUM???*/
void get_psum() {
  int i, j;
  float sum = 0;
  for(j = 0; j<ndim; j++) {
    sum = 0.0;
    for(i = 0; i<mpts; i++) {
      sum += p[i][j];
    }
    psum[j] = sum;
  }
}/* END get_psum */




/**********************************************************************/
void minSearch() {
  int i;
  float tempArray[ndim];
  float result;
  
  
  amoeba();
  
  for(i = 0; i<ndim; i++) {
    tempArray[i] = p[0][i];
    //printf("angle %d) = %f\n", i, tempArray[i]); 
  }
  
  result = function(tempArray);
  //printf("result = %f\n", result);
  
}/* END minSearch */


#if 0
/**********************************************************************/
/*needs to be modified later on*/
void rotate_simplex(double alpha, double beta, double gama) {
  char line[MAX_LINE];
  char command[MAX_LINE];

  
  char line1[30]; /*WHY 30*/
  FILE *readfptr, *outfptr;
  double cosA = cos(alpha);
  double cosB = cos(beta);
  double cosG = cos(gama);
  double sinA = sin(alpha);
  double sinB = sin(beta);
  double sinG = sin(gama);
  double rotMat[] = { ( cosG*cosB - cosB*sinA*sinG), ( cosG*sinA + cosB*cosA*sinG), (sinG*sinB), 
		      (-sinG*cosA - cosB*sinA*cosG), (-sinG*sinA + cosB*cosA*cosG), (cosG*sinB),
		      (sinB*sinA), (-sinB*cosA), (cosB)};
  POINT tempP;
  
  PDB_LINE pl;
  readfptr = fopen(PEPRESULTFILE, "r");
  if(readfptr == NULL) {
    printf("Cannot open the file %s\n", PEPRESULTFILE);
    exit(1);
  }
  
  outfptr = fopen("blah", "w");
  if(outfptr == NULL) {
    printf("Cannot open the file blah\n");
    exit(1);
  }
  
  while(fgets(line, MAX_LINE, readfptr)!= 0) {
    if(strcmp(line, NEWLINE)==0) continue; /*skip blank lines*/
    read_pdb_line(line, &pl);
    strncpy(line1, line, 26);
    line1[26]='\0';
    
    tempP = matrixMult(rotMat, pl.pt);
    pl.pt = tempP;
    printPDB(pl, line1, outfptr);
    
  }/* END while */
  
  fclose(readfptr);
  fclose(outfptr);
  
 /* char command[MAX_LINE]; */
  sprintf(command, "mv blah %s", PEPRESULTFILE);
  system(command);

 }/* END rotate_simplex() */
#endif
 
 
 
 
/*********************************************************************/
POINT matrixMult(double r[], POINT pt) {
  POINT a;
  float x, y, z;
  x = pt.x;
  y = pt.y;
  z = pt.z;
  a.x = x *r[0] + y*r[1] + z*r[2];
  a.y = r[3] * x + r[4] * y + r[5] * z;
  a.z = r[6] * x + r[7] * y + r[8] * z;
  return a;
}/* END matrixMult() */


//***********************************************
float check_phipsi_boundary(float angle){
  if(angle < -180.00)return(angle+360.00); 
  if(angle > 180.00 && angle != 360.00)return(angle-360.00);
  if(angle <= 180.00 && angle >= -180.00)return(angle);
  if(angle == 360.00)return(angle);
  return 0.0;
}//**************************************************




/*********************************************************************/
float function(float input[]) {
  
  
  FILE *fp_output;
  int i, j, length;
  float sum,phi, psi;
  
  float C_Ndist = 0.00;
  
  POINT first_C, last_N;
  POINT first_CA, last_CA;
  POINT first_N, last_C;  

  
  float scoring_func_for_phi, scoring_func_for_psi;
  
  scoring_func_for_phi =  scoring_func_for_psi = 0.00;
  float CA_CA_dist=0.00, N_C_dist=0.00;
  float new_phi, new_psi;
  
  ResData *seed;

   
  /* testing
  for(i = 0; i<ndim; i++) {
    printf("input %d) = %f\n", i, input[i]);
  }
  */
	/* TOPEPFILE = toPepFile.txt 
	   topepfile.txt is the input file to pepmake*/	  
  //outfptr = fopen(TOPEPFILE, "w"); 
  //if(!outfptr){printf("%s cannot be opened for writing\n",TOPEPFILE);exit(EXIT_FAILURE);}
  
  i=j=0;
  length = ndim/2;
  
  //printf("length = %d\n",length);
  seed = (ResData*)malloc(length*sizeof(ResData));
  if(!seed){printf("Cannot malloc seed. Exiting..\n");exit(-1);}

  //for(i=0;i<length;i++){
  //printf("input[%d]=%f\n",j,input[j++]);
  //}
  //exit(-1);

  /* Creating the topepfile.txt here */
  /* TOPEPFILE = toPepFile.txt --> a file containing the residues and the phi psi angle values.*/
  for(i = 0; i<length; i++) {
    phi = input[j++];
    psi = input[j++];
    //printf("phi = %f, psi = %f\n",phi,psi);
    new_phi = check_phipsi_boundary(phi);
    new_psi = check_phipsi_boundary(psi);
   
    //fprintf(outfptr, PEP_WRITE_FORMAT, resNoArray[i], resArray[i], new_phi, new_psi);

    //Initialise the seed;
    seed[i].id = resNoArray[i]; 
    strncpy(seed[i].resName, resArray[i],4);

    seed[i].phi = new_phi;
    seed[i].psi = new_psi;
    seed[i].omega = DEFAULT_OMEGA;
    seed[i].chi = DEFAULT_CHI;
    seed[i].numAtoms = 7;
    seed[i].badcontact = 0;
    //printf("id=%d,resname=%s,phi=%4.3f,psi=%4.3f,omega=%4.3f,chi=%4.3f\n", seed[i].id,seed[i].resName,seed[i].phi,seed[i].psi,seed[i].omega,seed[i].chi); 
  }
  
  //exit(-1);
  //fclose(outfptr);
  
  //printf("delete = %d and fin_initSimplex = %d\n\n",delete, fin_initSimplex);
  delete++;
  
  // usePep is in pepmake.c
  // PEPRESULTFILE = "pepResultFile.txt -- This is where the output is written into 
  // Initialise the residue data and call pepmake to create the pdb file.
  readGAfolderAngles(seed, length); // in pepmake.c
  for (i=0; i<length; i++) {
    seed[i].numAtoms = 7; 
  }		
  initResData(&seed[0]); // in pepmake.c
  buildPeptide(seed, length); // in pepmake.c
  
  fp_output = fopen(PEPRESULTFILE,"w");
  if(!fp_output){printf("Cannot open %s for writing.Exiting..\n ",PEPRESULTFILE);exit(-1);}
  printPDBAtoms(fp_output, seed, length);  // in pepmake.c
  //printPDBAtoms(stdout, seed, length); 
  fclose(fp_output);
  //exit(-1);
  free(seed);
  //  usePep(TOPEPFILE, PEPRESULTFILE); 
  
  
  i = 0;
  sum = 0.00;
  
  
  /**************************************************************************************/
  /* Without penalizing the distance */
  /*---------------------------------*/
  C_Ndist =  assign_pts(PEPRESULTFILE,  &first_C, &last_N, "CN");
  CA_CA_dist = assign_pts(PEPRESULTFILE, &first_CA, &last_CA, "CACA");
  N_C_dist = assign_pts(PEPRESULTFILE, &first_N, &last_C, "NC");
  //printf("C_Ndist = %-4.3f, CA-CA = %-4.3f, N-C =%-4.3f\n",C_Ndist,CA_CA_dist, N_C_dist);
  
  //exit(-1);
  sum  = sum + fabs(des_CN_dist - C_Ndist);
  //sum = sum + fabs(des_CA_CA_dist - CA_CA_dist);
  //sum = sum + fabs(des_NC_dist - N_C_dist); 
  //sum = sum + fabs( DESIRED_DISTANCE - C_Ndist);  
  /*************************************************************************************/
     



     /*****************************************************************************/
     /* Old code to add penalties */

     /* Checking to see if the phi-psi angles are going out of their bounds. 
	The phi angle can range from -20deg to -180deg
	The psi angle can range from -180 to 180deg 
	If the phi-psi angles go out of bounds, then we 'penalise' (ie increase) the distance.*/
     
     /* Assumption is that phi is > -20 and < 0.00. Some phi angles can be > 0.00, shall we ignore those?  */
     /* Also assuming that the psi angles  will be between -180 and 180.If the psi angle is 360 or >, then shall we ignore those?? */
     /*
       j=0;
       
       for(i = 0; i<length; i++){
       phi = input[j++];
       psi = input[j++];
       printf("phi = %f, psi = %f\n", phi, psi); 
       
       if(phi < -180.00){
       phi_diff = fabs(phi -(-180.00) );
       printf("\t phi =  %f and phi_diff = %f\n",phi, phi_diff);
       }
       
       if(phi > -20.00 && phi < 0.00 ){
       phi_diff = fabs(phi - (-20.00) );
       printf("\t phi = %f and phi_diff = %f\n",phi, phi_diff);
       }
       if(psi < -180.00){
       psi_diff = fabs(psi - (-180.00) );
       printf("\t psi = %f and psi_diff = %f\n",psi, psi_diff);
       }
       if(psi > 180.00 && psi < 360.00){
       psi_diff = fabs(psi - 180.00);
       printf("\t psi = %f and psi_diff = %f\n",psi, psi_diff);
       }
       
       
       sqrt_of_sum_of_differences+=sqrt( pow(phi_diff,2.00) + pow(psi_diff,2.00) );
       
       phi_diff=0.00;psi_diff=0.00;
       
       }
       
       
       C_Ndist = assign_pts(PEPRESULTFILE,  &first_C, &last_N);
       pen_CNdist = C_Ndist + sqrt_of_sum_of_differences;
       sum = sum + fabs( DESIRED_DISTANCE - pen_CNdist); 
     */
     /*  printf("C_Ndist = %f\t",C_Ndist); */
     /*  printf("pen CNdist = %f\n\n", pen_CNdist);*/
     
     /**************************************************************************************/  
     
     
     /**************************************************************************************/
     /* New code to add penalties:
        The Rule for adding penalties is as follows:
	We allow the phi-psi angles to vary by DEG_OF_VAR.
	For each calculated phipsi value,we do the following 
	[{phi(orig) - phi(calc)} - DEG_OF_VAR]^2 and [{psi(orig) - psi(calc)} - DEG_OF_VAR]^2.
	We keep on accumulating this sum for all the sets of phi psi values and then add(1/seqlength)*sum to our distance.*/
#if 0     
       j=0;
       k=0;
     
     if(fin_initSimplex == TRUE){

	phi_diff = (float*)malloc(SEQLENGTH*sizeof(float));
	if(!phi_diff){
		 printf("Memory allocation failed for phi_diff\n"); exit(EXIT_FAILURE);}

	psi_diff = (float*)malloc(SEQLENGTH*sizeof(float));
	if(!psi_diff){
		 printf("Memory allocation failed for psi_diff\n"); exit(EXIT_FAILURE);}

       
       for(k=0; k<SEQLENGTH; k++){
   
	 phi_calc = input[j++];                         psi_calc = input[j++];
	 
	 phi_diff[k] = orig_phi[k] - phi_calc;          psi_diff[k] = orig_psi[k] - psi_calc;
	 
	 //printf("phi_diff[%d] = %f - %f = %f\t and ",k, orig_phi[k], phi_calc, phi_diff[k]);
	 // printf("psi_diff[%d] = %f - %f = %f\n",k, orig_psi[k], psi_calc, psi_diff[k]);
       }
         
       /* Evaluating the scoring function */
     
       for(k=1; k<SEQLENGTH; k++){
       scoring_func_for_phi += pow( (phi_diff[k] - DEG_OF_VAR),2.00 ); 
	 /* scoring_func_for_phi += pow( phi_diff[k],2.00 );*/
          }
       
       for(k=0; k<SEQLENGTH-1; k++){
       scoring_func_for_psi += pow( (psi_diff[k] - DEG_OF_VAR),2.00 ); 
	 /* scoring_func_for_psi += pow( psi_diff[k] ,2.00 ); */
         }
       
       //printf("scoring_func_for_phi = %f\n",scoring_func_for_phi);
       //printf("scoring_func_for_psi = %f\n",scoring_func_for_psi); 
       
       penalty = (sqrt(scoring_func_for_phi) + sqrt(scoring_func_for_psi) )/SEQLENGTH;
       //printf("penalty = %f\n", penalty);

       C_Ndist =  assign_pts(PEPRESULTFILE, &first_C, &last_N); 
       pen_CNdist = C_Ndist + penalty;
       sum = fabs( DESIRED_DISTANCE - pen_CNdist ); 

       printf("C_Ndist = %f\n",C_Ndist);
       printf("pen CNdist = %f\n\n", pen_CNdist);
      
       free(phi_diff); free(psi_diff);
     }   
#endif     	      
	    
     /* free(phi_diff);  free(psi_diff);*/ 

      /*****************************************************************************************/


     //printf("sum = %f\n", sum);

      return (sum);
      
}/* END function() */




/*******************************************************************/
void amoeba() {
  
  int ilo, ihi, inhi;
  float ytry, ysave,rtol;
  int i, j;
  get_psum();
 
       for(;;){
	       ilo = 0;
	       if(y[0]>y[1]){
		       ihi = 1;
		       inhi = 2;
		       }
		       else{
			       ihi = 2;
			       inhi = 1;
		       }
		       
			    
             for(i = 0; i<mpts; i++){
		     if (y[i] < y[ilo]){
			ilo = i;
			}
			else if(y[i] > y[ihi]){
				inhi = ihi;
				ihi = i;
				}
				else if(y[i] > y[inhi]){
					if (i != ihi) {
						inhi = i;
					}
				}
			}/* end for() */
	
      
    
    /*printf("%d, %d\n", ihi, ilo);*/
    rtol = 2.0*fabs(y[ihi]-y[ilo])/ (fabs(y[ihi]) + fabs(y[ilo]));
    /*printf("%f\n", rtol);*/
    
        if(rtol < ftol) {
		/*printf("hi");*/
		break;
		}
		if(nfunk >= NMAX) {
		  //printf("Too many iterations in ameoba\n");
			return;
			/*exit(1);*/
			}
			
    /*ytry = amotry(ihi, -A);*/
    amotry(ihi, -A, &ytry);
    
         if(ytry <= y[ilo]) {
		 amotry(ihi, G, &ytry);
		 }
		 else if (ytry >= y[inhi]) {
			 ysave = y[ihi];
			 amotry(ihi, B, &ytry);
			 
			 if(ytry >= ysave) {
				 for (i = 0; i<mpts; i++) {
					 
					 if( i!= ilo) {
						 for (j = 0; j < ndim; j++) {
							 psum[j] = 0.5 * (p[i][j] + p[ilo][j]);
							 p[i][j] = psum[j];
							 }/* end for() */
							 
							 y[i] = function(psum);
						 }
					 }/* end for(i = 0; i<mpts; i++) */
					 
			nfunk += ndim;
			get_psum();
			/*get_psum(p, psum);*/
			
		}/*end if(ytry >= ysave) */
		
	   }/* end else if (ytry >= y[inhi])*/
	
    }/*end for(;;)*/

}/***** END amoeba()  *******/	
      


/******************************************************************************/
void amotry(int ihi, float fac, float *result) {
	
	float fac1, fac2, ytry;
	float ptry[ndim];
	int j;
	
	fac1 = (1-fac)/ndim;
	fac2 = fac1-fac;
  
	      for(j = 0; j<ndim; j++) {
		      ptry[j] = psum[j]*fac1-p[ihi][j]*fac2;
		      }
		      
                ytry = function(ptry);
               /*function(ptry, result);*/
               nfunk++;
  
	       if(ytry < y[ihi]) {
		       y[ihi] = ytry;
    
		       for(j = 0; j<ndim; j++) {
			       psum[j] += ptry[j] - p[ihi][j];
			       p[ihi][j] = ptry[j];
		       }
	       }
    
	       *result = ytry;
 }/* end amotry */
 
 
 
 
/*********************************************************************************/
/* DISTANCE TESTING */
void readDistance() {
  FILE *infptr;
  char line[300];
  int resNo, i;
  float distance;
  
  infptr = fopen("distanceFile.txt", "r");
  if(infptr == NULL) {
    printf("Cannot open the file distanceFile.txt\n");
    exit(1);
  }
  i = 0;
  while(fgets(line, 300, infptr)!= NULL) {
    sscanf(line, "%d %f", &resNo, &distance);
    actualDis[i].resNo = resNo;
    actualDis[i].distance = distance;
    i++;
  }
  
  fclose(infptr);
}

/* end distance testing */



/**********************************************************************************
 * prepareMin stores the phi psi angles in phi[] and psi[] arrays *
 *********************************************************************************/ 
void prepareMin(float phi[], float psi[], float omega[],float chi[],int length) {
  
  FILE *infptr;
  char line[MAX_LINE];
  int status, i,res_no;
  /*char resName[1];*/
  //  float omega[length];
  char res_name[4];


  infptr = fopen(PHIPSIFILE, "r");
  if(infptr == NULL){printf("Error! Cannot open file: %s\n", PHIPSIFILE);exit(-1);}
  
  i = 0;
  
  while(fgets(line, MAX_LINE, infptr) != NULL){
    //printf("%s", line);
    
    if(strcmp(line, NEWLINE) == 0) {continue;}/* skip blank lines */
    status = sscanf(line, PHIPSI_READ_FORMAT, &res_no, res_name, &phi[i], &psi[i], &omega[i], &chi[i]);
    resNoArray[i]=res_no;
    strncpy(resArray[i],res_name,4);
    //printf("%d %s %f %f %f %f\n",res_no,res_name,phi[i],psi[i],omega[i],chi[i]);
    if(status != 6){printf("Invalid format in the phipsi result file\n");exit(1);}
    
    i++;
    
  }/* end while */
  
  
  fclose(infptr);
  /* testing
     for(i = 0; i<length; i++) {
     printf("%d) phi = %f, psi = %f\n", i, phi[i], psi[i]);
     }
     end testing */
  
}/* END preparemin() */
/*******************************************************************************/






/**********************************************************************/
void initSimplex(int length) {
  
  float phi[length], psi[length], omega[length],chi[length];
  int i, j;
  float *temp;
  
  /* WHAT WILL THE GUESS BE? */
  /* Used a guess value of 10 when running the program without penalising the distance */
  /*  float guess = 10.0; */
  
  /* Now we want to restrict the phi, psi values to be within +- 10 degrees
     of their initial value,so we are limiting the guess to 2 degrees */  
  
  
  
  /* to store the name of the residue */
  resArray = (char**)malloc(length*sizeof(char*)); 
  if(!resArray){printf("Memory allocation failed for resArray\n"); exit(EXIT_FAILURE);}
  
  resNoArray = (int*)malloc(length*sizeof(int));
  if(!resNoArray){printf("Memory allocation failed for resNoArray\n"); exit(EXIT_FAILURE);}
  
  for(i=0;i<length;i++){
    resArray[i] = (char*)malloc(4*sizeof(char));
  }  


  
  /*------------------------------------------*/
  prepareMin(phi, psi, omega, chi, length);
  //exit(-1);
  
  
  /*testing*/
  for(i = 0; i<length; i++) {
    // printf("init %d) phi = %f, psi = %f\n", i, phi[i], psi[i]);
    orig_phi[i] = phi[i];
    orig_psi[i] = psi[i];
  }
  /*end testing */
  //printf("finished preparemin\n");
  
  ndim = length*2; /*2 unknowns for each residue*/
  
  mpts = ndim + 1;
  ftol= 3*pow(10.0, -10.0); /* ftolerance */
  /*	 printf("ftol = %f\n", ftol); */
  
  
  
  y = (float*)malloc(sizeof(float)*mpts);
  if(!y){printf("Memory allocation failed for y\n"); exit(EXIT_FAILURE);}
  
  p = (float**)malloc(sizeof(float*)*mpts);
  if(!p){printf("Memory allocation failed for p\n"); exit(EXIT_FAILURE);}
  
  for(i = 0; i<mpts; i++) {
    p[i] = (float*)malloc(sizeof(float)*ndim);
  }
  psum = (float*)malloc(sizeof(float)*ndim);
  if(!psum){printf("Memory allocation failed for psum\n"); exit(EXIT_FAILURE);}
  
  
  /*initialize the last point*/
  j = 0;
  i = 0;
  while(i<ndim){
    //printf("phi[%d]=%f, psi[%d]=%f\n",j,phi[j],j,psi[j]);
    p[ndim][i++] = phi[j];
    p[ndim][i++] = psi[j];
    //p[ndim][i++] = omega[j];
    //p[ndim][i++] = chi[j];
    j++;
  }
  
  /* testing 
     for(i=0; i<ndim; i++) {
     printf("last point angle p[%d][%d] = %f\n", ndim,i, p[ndim][i]);
     }
  */
  
  /*initialize the rest of the points and adding the guess value */
  for(i = 0; i<ndim; i++) {
    for(j = 0; j<ndim; j++) {
      if(i == j){
	p[i][j] = p[ndim][j] + GUESS;  
	//printf("p[%d][%d] = %f\n",i,j,p[i][j]);
      }
      else {
	p[i][j] = p[ndim][j];
      }
    }
  }
  /*
    printf("\nPrinting the  matrix p\n");
    printf("--------------------------------\n");
    for(i=0; i<ndim; i++){
    for(j=0; j<ndim; j++){
    printf("%6.2f  ",p[i][j]);
    }
    printf("\n");
    }
  */	
  
  
  
  /* float temp[ndim];*/
  temp = (float*)malloc(ndim*sizeof(float) );
  if(!temp){printf("Memory for temp could not be allocated\n");exit(EXIT_FAILURE);}
  
  /* Storing the values of p in temp 
     y[ndim+1] is also an input vector whose components must be pre initialized
     to the values of function evaluated at the ndim + 1 vertices(rows)of p
  */ 
  
  
  
  /*----------------------------------------------------------------------------*/
  /* IMPT:  function gets called here */
  for(i = 0; i<mpts; i++){
    for(j = 0; j<ndim; j++){
      temp[j] = p[i][j];
      //printf("temp[%d] = %f\n",j,temp[j]);
    }
    y[i] = function(temp); 
  }
  //exit(-1);
  /*
    for(i = 0; i<mpts; i++){
    for(h = 0; h<ndim; h++){
    printf("->%d), temp[%d] = %f\n", i, h, temp[h]);
    }
    printf("\n");
    }
  */
  
}/* END initSimplex */




/******************************************************************************************/
void cleanup() {
  int i;
  //free(resArray);
  free(rdcValueArray);
  free(rdcIndexArray);
  //free(resNoArray);
  free(targetRDC);
  free(y);
  
  for(i = 0; i<mpts; i++) {
    free(p[i]);
  }
  free(p);
  free(psum);
  
}/*END cleanup **************************************************************************************/





//*****************************************************************************
int get_first_and_last_fist_resd_duplicate(char* file, int* first_resd, int* last_resd){
  
  FILE *fpr;
  char buffer[MAX_LINE_LEN]; 
  int *resd_arr,resdnum,resd_count = 1;
  char atom_name[6];  
  int *num_atoms_in_each_resd,atom_count = 1;
  

  fpr = fopen(file,"r");
  if(!fpr){printf("Cannot open %s for reading.\n",file);exit(-1);}

  resd_arr =(int*)malloc(1*sizeof(int));
  if(!resd_arr){printf("Cannot malloc for resd_arr..Exiting\n");exit(-1);}
  resd_arr[0] = -1000;
  
  num_atoms_in_each_resd = (int*)malloc(1*sizeof(int));
  if(!num_atoms_in_each_resd){printf("Cannot malloc for num_atoms_in_each_resdr..Exiting\n");exit(-1);}
  num_atoms_in_each_resd[0] = 0;
  
  while(fgets(buffer, MAX_LINE_LEN, fpr)!= NULL){
    if(strncmp(buffer, "ATOM", 4) == 0){
      sscanf(&buffer[22],"%4d",&resdnum);
      sscanf(&buffer[11],"%5s",atom_name);

      if(resdnum != resd_arr[resd_count-1]){
	resd_arr = (int*)realloc( (int*)resd_arr,(resd_count+1)*sizeof(int) );
	if(!resd_arr){printf("Cannot realloc resd_arr..exiting\n");exit(-1);}
	resd_arr[resd_count] = resdnum;
	
	atom_count=0;
	num_atoms_in_each_resd = (int*)realloc( (int*)num_atoms_in_each_resd,(resd_count+1)*sizeof(int) );
	if(!num_atoms_in_each_resd){printf("Cannot realloc num_atoms_in_each_resd..exiting\n");exit(-1);}
        atom_count++;
	num_atoms_in_each_resd[resd_count] = atom_count;
	
	//printf("resdnum = %d and resd_arr[%d]=%d,num-atoms[%d]=%d\n",resdnum,resd_count,resd_arr[resd_count],resd_count,atom_count);
	resd_count++;
	//atom_count = 0;
      }else{
	
	atom_count++;
	num_atoms_in_each_resd[resd_count-1] = atom_count;
	//printf("num_atoms_eacresd[%d] = %d\n",resd_count-1,num_atoms_in_each_resd[resd_count-1]);
      }
    }
  }
  fclose(fpr);

  *first_resd = resd_arr[1];
  *last_resd = resd_arr[resd_count-1];

  //printf("first_resd = %d and last_resd = %d\n",resd_arr[1],resd_arr[resd_count-1]);



  free(resd_arr);free(num_atoms_in_each_resd);
  return(resd_count-1);

}//END get_first_and_last_fist_resd **************************************************
//************************************************************************************




//*****************************************************************
float assign_pts(char* file, POINT *fpt, POINT *lpt, char *flag){

  FILE *fpr; 
  PDB_LINE line;
  float distance;
  int first_resd, last_resd;
  get_first_and_last_fist_resd_duplicate(file, &first_resd, &last_resd);

  fpr = fopen(file,"r");

  while(read_pdb_line(fpr, &line) != EOF){
    if(strcmp(flag,"CN")==0){
      if(is_C_atom(line.atom) && line.res_no ==first_resd){
	fpt->x = line.pt.x;  
	fpt->y = line.pt.y;  
	fpt->z = line.pt.z; 
      }
      if(is_N_atom(line.atom) && line.res_no ==last_resd){
	lpt->x = line.pt.x;  
	lpt->y = line.pt.y;  
	lpt->z = line.pt.z; 
      }
    }
    if(strcmp(flag,"CACA")==0){
      if(is_ref_atom(line.atom) && line.res_no ==first_resd){
	fpt->x = line.pt.x;  
	fpt->y = line.pt.y;  
	fpt->z = line.pt.z; 
      }
      if(is_ref_atom(line.atom) && line.res_no ==last_resd){
	lpt->x = line.pt.x;  
	lpt->y = line.pt.y;  
	lpt->z = line.pt.z; 
      }
    }
    if(strcmp(flag,"NC")==0){
      if(is_N_atom(line.atom) && line.res_no ==first_resd){
	fpt->x = line.pt.x;  
	fpt->y = line.pt.y;  
	fpt->z = line.pt.z; 
      }
      if(is_C_atom(line.atom) && line.res_no ==last_resd){
	lpt->x = line.pt.x;  
	lpt->y = line.pt.y;  
	lpt->z = line.pt.z; 
      }
    }
  }// END while....
  fclose(fpr);


  //printf("fpt = (%4.3f, %4.3f, %4.3f)\n",fpt->x,fpt->y, fpt->z);
  //printf("lpt = (%4.3f, %4.3f, %4.3f)\n",lpt->x,lpt->y,lpt->z);
  distance = give_Distance(fpt, lpt);
  //printf("distance = %4.3f\n",distance);
  return(distance);

}// END assign_pts ************************************************







float give_Distance(POINT *pt1, POINT *pt2){
/***********************************************************	
 * returns the distance between two points 
***********************************************************/ 
float l1, l2, l3;
 l1 = l2 = l3 = 0.00;
 
 //printf("pt1_x = %f  pt1_y = %f pt1_z = %f\n",pt1->x,pt1->y,pt1->z);
 //printf("pt2_x = %f  pt2_y = %f pt2_z = %f\n",pt2->x,pt2->y,pt2->z);
 
 l1 = pow((pt1->x - pt2->x),2.00);
 l2 = pow((pt1->y - pt2->y),2.00);
 l3 = pow((pt1->z - pt2->z),2.00);
 
//printf("l1= %f, l2=%f, l3=%f\n",l1,l2,l3);
 
 return( sqrt(l1+l2+l3) );
} /* END float get_distance() */	










/********************************************************************************/
void createSpace(char space[], int number) {
  int i;
  for(i=0; i<number; i++) {
    space[i] = SPACE;
  }
  space[i-1] = '\0';
}//******************************************************************************






/********************************************************************************/
void printPDB(PDB_LINE plsave, char *line, FILE *outputfptr) {
  int offset, i, j;
  float tempf;
  char *space5, *space6, *space7;
  
  if(plsave.pt.x < 0) {
    offset = 1; /* for the minus sign */
  }
  else {
    offset = 0;
  }
  tempf = fabs(plsave.pt.x);
  i = 1; 
  j = 10;
  if((plsave.pt.x >= 1)||(plsave.pt.x <= -1)) {
    while(1) {
      if((tempf >= i) && (tempf< j)) {
	break;
      }
      offset++;
      i = i * 10;
      j = j * 10;
    }
  }
  offset = PDB_SPACE5 - offset;
  /*printf("offset5 = %d\n", offset);*/
  
 /* char space5[offset]; */
  space5 = (char*)malloc(offset*sizeof(char) );
  if(space5 == NULL){
	  printf("space5 could not be allocated\n");
	  exit(EXIT_FAILURE);
  }
  
  createSpace(space5, offset);
  
  
  if(plsave.pt.y < 0) {
    offset = 1;//for the minus sign
  }
  else {
    offset = 0;
  }
  tempf = fabs(plsave.pt.y);
  i = 1; 
  j = 10;
  if((plsave.pt.y >= 1)||(plsave.pt.y <= -1)) {
    while(1) {
      if((tempf >= i) && (tempf< j)) {
	break;
      }
      offset++;
      i = i * 10;
      j = j * 10;
    }
  }
  offset = PDB_SPACE6 - offset;
  /*printf("offset5 = %d\n", offset); */
 /* char space6[offset]; */
  space6 = (char*)malloc(offset*sizeof(char) );
  if(space6 == NULL){
	  printf("space6 could not be allocated\n");
	  exit(EXIT_FAILURE);
  }
  
  
  createSpace(space6, offset);
  
  if(plsave.pt.z < 0) {
    offset = 1;//for the minus sign
  }
  else {
    offset = 0;
  }
  tempf = fabs(plsave.pt.z);
  i = 1; 
  j = 10;
  if((plsave.pt.z >= 1)||(plsave.pt.z <= -1)) {
    while(1) {
      if((tempf >= i) && (tempf< j)) {
	break;
      }
      offset++;
      i = i * 10;
      j = j * 10;
    }
  }
  offset = PDB_SPACE7 - offset;
  /*printf("offset5 = %d\n", offset);*/
  /* char space7[offset]; */
  space7 = (char*)malloc(offset*sizeof(char) );
  if(space7 == NULL){
	  printf("space7 could not be allocated\n");
	  exit(EXIT_FAILURE);
  }
  
  
  
  createSpace(space7, offset);
  


  fprintf(outputfptr, PDB_WRITE_FORMAT1, line, space5, plsave.pt.x, space6, plsave.pt.y, space7, plsave.pt.z);
  free(space5); free(space6); free(space7);
  
}/***************************************************************************************/




//****************************************************
void getLength(char* infile, int* l_ptr){
 
 char aa_name[4];        char *status;
 char aa_number[5];      char line[300];
 char *aa_namePtr;
 char *aa_numberPtr;
 char *string1 = "ATOM";
 int  j = 0, k, count;   int print_counter = 0;
 char array[50000];
 float  aa_num;	 
 float array_number[30000];
 int l_counter = 0;

 FILE *infilePtr;

 infilePtr = fopen(infile, "r");
 if(!infilePtr){printf("Error! Cannot open file: %s\n", infile);exit(-1);}
	
 /* outfilePtr = fopen(outfile,"w");*/


 /*fprintf(outfilePtr,">sequencename \n");*/
 
 for (status = fgets(line, 300, infilePtr);
 	status != 0;
	status = fgets(line, 300, infilePtr))
	{	
		int r;
	
		r = strncmp(status,string1,strlen(string1));
		if( r == 0)
		{
		int r1,r2,r3,r4,r5,r6,r7,r8,r9,r10,
	            r11,r12,r13,r14,r15,r16,r17,r18,r19,r20;			
		
		
		sscanf(&line[16],"%3s",aa_name); 
		sscanf(&line[22],"%4s",aa_number);
                 
		aa_namePtr = aa_name; 
		aa_numberPtr = aa_number;
		
		aa_num = atof(aa_numberPtr);
		
		r1 = strcmp(aa_namePtr,"ALA");   r11 = strcmp(aa_namePtr,"LEU");
		r2 = strcmp(aa_namePtr,"ARG");    r12 = strcmp(aa_namePtr,"LYS");
		r3 = strcmp(aa_namePtr,"ASP");    r13 = strcmp(aa_namePtr,"MET");
		r4 = strcmp(aa_namePtr,"ASN");    r14 = strcmp(aa_namePtr,"PHE");
		r5 = strcmp(aa_namePtr,"CYS");    r15 = strcmp(aa_namePtr,"PRO");
		r6 = strcmp(aa_namePtr,"GLU");    r16 = strcmp(aa_namePtr,"SER");
		r7 = strcmp(aa_namePtr,"GLN");    r17 = strcmp(aa_namePtr,"THR");
		r8 = strcmp(aa_namePtr,"GLY");    r18 = strcmp(aa_namePtr,"TRP");
		r9 = strcmp(aa_namePtr,"HIS");    r19 = strcmp(aa_namePtr,"TYR");
		r10 = strcmp(aa_namePtr,"ILE");   r20 = strcmp(aa_namePtr,"VAL");  
		
		
		if(r1 == 0) { array[j]='A'; array_number[j]=aa_num; j++; } 
		if(r2 == 0) { array[j]='R'; array_number[j]=aa_num;j++; } 
		if(r3 == 0) { array[j]='D';array_number[j]=aa_num;j++; } 
		if(r4 == 0) { array[j]='N';array_number[j]=aa_num;j++; } 
		if(r5 == 0) { array[j]='C';array_number[j]=aa_num;j++; } 
		if(r6 == 0) { array[j]='E';array_number[j]=aa_num;j++; } 
		if(r7 == 0) { array[j]='Q';array_number[j]=aa_num;j++; } 
		if(r8 == 0) { array[j]='G';array_number[j]=aa_num;j++; } 
		if(r9 == 0) { array[j]='H';array_number[j]=aa_num;j++; } 
		if(r10 == 0) { array[j]='I';array_number[j]=aa_num;j++; } 
		if(r11 == 0) { array[j]='L';array_number[j]=aa_num;j++; }  
		if(r12 == 0) { array[j]='K';array_number[j]=aa_num;j++; } 
		if(r13 == 0) { array[j]='M';array_number[j]=aa_num;j++; } 
		if(r14 == 0) { array[j]='F';array_number[j]=aa_num;j++; } 
		if(r15 == 0) { array[j]='P';array_number[j]=aa_num;j++; }  
		if(r16 == 0) { array[j]='S';array_number[j]=aa_num;j++; } 
		if(r17 == 0) { array[j]='T';array_number[j]=aa_num;j++; }  
		if(r18 == 0) { array[j]='W';array_number[j]=aa_num;j++; } 
		if(r19 == 0) { array[j]='Y';array_number[j]=aa_num;j++; } 
		if(r20 == 0) { array[j]='V';array_number[j]=aa_num;j++; } 
		
	        }
		count = j;
	}
 
 
 
	for(k=0; k<count; k++){
		if(  (array[k] == array[k+1]) && (array_number[k] == array_number[k+1])  ){
			array[k+1] = array[k];  array_number[k+1] = array_number[k];
		}else{
		  
		    /* fprintf(outfilePtr,"%c",array[k]);*/ 
		    /* printf("%c",array[k]); */
		   print_counter ++;
		   l_counter ++;
	          }
			         
        }/*fprintf(outfilePtr,"\n");*/
		     /* printf("exiting getsequence \n");*/
	*l_ptr = print_counter;
	
	fclose(infilePtr);
	
}// END getlength..***************************************************************************




		
/****************************************************************************************
//  anchor_file = file from which the desired distances are obtained..
//  to_minimize = loop with fist residues which will be minimized.
//  returns the minimized pdb file..		
****************************************************************************************/  
char* call_simplex(char *anchor_file, char* to_minimize){

  
  float CN_dist, CACA_dist, NC_dist;
  
  POINT first_C,last_N;
  POINT first_CA, last_CA, first_N, last_C;
  int first_resd, last_resd, seqlength = 0;


  seqlength = get_first_and_last_fist_resd_duplicate(to_minimize, &first_resd, &last_resd);
  //getLength(to_minimize, &seqlength);
  SEQLENGTH = seqlength;
  //printf("seqlength = %d\n",seqlength);
  //useVadar(to_minimize, PHIPSIFILE);   /* PHIPSIFILE = PhipsiFile.txt */
  call_phipsi(to_minimize, PHIPSIFILE);

  //exit(-1);


  CN_dist =  assign_pts(anchor_file, &first_C, &last_N, "CN");
  CACA_dist = assign_pts(anchor_file, &first_CA, &last_CA, "CACA");
  NC_dist = assign_pts(anchor_file, &first_N, &last_C, "NC");
  //printf("C-N = %4.3f, CA-CA = %4.3f, N-C = %4.3f\n",CN_dist, CACA_dist, NC_dist);
  
  des_CN_dist = CN_dist;
  des_CA_CA_dist = CACA_dist;
  des_NC_dist = NC_dist;  
  //exit(-1);
  
  initSimplex(seqlength);
  
  /*
    for(i=0; i<seqlength; i++){
    printf("orig_phi[%d] = %f, orig_psi[%d] = %f\n",i, orig_phi[i],i, orig_psi[i]);
    } 
  */
  
  //printf("finished initSimplex\n");
  fin_initSimplex = TRUE;
  
  
  
  minSearch();
  
  rename(PEPRESULTFILE, SIMPLEX_OUTPUT);
  
  /* free(orig_phi);
     free(orig_psi);*/
  cleanup();//DONT DELETE!!!
  
  return(SIMPLEX_OUTPUT);
  
  
}

int main (int argc, char *argv[]){

  char *pre_post_pdb,*pre_post_loop_pdb, *simplex_output;
  
  pre_post_pdb = argv[1];
  pre_post_loop_pdb = argv[2];
  
  
  simplex_output = call_simplex(pre_post_pdb,pre_post_loop_pdb);
 
  return 1;
}


