#ifndef __SIMPLEX_H
#define __SIMPLEX_H

//#include "useVadar.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "util.h"

#define PEP_WRITE_FORMAT   "%d %c %5.2f %5.2f\n"
//#define PDB_READ_FORMAT  "%4s %6d %3s%4s %5d %7f %7f %7f %f %f %8s\n"
//#define PDB_WRITE_FORMAT "%4s%d%s%3s%s%4s%s%d%s%.3f%s%.3f%s%.3f\n"
#define PDB_WRITE_FORMAT1  "%s%s%.3f%s%.3f%s%.3f\n"
#define VADAR_READ_FORMAT  "%d %c %f %f %f\n"
#define PHIPSI_READ_FORMAT "%d %s %f %f %f %f\n" 


#define FILE_READ "r"
#define FILE_WRITE "w"

#define NMAX 5000
#define A 1.0
#define B 0.5
#define G 2.0
//#define PI 3.141592654
#define MAX_LINE 300
#define R 0.2779
#define Da 8.03

#define NEWLINE         "\n"
#define TOPEPFILE       "toPepFile.txt"
#define PEPRESULTFILE   "pepResultFile.txt"
#define PEPRESULT_HFILE "pepResultFile-H.txt"
#define PHIPSIFILE      "phipsiFile.txt"
#define SIMPLEX_INPUT   "simplex_input"
#define SIMPLEX_OUTPUT  "simplex_output"



#define ATOMPDB "ATOM"
#define NPDB "N"
#define CPDB "C"
#define OPDB "O"
#define HPDB "H"
#define PDBEND "TER"

#define COBONDLEN 1.4

#define PDB_SPACE1 7 //the # of spaces b/w "ATOM" and atomno
#define PDB_SPACE2 1 //the # of spaces b/w atomno and atomName
#define PDB_SPACE3 3 //the # of spaces b/w atomName and resName
#define PDB_SPACE4 6 //the # of spaces b/w resName and resNo
#define PDB_SPACE5 8 //the # of spaces b/w resNo and x
#define PDB_SPACE6 4 //the # of spaces b/w x and y
#define PDB_SPACE7 4 //the # of spaces b/w y and z

#define SPACE ' '
#define N_ATOM           "N"
#define C_ATOM           "C"
#define CA_ATOM          "CA"

#define TRUE      1
#define FALSE     0

#define DEFAULT_OMEGA  180.00
#define DEFAULT_CHI    360.00

typedef struct {
  int resNo;
  float distance;
}Res_Dis;


typedef struct {
  int index;
  float value;
} RDC;


void get_psum();
float function(float* input);
void amoeba();
void amotry(int ihi, float fac, float* result);
//void minSearch(float psi, float phi, float omega, int ndimI, int mptsI);
//void minSearch(float psi[], float phi[], float omega[], int ndimI);
void minSearch();

void prepareMin(float phi[], float psi[],float [],float [], int length);
void readRDC(int offset);
float searchRDC(int index);
void initSimplex(int length);
void calcRDC(float *x1, float *y1, float *z1, float *result);
void createSpace(char space[], int number);
void printH(POINT hpt, PDB_LINE plsave, FILE *outfptr, int atom_no);
void addH(char* input, char* output);
//void read_pdb_line (char *line, PDB_LINE * l);
void rotate_simplex(double alpha, double beta, double gama);
POINT matrixMult(double r[], POINT pt);
void printPDB(PDB_LINE plsave, char *line, FILE *outputfptr);

float give_Distance(POINT *pt1, POINT *pt2);

//int assign_pt (POINT * a, POINT b);

float assign_pts( char *file, POINT *fpt, POINT *lpt, char*);

//int set_sec_loop_ref_pt (char * loop, POINT * pt);

//int set_prim_loop_ref_pt ( char * loop, POINT * pt);

//boolean is_N_atom (char * atom);

//boolean is_C_atom (char * atom);

//int read_pdb_Line (FILE * fp, PDB_LINE * l);


char* call_simplex(char*, char*);
#endif

