#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

//#include "../util/util.h"
#include "superpose.h"
#include "misc.h"
//#include "generate.h"

//#define DEBUG_SUPERPOSE


//*********************
void exit_prog(){
  exit(EXIT_FAILURE); 
}//*********************


//*******************************
int min(int x, int y){
  return ( (x >=y) ? y : x);
}
//*******************************


//***************************
int max(int x, int y){
  return ( (x >=y) ? x : y); 
}
//**************************



//***************************************************************************
// pdb_org = name of the file which has not been changed
// pdb_sup = name of the file whish has been superimposed on pdb_org  
void write_header(char *result_file, char *pdb_sup,char *pdb_org){
  
  FILE *result_ptr;
  /*const char *star   = "*--------------------------------------------------------------*\n";
    const char *label  = "         SUPERIMPOSITION USING QUATERNION  METHOD               \n";
    const char *label2 = "        ------------------------------------------              \n";*/
  const char *remark = "REMARK   ";    
  //printf("pdb_org = %s and pdb_sup = %s\n",pdb_org, pdb_sup);
  
 
  result_ptr = fopen(result_file,"w");
  if(!result_ptr){printf("Cannot open %s\n", result_file); exit_prog();}
  
  fprintf(result_ptr,"%s Superposition done by Superpose server ver 1.0\n",remark);
    fprintf(result_ptr,"%s %s is superposed on %s\n",remark,pdb_sup,pdb_org);
    fprintf(result_ptr,"%s %s is shown first followed by the superimposed %s\n\n",remark,pdb_org,pdb_sup);
  
  fflush(result_ptr); fclose(result_ptr);
  
  
}/* END  write_header()*/
//*******************************************************************************




//************************************************************************************
/* Rotate a vector..ie. Multiply the array v with the matrix t */
void rotvec(int n, float v[4], float t[][4]){
  int i,j;
  float s[4];
  for(i=1; i<=n; i++){
    s[i] = v[i];
    v[i] = 0.00;
  }
  
  for(i=1; i<=n; i++){
    for(j=1; j<=n; j++){
      v[i] = v[i]+s[j]*t[i][j];
    }
  }
}/* END rotvec .. */
//**************************************************************************************



//**************************************************************************************
/* The input is a 5x5 Matrix, the first column 
    and the first row are not printed *
 --------------------------------------------*/
void print4Matrix(float arr[][5],int row, int col){
  int i,j;
  printf("----------------------------------\n");
  for(i=1; i<row; i++){
    for(j=1; j<col; j++){
      printf("%11.6f  ",arr[i][j]);
      if(j == col-1)
	printf("\n");
    }
  }
  printf("\n");
}/*-- END printMatrix()  --*/
//****************************************************************************************





//*****************************************************************************************
void print3Matrix(float arr[][4],int row, int col){
  int i,j;
  printf("----------------------------------\n");
  for(i=1; i<row; i++){
    for(j=1; j<col; j++){
      printf("%10.6f ",arr[i][j]);
      if(j == col-1)
	printf("\n");
    }
  }
  printf("\n");
}/*-- END printMatrix()  --*/
//*****************************************************************************************





//*****************************************************************************************
int jacobi(float a[5][5], int n, int np, float d[5],float v[5][5], int *nrot){
  int i,ip,iq,j,maxrot,nmax;
  float c, g, h, s, sm, t, tau, theta, tresh;
  float b[500], z[500], zero;

  /*Initialize*/
  nmax = 500;
  zero = 1.0*(pow(10,-30));
   /* printf("zero = %10.6f\n", zero);*/
  maxrot = 50;  *nrot = 0;

  /* Initialize v to the Identity Matrix */
  /*-------------------------------------*/
  for(ip=1;ip<=n;ip++){
    for(iq=1;iq<=n;iq++){
      if(ip==iq)
	v[ip][iq] = 1.00;
      else 
	v[ip][iq] = 0.00;
    }
  }
  /*
  printf("Printing v(the identity matrix)\n");
  print4Matrix(v,4,4);
  */
  /*Initialize b and d to the diagonal of a */
  for(ip=1; ip<=n; ip++){
    b[ip] = a[ip][ip];
    d[ip] = b[ip];
    z[ip] = 0.00;
  }

  /*
    printf("b = %10.2f, %10.2f, %10.2f, %10.2f \n",b[0], b[1], b[2], b[3]);
    printf("d = %10.2f, %10.2f, %10.2f, %10.2f \n",d[0], d[1], d[2], d[3]); 
    printf("z = %10.2f, %10.2f, %10.2f, %10.2f \n",z[0], z[1], z[2], z[3]);
  */
  
  for(i=1; i<=maxrot; i++){
    sm = 0.00;
    
    for(ip=1; ip<=(n-1); ip++){
      for(iq=(ip+1); iq<=n; iq++){
	/*printf("ip= %d,  iq=%d\n", ip, iq);*/
	sm = sm + fabs(a[ip][iq]);
	/*printf("sm = %f\n", sm);*/
      }
    }
    /*    printf("sm = %.4g\n", sm); */

    if(sm < zero){
      return(0);
    }
    if ( i < 4){
      tresh = 0.2*sm/(n*n);
    }
    else {
      tresh = 0.0;
    }
    /*  printf("tresh = %.6g\n",tresh); */ 

    for(ip=1; ip<=(n-1); ip++){

      for(iq=(ip+1); iq<=n; iq++){

	g = 100.0*fabs(a[ip][iq]);
	/*	printf("g = %f\n", g); */
	
	if( (i>4)&&((fabs(d[ip])+g) == fabs(d[ip]) )&&((fabs(d[iq])+g)== fabs(d[iq]))){
	  a[ip][iq] = 0.00;
	  /* printf("a[ip][iq] = %f\n",a[ip][iq]);*/
	}
	else if(fabs(a[ip][iq]) > tresh){
	  h = d[iq]-d[ip];
	  /* printf("h = %f\n",h);*/
	  

	  /* Problem over here....Have to check fabs(h) and g values..   */
	  if( (fabs(h)+g) == fabs(h) ){
	    t = (a[ip][iq])/h; 
	    /* printf("t = %f\n", t);*/
	  }
	  else {
	    theta = 0.50*h/a[ip][iq];
	    t = 1.00/(fabs(theta)+sqrt(1.00+theta*theta));
	    /* printf("theta = %f\n", theta);
	       printf("in else t = %f\n", t);*/
	    if(theta < 0.0)
	      t = -t;
	  }
	  
	  c = 1.0/sqrt(1+t*t);
	  s = t*c;
 	  tau = s/(1.0 + c);
	  h = t*(a[ip][iq]);
	  /* printf(" c = %f    ", c); printf(" s = %f", s);
	     printf(" tau = %f    ", tau); printf(" h = %f\n", h);*/
	  
	  z[ip] = z[ip] - h;
	  z[iq] = z[iq] + h;
	  d[ip] = d[ip] - h;
	  d[iq] = d[iq] + h;
	  a[ip][iq] = 0.00;
	  /* printf("ip = %d,   iq = %d\n",ip,iq);*/
	  /*	  printf("z[ip] = %f\n",z[ip]);
	  printf("z[iq] = %f\n",z[iq]); 
          printf("d[ip] = %f\n",d[ip]); 
          printf("d[iq] = %f\n",d[iq]);
          printf("a[ip][iq] = %f\n",a[ip][iq]); */

	  for(j=1; j<=(ip-1); j++){
	    g = a[j][ip];    h = a[j][iq];
	    a[j][ip] = g - s*(h+g*tau);
	    a[j][iq] = h + s*(g-h*tau);
	    /*  printf("first for..  ");
		printf("g=%f,  h=%f,   a[j][ip]=%f,   a[j][iq]=%f\n",g,h,a[j][ip], a[j][iq]); */
	  }
	  
	    for(j=(ip+1); j<=(iq-1); j++){ 
	    g=a[ip][j];     h=a[j][iq]; 
	    a[ip][j]=g-s*(h+g*tau);                                  
	    a[j][iq]=h+s*(g-h*tau);
	    /* printf("second for..  ");
	       printf("g=%f,  h=%f,   a[ip][j]=%f,   a[j][iq]=%f\n",g,h,a[ip][j], a[j][iq]);*/
	  }
	  
	  for(j=(iq+1); j<=n; j++){
	    g=a[ip][j];     h=a[iq][j];   
	    a[ip][j]=g-s*(h+g*tau);
	    a[iq][j]=h+s*(g-h*tau); 
	    /* printf("third for..  ");
	       printf("g=%f,  h=%f,   a[ip][j]=%f,   a[iq][j]=%f\n",g,h,a[ip][j], a[iq][j]);*/
	  }
	  
	  for(j=1; j<=n; j++){
	    g=v[j][ip];     h=v[j][iq];
	    v[j][ip]=g-s*(h+g*tau);     
	    v[j][iq]=h+s*(g-h*tau);
	    /* printf("fourth for..  ");
	       printf("g=%f,  h=%f,   v[j][ip]=%f,   v[j][iq]=%f\n",g,h,v[j][ip], v[j][iq]);*/
	  }
	  
	  (*nrot)++;
	}
      }
    }
    
	  
	  for(ip=1; ip<=n; ip++){
	    b[ip] = b[ip] + z[ip];
	    d[ip] = b[ip];                        
	    z[ip] = 0.00;
	  }
  }
  /* printf("Too many iterations in jacobi\n");*/
  return(1);
}/*  End jacobi() */
//*********************************************************************************************************




//***************************************************************************************************
void eigsrt(float d[5], float v[5][5], int n, int np){
  int i, j, k;
  float p;
  
  for(i=1; i<=(n-1); i++){
    k = i;
    p = d[i];
    
    for(j=i+1; j<=n; j++){
      if(d[j] >= p){
	k=j;
	p = d[j];
      }
    }
    if(k != i){
      d[k] = d[i];
      d[i] = p;
      for(j=1; j<=n; j++){
	p = v[j][i];
	v[j][i] = v[j][k];
	v[j][k] = p;
      }
    }
  }
}/* End eigsrt.. */
//******************************************************************************************************





//*********************************************************************************************
// GETS ALL THE COORDINATES,
int get_all_coords_and_centre(char *filename, float arr[][4], float centre[4], char line[MAX_ATOMS_SUP][MAX_LINE_LEN_SUP], char line_end[MAX_ATOMS_SUP][MAX_LINE_LEN_SUP]){
  
  FILE *fptr;
  char buffer[MAX_LINE_LEN_SUP];
  float sum_x, sum_y, sum_z;
  int i,j;
  i = 1;

  sum_x = sum_y = sum_z = 0.00;
  centre[0] = 0.00;
  line[0][0] = ' '; line_end[0][0]=' ';
  arr[0][0] = arr[0][1] = arr[0][2] = arr[0][3] = 0.00;

 
  fptr = fopen(filename, "r");
  if(!fptr){printf("Cannot open %s for reading\n", filename); exit_prog();}
  
  
  while(fgets(buffer, MAX_LINE_LEN_SUP, fptr)!=NULL){
     if(strncmp(buffer, "ATOM", 4) == 0){
       /* printf("%s",buffer);
	  printf("strlen(buffer) = %d\n",strlen(buffer));*/
       for(j=0; j<=26; j++){
	line[i][j] = buffer[j];
      }
       /* printf("line in util = %s\n",line[i]);*/

       arr[i][0] = 0.00;
       sscanf(&buffer[31],"%f%f%f",&arr[i][1], &arr[i][2], &arr[i][3]);
       sum_x += arr[i][1]; sum_y += arr[i][2]; sum_z += arr[i][3];

       for(j=54; j<=strlen(buffer);j++){
	 line_end[i][j-54] = buffer[j];
	 /*printf("%c",line_end[i][j]);*/
        }
       /*printf("line end in util = %s\n",line_end[i]);*/

       i++;
     }
  }
  i = i-1;
  
  centre[1] = sum_x/i; centre[2] = sum_y/i; centre[3] = sum_z/i;
  fflush(fptr);  fclose(fptr);
  return(i);
}/* --------- END get_all_coords() ----------*/
//**************************************************************************************************




//GETS ALL THE CO-ORDS OF THE ATOMS THAT ARE IN LIST L
//*************************************************************************************************
int get_selected_coords_and_centre(char *filename, float arr[][4], float centre[4], char line[MAX_ATOMS_SUP][MAX_LINE_LEN_SUP], LIST *L,int list_size){
  
  FILE *fptr;  char buffer[MAX_LINE_LEN_SUP];
  float sum_x, sum_y, sum_z;
  int i,j,k;
  char atom[6];   int lcount = 0;  
  int *resd_arr,resdnum,resd_count = 1;
  int *num_atoms_in_each_resd,atom_count = 1;
  int count,ncount=0;

  i=1;
  sum_x = sum_y = sum_z = 0.00;
  centre[0] = 0.00;  line[0][0] = ' ';
  arr[0][0] = arr[0][1] = arr[0][2] = arr[0][3] = 0.00;
  
  fptr = fopen(filename, "r");
  if(!fptr){printf("Cannot open %s for reading\n", filename); exit_prog();}
  
  resd_arr =(int*)malloc(1*sizeof(int));
  if(!resd_arr){printf("Cannot malloc for resd_arr..Exiting\n");exit(-1);}
  resd_arr[0] = -1000;
  
  num_atoms_in_each_resd = (int*)malloc(1*sizeof(int));
  if(!num_atoms_in_each_resd){printf("Cannot malloc for num_atoms_in_each_resdr..Exiting\n");exit(-1);}
  num_atoms_in_each_resd[0] = 0;

  //printf("In get selected coords and centre..\n");
  //printf("------------------------------------------------------\n");
  //print_resdlist(L,list_size);
  
  while(fgets(buffer, MAX_LINE_LEN_SUP, fptr)!=NULL){
    if(strncmp(buffer, "ATOM", 4) == 0){
      
      sscanf(&buffer[11],"%5s", atom);
      sscanf(&buffer[22],"%4d",&resdnum);
      
      //printf("atom = %s and resdnum = %d\n",atom, resdnum);

      if(resdnum != resd_arr[resd_count-1]){

	resd_arr = (int*)realloc( (int*)resd_arr,(resd_count+1)*sizeof(int) );
	if(!resd_arr){printf("Cannot realloc resd_arr..exiting\n");exit(-1);}
	resd_arr[resd_count] = resdnum;

	atom_count=0;
	num_atoms_in_each_resd = (int*)realloc( (int*)num_atoms_in_each_resd,(resd_count+1)*sizeof(int) );
	if(!num_atoms_in_each_resd){printf("Cannot realloc num_atoms_in_each_resd..exiting\n");exit(-1);}
        atom_count++;
	num_atoms_in_each_resd[resd_count] = atom_count;

	//printf("resdnum = %d and resd_arr[%d]=%d,num-atoms[%d]=%d\n",resdnum,resd_count,resd_arr[resd_count],resd_count,atom_count);
	resd_count++;
	//atom_count = 0;
      }else{

	atom_count++;
	num_atoms_in_each_resd[resd_count-1] = atom_count;
	//printf("num_atoms_eacresd[%d] = %d\n",resd_count-1,num_atoms_in_each_resd[resd_count-1]);

      }
    }
  }

  //for(j=0;j<resd_count;j++){
    //printf("num_atoms_eacresd[%d] = %d\n",j,num_atoms_in_each_resd[j]);
  //}
  
  for(k=0;k<list_size;k++){
    for(j=1;j<resd_count;j++){
      if(L[k].atomno == resd_arr[j]){L[k].num_of_atoms_in_resd = num_atoms_in_each_resd[j];}
    }
  }

  //for(k=0;k<list_size;k++){
   //printf("L[%d].num_atoms_eacresd = %d\n",k,L[k].num_of_atoms_in_resd);
  //}

  rewind(fptr);
 
  count=0;
 while(fgets(buffer, MAX_LINE_LEN_SUP, fptr)!=NULL){
    if(strncmp(buffer, "ATOM", 4) == 0){
      
      sscanf(&buffer[11],"%5s", atom);
      sscanf(&buffer[22],"%4d",&resdnum);
      //ncount++;

      //printf("resdnum = %d and atom = %s ",resdnum,atom);
      
      //if(resdnum == L[count].atomno && (is_bb_atom(atom)==1) ){
      if(resdnum == L[count].atomno && (is_bb_atom_except_O(atom)==1) ){
      //if(resdnum == L[count].atomno && (is_bb_atom_except_O_and_CA(atom)==1) ){
      //if(resdnum == L[count].atomno) {
      	//printf("%s",buffer);
	lcount++;
	ncount++;
	//if(ncount == L[count].num_of_atoms_in_resd){count++;ncount=0;}
        for(j=0; j<=26; j++){
	  line[i][j] = buffer[j];
	}
	arr[i][0] = 0.00;
	sscanf(&buffer[30],"%f%f%f",&arr[i][1], &arr[i][2], &arr[i][3]);
	
	//printf("after scanning, arr[1]=%4.3f,  arr[2]=%4.3f,  arr[3]=%4.3f\n",arr[i][1],arr[i][2],arr[i][3]);
	sum_x += arr[i][1]; sum_y += arr[i][2]; sum_z += arr[i][3];
	i++;
      }else if(resdnum == L[count].atomno){
	ncount++;
      }else{
      }
      if(ncount == L[count].num_of_atoms_in_resd){count++;ncount=0;}
    }
    
 }

  i = i-1;
  
  //printf("lcount = %d\n",lcount);

  //printf(" In util.c ,resd_count = %d\n",resd_count);
  //centre[1] = sum_x/(resd_count-1); centre[2] = sum_y/(resd_count-1); centre[3] = sum_z/(resd_count-1);
  centre[1] = sum_x/lcount; centre[2] = sum_y/lcount; centre[3] = sum_z/lcount;
  
  fclose(fptr);
  free(resd_arr);
  free(num_atoms_in_each_resd);
  return(lcount);
}
/* END get_selected_coords_and_centre() */
//***********************************************************************************************************



//**********************************************************************************
void transpose_matrix(float arr[][5],float arr_transp[][5], int n){
  int i,j;
  
  for(i=1; i<=4; i++){
    for(j=1; j<=4; j++){
      arr_transp[j][i] = arr[i][j];
    }
  } 
}//********************************* END transpose_matrix() **************************


#if 0
//***********************************************************
// * Appends file 'appendee' to file 'appendor'. 
// ***********************************************************/
int append_file (char * appendor, char * appendee) {

  
  FILE * tarfp;
  FILE * srcfp;
  char   buffer[MAX_LINE_LEN_SUP];
  /*printf("appendor = %s\n", appendor);*/
  tarfp = fopen (appendor, "a"); 
  if(!tarfp){
    printf("Cannot open %s for reading\n", appendor); exit_prog();
  } 
  srcfp = fopen (appendee, "r");
  if(!srcfp){
    printf("Cannot open %s for reading\n", appendee); exit_prog();
  } 
  
  //printf("Are we in appendfile..\n");
#if 0
  while (fgets (buffer, MAX_LINE_LEN_SUP, srcfp) != NULL) {
    /* printf("%s",buffer); */
    //Not printing the lines with MASTER, END and TER...
     if((strncmp(buffer,"MASTER",6)==0)||(strncmp(buffer,"END",3)==0)||(strncmp(buffer,"TER",3)==0)){
          // printf("buffer = %s",buffer);
    }
    else{
      fputs (buffer, tarfp); fflush (tarfp);
    }
  }
#endif

  while(fgets(buffer,MAX_LINE_LEN_SUP,srcfp)!=NULL){
    if(strncmp(buffer,"ATOM",4)==0){
      fputs(buffer,tarfp);fflush(tarfp);
    }
  }

  
  fclose (srcfp);
  fclose (tarfp);
  
  
  return 1;
  
} /* END append_file () */
//**************************************************************************************************
#endif




//********************************
int is_CA_atom(char *atom){
  
  if(strcmp(atom,"CA") == 0){
    return(1);
  }else{
    return(-1);
  } 
  
}// END is_CA_atom **************




//******************************************************************************************************
int is_bb_atom(char *atom){
  //printf("atom = %s and strlen(atom)=%d\n",atom,strlen(atom));

  if( (strcmp(atom,"N")==0) || (strcmp(atom,"CA")==0) || (strcmp(atom,"C")==0) || (strcmp(atom,"O")==0)){
    //printf("atom = %s and strlen(atom)=%d\n",atom,strlen(atom));
    return(1);
  }else{
    return(-1);
  }
}//*******************************************************************************************************



//******************************************************************************************************
int is_bb_atom_except_O(char *atom){
  //printf("atom = %s and strlen(atom)=%d\n",atom,strlen(atom));

  if( (strcmp(atom,"N")==0) || (strcmp(atom,"CA")==0) || (strcmp(atom,"C")==0) ){
    //printf("atom = %s and strlen(atom)=%d\n",atom,strlen(atom));
    return(1);
  }else{
    return(-1);
  }
}//*******************************************************************************************************


int is_bb_atom_except_O_and_CA(char *atom){

  if( (strcmp(atom,"N")==0) || (strcmp(atom,"C")==0) ){
    //printf("atom = %s and strlen(atom)=%d\n",atom,strlen(atom));
    return(1);
  }else{
    return(-1);
  }
}



//***************************
//int is_N_Atom(char* atom){
//if(strcmp(atom,"N")==0){
//  return(1);
// }else{
//  return(-1);
// }
//}//**************************


//**************************
//int is_C_atom(char *atom){
//if(strcmp(atom,"C")==0){
//  return(1);
//}else{
//  return(-1);
//}
//}//**************************


//**************************
//int is_O_atom(char *atom){
//if(strcmp(atom,"O")==0){
//  return(1);
//}else{
//  return(-1);
//}
//}//**************************



//**************************************************************************************
//Returns TRUE if the atom is not Hydrogen..
int is_not_Hydrogen(char *atom){
  //printf("atom = %s ",atom);
  //if(atoi(&atom[0])  ) {printf("int = %d  ",atoi(&atom[0]) );
  //if( strncmp(&atom[1],"H",1)==0 || strncmp(&atom[0],"H",1)==0  || strncmp(&atom[0],"Q",1)==0 ){
  //if( strcmp(atom,"HA")==0 || strcmp(atom,"HB")==0
    //printf("%s\t",atom);
  if( (atoi(&atom[0]) && strncmp(&atom[1],"H",1)==0)  || (strncmp(&atom[0],"H",1)==0) || (strncmp(&atom[0],"Q",1)==0) ){
    //printf("%s\t",atom);

    return(0);
  }else{
    return(1);
  }
}// END is_not_hydrogen *********************************************






//**********************************
int is_Q_atom(char *atom){
  if(strncmp(&atom[0],"Q",1)==0) {
    return(1);
  }else{
    return(0);
  }
}// END ****************************






//*****************************************************************************
void get_first_and_last_fist_resd(char* file, int* first_resd, int* last_resd){
  
  FILE *fpr;
  char buffer[MAX_LINE_LEN_SUP]; 
  int *resd_arr;
  int resdnum;
  int resd_count = 1;
  char atom_name[6];  
  int *num_atoms_in_each_resd;
  int atom_count = 1;
  
  fpr = open_file(file,"r");

  resd_arr =(int*)malloc(1*sizeof(int));
  if(!resd_arr){
    printf("Cannot malloc for resd_arr..Exiting\n");
    exit(-1);
  }
  resd_arr[0] = -1000;
  
  num_atoms_in_each_resd = (int*)malloc(1*sizeof(int));
  if(!num_atoms_in_each_resd){
    printf("Cannot malloc for num_atoms_in_each_resdr..Exiting\n");
    exit(-1);
  }
  num_atoms_in_each_resd[0] = 0;
  
  while(fgets(buffer, MAX_LINE_LEN_SUP, fpr)!= NULL){
    if(strncmp(buffer, "ATOM", 4) == 0){
      sscanf(&buffer[22],"%4d",&resdnum);
      sscanf(&buffer[11],"%5s",atom_name);

      if(resdnum != resd_arr[resd_count-1])
      {
	resd_arr = (int*)realloc( (int*)resd_arr,(resd_count+1)*sizeof(int) );
	if(!resd_arr){
          printf("Cannot realloc resd_arr..exiting\n");
          exit(-1);
        }
	resd_arr[resd_count] = resdnum;
	
	atom_count=0;
	num_atoms_in_each_resd = (int*)realloc( (int*)num_atoms_in_each_resd,(resd_count+1)*sizeof(int) );
	if(!num_atoms_in_each_resd){
          printf("Cannot realloc num_atoms_in_each_resd..exiting\n");
          exit(-1);
        }
        atom_count++;
	num_atoms_in_each_resd[resd_count] = atom_count;
	
	//printf("resdnum = %d and resd_arr[%d]=%d,num-atoms[%d]=%d\n",resdnum,resd_count,resd_arr[resd_count],resd_count,atom_count);
	resd_count++;
	//atom_count = 0;
      }
      else
      {
	
	atom_count++;
	num_atoms_in_each_resd[resd_count-1] = atom_count;
	//printf("num_atoms_eacresd[%d] = %d\n",resd_count-1,num_atoms_in_each_resd[resd_count-1]);
      }
    }
  }
  fclose(fpr);

  *first_resd = resd_arr[1];
  *last_resd = resd_arr[resd_count-1];

  //printf("first_resd = %d and last_resd = %d\n",resd_arr[1],resd_arr[resd_count-1]);



  free(resd_arr);free(num_atoms_in_each_resd);

}//END get_first_and_last_fist_resd **************************************************
//************************************************************************************







//************************************************************************************
char* call_superpose(char *loop_file, char* anchor_file, int no_of_fist_resds, float* rmsd){

  char* rotd_loop_file;
  int list_size = 0;
  if(no_of_fist_resds == 2){
    list_size = 2; // As we are using only one fist residues from both ends of the loop.
  }
  if(no_of_fist_resds == 6){
     list_size = 6; // If we use all the three first and last fist residues.. 
  }
  
  LIST *loop_list, *anchor_list;
  int first_fist_resd_of_anchor;
  int last_fist_resd_of_anchor;
  int first_fist_resd_of_loop;
  int last_fist_resd_of_loop;
  

  loop_list = (LIST*)malloc(list_size*sizeof(LIST));
  anchor_list = (LIST*)malloc(list_size*sizeof(LIST));

  get_first_and_last_fist_resd(anchor_file, &first_fist_resd_of_anchor, &last_fist_resd_of_anchor);
  //printf("first_resd = %d and last_resd = %d\n",first_fist_resd_of_anchor,last_fist_resd_of_anchor);

  get_first_and_last_fist_resd(loop_file, &first_fist_resd_of_loop, &last_fist_resd_of_loop);
  //printf("first_resd = %d and last_resd = %d\n",first_fist_resd_of_loop,last_fist_resd_of_loop);

if(list_size == 2){
  //If list_size ==2, use the following..
  anchor_list[0].atomno = first_fist_resd_of_anchor; anchor_list[1].atomno = last_fist_resd_of_anchor; 
  loop_list[0].atomno = first_fist_resd_of_loop;     loop_list[1].atomno = last_fist_resd_of_loop; 
  strcpy(anchor_list[0].atomType,"    \0");          strcpy(anchor_list[1].atomType,"    \0");
  strcpy(loop_list[0].atomType,"    \0");            strcpy(loop_list[1].atomType,"    \0");
}


if(list_size == 6){
  //If list_size == 6, use the following..
  anchor_list[0].atomno = first_fist_resd_of_anchor; anchor_list[1].atomno = first_fist_resd_of_anchor+1; 
  loop_list[0].atomno = first_fist_resd_of_loop;     loop_list[1].atomno = first_fist_resd_of_loop+1; 
  strcpy(anchor_list[0].atomType,"    \0");          strcpy(anchor_list[1].atomType,"    \0");
  strcpy(loop_list[0].atomType,"    \0");            strcpy(loop_list[1].atomType,"    \0");
  
  anchor_list[2].atomno = first_fist_resd_of_anchor+2; anchor_list[3].atomno = last_fist_resd_of_anchor-2; 
  loop_list[2].atomno = first_fist_resd_of_loop+2;     loop_list[3].atomno = last_fist_resd_of_loop-2; 
  strcpy(anchor_list[2].atomType,"    \0");            strcpy(anchor_list[3].atomType,"    \0");
  strcpy(loop_list[2].atomType,"    \0");              strcpy(loop_list[3].atomType,"    \0");
  
  anchor_list[4].atomno = last_fist_resd_of_anchor-1; anchor_list[5].atomno = last_fist_resd_of_anchor; 
  loop_list[4].atomno = last_fist_resd_of_loop-1;     loop_list[5].atomno = last_fist_resd_of_loop; 
  strcpy(anchor_list[4].atomType,"    \0");           strcpy(anchor_list[5].atomType,"    \0");
  strcpy(loop_list[4].atomType,"    \0");             strcpy(loop_list[5].atomType,"    \0");
}


  rotd_loop_file = superpose(loop_file, anchor_file, loop_list, anchor_list, list_size, rmsd);

  free(loop_list); free(anchor_list);
  return(rotd_loop_file);
}// END call_superpose ***************************************************************************************







//******************************************************************************
int is_chosen_atom(char *line, LIST *list, int i){

 char atom[3];   int resd_no, result=0;
 
 //printf("line=%s and atomtype = %s\n",line,list[i].atomType);
  if(strncmp(line, "ATOM", 4) == 0){

    sscanf(&line[13],"%3s", atom); 
    sscanf(&line[22],"%4d",&resd_no);

    //if( (strcmp(atom,list[i].atomType)==0) && (resd_no == list[i].atomno) ){
    if( (strcmp(atom,"N")==0 || strcmp(atom,"CA")==0 || strcmp(atom,"C")==0) && (resd_no == list[i].atomno) ){
      printf("matched line = %s and list_index = %d\n",line,i);
      result = 1;
    }else{
      result = 0;
    }
  } 
  return(result);
}// END is_chosen_atom **********************************************************






//*********************************************************************************
float get_rmsd(float rot_m[MAX_ATOMS_SUP][4], float req_f[MAX_ATOMS_SUP][4], int eq_num_of_atoms){
  
  int i,k;
  float rmsd = 0.00;
  float diff[eq_num_of_atoms+1][4],diff_sqrd[eq_num_of_atoms+1][4];
  float diff_sqrd_total[4];
  
  
  /* Initialise */
  diff_sqrd_total[0]=diff_sqrd_total[1]=diff_sqrd_total[2]=diff_sqrd_total[3] = 0.00;
  
  for(k=0;k<=eq_num_of_atoms;k++){
    for(i=0;i<=3;i++){
      diff[k][i] = 0.00; diff_sqrd[k][i] = 0.00;
    }
  }
    /*  printf("eq_num_of_atoms = %d\n",eq_num_of_atoms);*/
  
  for(k=1; k<=eq_num_of_atoms; k++){
    for(i=1; i<=3; i++){
      diff[k][i] =  rot_m[k][i] - req_f[k][i];
      diff_sqrd[k][i] =  diff[k][i]*diff[k][i]; 
      diff_sqrd_total[i] += diff_sqrd[k][i];
      
      //printf("req_f[%d]= %4.3f & rot_m[%d]=%4.3f \n",i,req_f[k][i],i,rot_m[k][i]);
      //printf("diff_sqrd[%d] = %4.3f      ",i,diff_sqrd[k][i]);
      //printf("diff_sqrd_total[%d] = %4.3f\n",i,diff_sqrd_total[i]);
    }      
    /*printf("\n\n");*/
  }  
  
  /*
  printf("diff_sqrd_total[1] = %6.3f\n",diff_sqrd_total[1]);
  printf("diff_sqrd_total[2] = %6.3f\n",diff_sqrd_total[2]);
  printf("diff_sqrd_total[3] = %6.3f\n",diff_sqrd_total[3]);
  printf("num_atoms = %d and sqrt(eq_num_ofatoms) = %6.3f\n",eq_num_of_atoms,sqrt(eq_num_of_atoms));*/
  
  rmsd = sqrt(diff_sqrd_total[1]+diff_sqrd_total[2]+diff_sqrd_total[3])/sqrt(eq_num_of_atoms);
  
  return(rmsd);
}// END get_rmsd ****************************************************************************


//***********************************************************
void print_resdlist(LIST* l, int num_resds){
  int i;
  printf("The residue list is as follows:\n");
  printf("-------------------------------\n");
  
  for(i=0; i<num_resds; i++){
    printf("%-5d ",l[i].atomno);
    if( (i+1)%20==0)printf("\n");
  }
  printf("\n\n");
}//END print_resdlist ***************************************




//************************************************************************************************************************
//*                                                                                                                  *
//*                                                                                                                  *
//*                                                                                                                  *
//*************************************************************************************************************************
char* superpose(char *fname, char *sname, LIST *list1, LIST *list2, int list_size, float *rmsd){
  
 
  /* Initialize: */
  int i, j, k,n, ns;
  float n_sub_one, ns_sub_one;
  int   num_atoms, NUM_ATOMS; 
  char *moving_file, *target_file, *result_file;
  //char *anchor_and_sup_file;
  //char *transformed_file,*anchor_file;
  int  nmrot;
  FILE *result_fptr;
  // FILE *target_fptr, *anchor_and_sup_fptr;
  //FILE *trans_fptr,*anchor_fptr;
  //LIST *RESD_LIST1, *RESD_LIST2; /* Expanded list to store the residues */
 
  int mov_all, mov_selected, target_selected; 

  /*------------------------------------------------------
   * q = Quaternion matrix                               *
   * xf stores the target file coordinates               *
   * xm stores the moving file coordinates               *
   *-----------------------------------------------------*/

  float dm[5], vm[5][5];
  float t[4][4], q[5][5];  /* tr = a vector from cm ---> cf  */
  float dxp[MAX_ATOMS_SUP][4], dxm[MAX_ATOMS_SUP][4];
 
  float xm_all[MAX_ATOMS_SUP][4], cm_all[4], xm_selected[MAX_ATOMS_SUP][4], cm_selected[4];
  float xf_selected[MAX_ATOMS_SUP][4], cf_selected[4];
  
  float x[4];
  float sumf[4], summ[4],  fill_value;
  float rot_xm_selected[MAX_ATOMS_SUP][4];

  
  char line_mov[MAX_ATOMS_SUP][MAX_LINE_LEN_SUP];
  char mov_end_portion[MAX_ATOMS_SUP][MAX_LINE_LEN_SUP]; 
  char junk[MAX_ATOMS_SUP][MAX_LINE_LEN_SUP];
  char new_junk[MAX_ATOMS_SUP][MAX_LINE_LEN_SUP];
  int list1_beg_resdno;
  int list1_end_resdno;
  int list2_beg_resdno;
  int list2_end_resdno;
 
//  char buffer[MAX_LINE_LEN_SUP];
  
  /*-- INITIALIZE  --*/
  n = ns = 5;
  n_sub_one = ns_sub_one = 4;
  fill_value = 0.00;

  remove(RESULT_PDB); 
  
  remove(ANCHOR_AND_SUP_FILE);
  result_file = RESULT_PDB;
  
  //xiaoli anchor_and_sup_file = ANCHOR_AND_SUP_FILE;

  sumf[0]= 0.00; summ[0]=0.00;
  for(i=1; i<=3; i++){
    sumf[i] = 0.00; summ[i] = 0.00;
  }
  
  /* Fill Matrix q with zeroes */
  /*-----------------------------------------------*/
  for(i=0; i<5; i++){
    for(j=0; j<5; j++){ 
      q[i][j] = 0.00; 
    }
  }
  
  /* Initialize dm with zeroes  */
  /*-----------------------------------------------*/
  for(i=0; i<5; i++){
    dm[i] = 0.00;
  }

  moving_file = fname; target_file = sname;
     
  list1_beg_resdno = list1[0].atomno; list1_end_resdno = list1[list_size-1].atomno;
  list2_beg_resdno = list2[0].atomno; list2_end_resdno = list2[list_size-1].atomno;


/* Storing all the co-ordinates and the centre of the moving file and target file *
 *  This centre is based on all the points                                        *
 * mov_all stores all the atoms of the pdb file that is being rotated
 * target_all stores all the atoms of the pdb file that is not being moved. 
 *--------------------------------------------------------------------------------*/
  mov_all = get_all_coords_and_centre(moving_file, xm_all, cm_all, line_mov, mov_end_portion);
 

  /********************************************************************************/
 #if 0
  //printf("list size = %d\n",list_size);
    RESD_LIST1 = (LIST*)malloc((list_size*4)*sizeof(LIST));
    if(!RESD_LIST1){err_print(ERR_MEM_ALLOC,"RESD_LIST1 in check()");exit(EXIT_FAILURE);}
      
    RESD_LIST2 = (LIST*)malloc((list_size*4)*sizeof(LIST));
    if(!RESD_LIST2){err_print(ERR_MEM_ALLOC,"RESD_LIST2 in check()");exit(EXIT_FAILURE); }

    /*Store the N,CA,C,O atoms in the RESD_LISTs*/
    
    for(i=0; i<list_size; i++){
      for(z=(i*4);z<i*4+4;z++){
	RESD_LIST1[z].atomno=list1[i].atomno;    RESD_LIST2[z].atomno=list2[i].atomno;
      }
    }
    
    for(i=0; i<(list_size*4);(i=i+4)){
      strcpy(RESD_LIST1[i].atomType,"N");     strcpy(RESD_LIST2[i].atomType,"N");
      strcpy(RESD_LIST1[i+1].atomType,"CA");  strcpy(RESD_LIST2[i+1].atomType,"CA");
      strcpy(RESD_LIST1[i+2].atomType,"C");   strcpy(RESD_LIST2[i+2].atomType,"C");
      strcpy(RESD_LIST1[i+3].atomType,"O");   strcpy(RESD_LIST2[i+3].atomType,"O");
    }
    


#endif   
    //***************************************************************************************************
   
    /* Storing the co-ordinates of the bbone atoms of the chosen residues *
     *  The centre of mass (cm/cf)selected are based on the selected atoms
     * ---------------------------------------------------------------------*/
    mov_selected    = get_selected_coords_and_centre(moving_file, xm_selected, cm_selected, junk, list1, list_size);
    target_selected = get_selected_coords_and_centre(target_file, xf_selected, cf_selected, junk, list2, list_size); 
    num_atoms = min(mov_selected, target_selected);

    
    if(mov_selected == 0){printf("Cannot find the requested atoms in the first protein.. Exiting\n");exit(-1);}
    if(target_selected == 0){printf("Cannot find the requested atoms in the sec protein.. Exiting\n");exit(-1);}
    

    /*-------Creating co-ordinate differences--------*
     *-------delta x plus (dxp) and minus (dxm)------*/
    
    dxm[0][0] = dxm[0][1] = dxm[0][2] = dxm[0][3] = 0.00;  
    dxp[0][0] = dxp[0][1] = dxp[0][2] = dxp[0][3] = 0.00;
    
    
    for(k=1; k<=num_atoms; k++){
      for(j=1; j<=3; j++){
	
	dxm[k][j] = xm_selected[k][j]-cm_selected[j]-(xf_selected[k][j]-cf_selected[j]);
	dxp[k][j] = xm_selected[k][j]-cm_selected[j]+(xf_selected[k][j]-cf_selected[j]);
	
	dxm[k][0] = 0.00;
	dxp[k][0] = 0.00;
      }

    }

 
  /******************************************************************************************/
  NUM_ATOMS = num_atoms;

  //printf("NUM_ATOMS = %d\n\n",NUM_ATOMS);
  //exit(-1);
      /*-----------------------------------------------------------------*
       *-----  Fill Upper Triangle of (symmetric) quaternion Matrix -----*/
    
  for(k=1; k<=NUM_ATOMS; k++){
    /* diags are sums of squared cyclic coordinate differences        PDBS0160 */
    /*-------------------------------------------------------------------------*/
    q[1][1] = q[1][1] + pow(dxm[k][1],2) + pow(dxm[k][2],2) + pow(dxm[k][3],2);
    q[2][2] = q[2][2] + pow(dxp[k][2],2) + pow(dxp[k][3],2) + pow(dxm[k][1],2);
    q[3][3] = q[3][3] + pow(dxp[k][1],2) + pow(dxp[k][3],2) + pow(dxm[k][2],2);
    q[4][4] = q[4][4] + pow(dxp[k][1],2) + pow(dxp[k][2],2) + pow(dxm[k][3],2);
     
    /* cross differences                                              PDBS0165  */
    /*--------------------------------------------------------------------------*/
    q[1][2] = q[1][2] + dxp[k][2]*dxm[k][3] - dxm[k][2]*dxp[k][3];
    q[1][3] = q[1][3] + dxm[k][1]*dxp[k][3] - dxp[k][1]*dxm[k][3];
    q[1][4] = q[1][4] + dxp[k][1]*dxm[k][2] - dxm[k][1]*dxp[k][2];
    
    q[2][3] = q[2][3] + dxm[k][1]*dxm[k][2] - dxp[k][1]*dxp[k][2];
    q[2][4] = q[2][4] + dxm[k][1]*dxm[k][3] - dxp[k][1]*dxp[k][3];
    q[3][4] = q[3][4] + dxm[k][2]*dxm[k][3] - dxp[k][2]*dxp[k][3];
 
  }
   

  /*--------------fill the rest by transposing it onto itself ----PDBS0173-------*/
  transpose_matrix(q,q,5);

  /*- orthogonalization by jacobi rotation = solution of EV -problem -- PDBS0181 */
  jacobi(q,n_sub_one,ns_sub_one,dm,vm,&nmrot);
  
  /* --- sort eigenvectors after eigenvalues, descending --           PDBS0186  */
  eigsrt(dm, vm, n_sub_one, ns_sub_one);


#ifdef DEBUG_SUPERPOSE
  printf("\nThe eigenvalues are as follows:\n");
  printf("--------------------------------------------------------\n");  
  for(i=1; i<=4; i++){
  printf("dm[%d]= %10.3f  ", i, dm[i]);
  }
  printf("\n\n");

  printf("The eigenvectors are as follows:\n");
  printf("---------------------------------------\n");
  for(i=1; i<=4; i++){
  printf("%7.3f,%7.3f,%7.3f,%7.3f\n", vm[i][1],vm[i][2],vm[i][3],vm[i][4]);
  } 
  printf("\n\n");
 
#endif 
  
  /*-- fill the rotation matrix which is made of elements from 4th EV   PDBS0206 */
  /*-----------------------------------------------------------------------------*/
  t[1][1] = pow(vm[1][4],2) + pow(vm[2][4],2) - pow(vm[3][4],2) - pow(vm[4][4],2);
  t[2][1] = 2.0*(vm[2][4]*vm[3][4] + vm[1][4]*vm[4][4]);
  t[3][1] = 2.0*(vm[2][4]*vm[4][4] - vm[1][4]*vm[3][4]);   
  
  t[1][2] = 2.0*(vm[2][4]*vm[3][4] - vm[1][4]*vm[4][4]);
  t[2][2] = pow(vm[1][4],2) + pow(vm[3][4],2) - pow(vm[2][4],2) - pow(vm[4][4],2);
  t[3][2] = 2.0*(vm[3][4]*vm[4][4]+vm[1][4]*vm[2][4]);
  
  t[1][3] = 2.0*(vm[2][4]*vm[4][4] + vm[1][4]*vm[3][4]); 
  t[2][3] = 2.0*(vm[3][4]*vm[4][4] - vm[1][4]*vm[2][4]);
  t[3][3] = pow(vm[1][4],2) + pow(vm[4][4],2) - pow(vm[2][4],2) - pow(vm[3][4],2);
  /*-----------------------------------------------------------------------------*/  


  /* -- reset dxm to store the individual rmsd's in it now -              PDBS0221 */
  /* fillMatrix(dxm, NUM_ATOMS, 3, fill_value);*/
  for(k=1; k<=NUM_ATOMS; k++){
    for(j=1; j<=3; j++){
      dxm[k][j] = fill_value;
    }
  }
  
#ifdef DEBUG_SUPERPOSE
  printf("\nThe rotation matrix: \n");
  printf("---------------------------------------\n");
  print3Matrix(t,4,4);
#endif  

  
  //**********************************************************************************
  // Writing out the result, result_mol.pdb and the avg files    *********************  
  //**********************************************************************************
  result_fptr = fopen(result_file,"w");
  if(!result_fptr){printf("Cannot open %s for writing\n", result_file); exit_prog(); }
  
  //xiaoli anchor_and_sup_fptr = fopen(anchor_and_sup_file,"w");
  //xiaoli if(!anchor_and_sup_fptr){printf("Cannot open %s for writing\n",anchor_and_sup_file); exit_prog(); }


  //xiaoli fprintf(anchor_and_sup_fptr,"MODEL        1\n");
 
  
  //ch_atom_cnt = 1;  /* ch_atom_cnt keeps count of the atoms chosen bt the user  */
  //list_index = 0;
  //------------------------------------------------------------------------------*/
  /* --     center atom in origin subtract cm                     PDBS032  */
   for(k=1; k<=mov_all; k++){ 
     //rot_xm_chosen[k][0] = 0.00;

     for(i=1; i<=3; i++){
       //x[i] = temp_x[k][i];
	     x[i] = xm_all[k][i];
       x[i] = x[i] - cm_selected[i]; 
     }
     /* --     the thing is centred in origin now, rotate it         PDBS0328 */
     rotvec(3,x,t);
     
     /* ---         now add cf                                      PDBS0330 */
     for(i=1; i<=3; i++){
       x[i] = x[i] + cf_selected[i];
     }
     
     /* Write x[i] to result file, resulT-mol file and to transformed file */
     fprintf(result_fptr, "%s%11.3f %7.3f %7.3f%s",line_mov[k], x[1],x[2],x[3],mov_end_portion[k]); 
     //fprintf(stdout, "%s%11.3f %7.3f %7.3f%s",line_mov[k], x[1],x[2],x[3],mov_end_portion[k]); 
     //xiaoli fprintf(anchor_and_sup_fptr, "%s%11.3f %7.3f %7.3f%s",line_mov[k], x[1],x[2],x[3],mov_end_portion[k]); 

       
   }/* END for(k=1; k<=mov_all; k++) */
   //*******************************************************************************************************
   fflush(result_fptr);  fclose(result_fptr); 
   //xiaoli fprintf(anchor_and_sup_fptr, "TER\n"); fprintf(anchor_and_sup_fptr, "ENDMDL\n");fprintf(anchor_and_sup_fptr, "MODEL        2\n");

   //xiaoli Read the anchor(target)file and append it to the result file    
   //target_fptr = fopen(target_file,"r");
   //if(!target_fptr){printf("Cannot open %s for reading\n", target_file); exit_prog(); }
  
   //xiaoli 
   //while(fgets(buffer,MAX_LINE_LEN_SUP,target_fptr)!=NULL){
     //if(strncmp(buffer,"ATOM",4)==0){
       //fprintf(anchor_and_sup_fptr,"%s",buffer);
     //}
   //}
   //fclose(target_fptr);
  
   //xiaoli fprintf(anchor_and_sup_fptr,"TER\n"); fprintf(anchor_and_sup_fptr,"ENDMDL\n");
   //xiaoli fflush(anchor_and_sup_fptr);  fclose(anchor_and_sup_fptr);  

   
   mov_selected    = get_selected_coords_and_centre(result_file, rot_xm_selected, cm_selected, new_junk, list1, list_size);
   *rmsd = get_rmsd(rot_xm_selected, xf_selected, NUM_ATOMS);

   return(result_file);
}//*************************************************************************************************************************

