#ifndef __SUPERPOSE_H
#define __SUPERPOSE_H

//#include "../util/util.h"
//#include "generate.h"

#define MAX_ATOMS_SUP        150
#define MAX_LINE_LEN_SUP     300

#define RESULT_PDB           "result.pdb"
#define ANCHOR_AND_SUP_FILE  "anchor_and_sup_file"

typedef struct {
  int atomno;
  char atomType[6];
  int num_of_atoms_in_resd;
} LIST;
  




void exit_prog();
int min(int x, int y);
int max(int x, int y);

void write_header(char *,char *, char *);
void rotvec(int n, float v[4], float t[][4]);

void print4Matrix(float arr[][5],int row, int col);
void print3Matrix(float arr[][4],int row, int col);

int jacobi(float a[5][5], int n, int np, float d[5],float v[5][5], int *nrot);
void eigsrt(float d[5], float v[5][5], int n, int np);

int get_all_coords_and_centre(char *, float [][4], float [4], char [MAX_ATOMS_SUP][MAX_LINE_LEN_SUP],char [MAX_ATOMS_SUP][MAX_LINE_LEN_SUP]);
int get_selected_coords_and_centre(char *filename, float arr[][4], float centre[4], char line[MAX_ATOMS_SUP][MAX_LINE_LEN_SUP], LIST *L, int);

void transpose_matrix(float arr[][5],float arr_transp[][5], int n);
//int append_file (char * appendor, char * appendee);

int is_CA_atom(char *);
int is_bb_atom(char *);

int is_bb_atom_except_O(char *atom);
int is_bb_atom_except_O_and_CA(char *atom);
//int is_N_atom(char *);
//int is_C_atom(char *);
//int is_O_atom(char *);

int is_not_Hydrogen(char *atom);
int is_Q_atom(char*);

void get_first_and_last_fist_resd(char* file, int* first_resd, int* last_resd);
char* call_superpose(char *loop_file, char* anchor_file, int, float*);
int is_chosen_atom(char *line, LIST *list, int i);

float get_rmsd(float rot_m[MAX_ATOMS_SUP][4], float req_f[MAX_ATOMS_SUP][4], int eq_num_of_atoms);
void print_resdlist(LIST* l, int num_resds);
char* superpose(char *fname, char *sname, LIST *list1, LIST *list2, int list_size, float*);

#endif


