
/*
	file:		unix.c
	purpose:	unix dependent utilities. 

	author: Robert Boyko
	date:	April 1, 1992	
	place:	University of Alberta / Department of Biochemistry
*/

#include <stdio.h> 
#include <stdlib.h>
#include <time.h>
#include "btimem.h"

/*************************************************************/
/* return today's date. 
  Remember to free it afterwards!
*/
char *get_date()
{	
	time_t	*tloc;

	tloc=(time_t *)bti_malloc (sizeof (time_t));
	time(tloc);
	return((char *)ctime(tloc));

}	/* get_date */


/*************************************************************
 * Determine whether a file exists with read permission.
 * No information is passed about other permissions on the
 * file.  Mimic the access() function in unix to return 0 if the
 * file exists and -1 if there was something wrong accessing the file.
 */
int CHECKEXIST( char *filename )
{
  FILE *fp = NULL;
  fp = fopen(filename, "r");
  if (fp == NULL) {
    return(-1);
  }
  fclose(fp);
  return(0);
}
