#!/usr/bin/perl
#
# Program to initiate a query/set of queries 
#
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
#
#
##############################################
$TMBHUNE_HOME = ".";

$genome=$ARGV[0];	# sequence file to be screened
$evol=$ARGV[1];

#$genome="genome.fa";
@sequences;


$i=0;
@seq;
$seq;

# count seqs in genome

open(INPUT, $genome);

$num_seqs=0;
while($line=<INPUT>)
	{
	if($line=~/^>/)
		{
		$num_seqs++;
		}
	}
close INPUT;

print ($num_seqs, "\n");

# build seqs array

open(INPUT, $genome);
while($line=<INPUT>)
	{
	if($line=~/^>/)
		{
		if($i==1)
			{
			$seq=join("", @seq);
			push(@sequences, $seq);	
			}
		@seq="";
		$seq="";
		push(@seq, $line);
		}		
	else
		{
		$i=1;
		push(@seq, $line);
		}
	}


if($i==1)
        {
        $seq=join("", @seq);
        push(@sequences, $seq);
        }
@seq="";
$seq="";
push(@seq, $line);

















# build query seq aa profile and running query

$num=0;
foreach $i(@sequences)
	{
	$i=~tr/a-z/A-Z/;
	$query="$TMBHUNE_HOME/tmp/blast_for_query.fa";
        open(OUTPUT, ">$query");
        print OUTPUT $i;
        close OUTPUT;
        $query_save="$TMBHUNE_HOME/tmp/tmp/blast_for_query".$num.".fa";
        system("cp $query $query_save");
        $i=~/^>(.+)/;
        $desc=$1;
	

        print ($desc, "\t");

	system("perl $TMBHUNE_HOME/query_aa_composition.pl $num $evol > $TMBHUNE_HOME/tmp/query.aa");
        $tmp_query="$TMBHUNE_HOME/tmp/tmp/query".$num.".aa";
        system("cp $TMBHUNE_HOME/tmp/query.aa $tmp_query");



	system("$TMBHUNE_HOME/TMB_AA_kNN $tmp_query 5 0 100 $num_seqs > output");
	$output_name='outputs/output'.$num;
        readResults();
	system("mv output $output_name");
	print "\n";	

	$num++;
	}



exit;








sub readResults
{

open(RESULT, "$TMBHUNE_HOME/output");
while($line=<RESULT>)
      {
	if($line=~/^ ExpDataBBTM_score/) { $line=~s/\n//;
        	print ($line, "\t");
       	        }
	if($line=~/^ ExpDataBBTM_ratio/) { $line=~s/\n//;
                print ($line, "\t");
                }
	if($line=~/^ ExpDataE/) { $line=~s/\n//;
		print ($line, "\t");
		}

	}

}

