#!/usr/bin/perl
#
# Cross validation prog
#
###########################


@aa_types=('A', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'Y');
$num=$ARGV[0];
$evol_info=$ARGV[1];

if($evol_info=~/on/)
        {
        # get evol aa profile
     	writeQuery($num);
        }
else {
        # tmp/blast_for_query.fa - home of query file
        $seq=read_in_seq();
        @aa_weights=calc_aa_percentage(1, $seq);

        foreach $i(@aa_weights)
                {
                print ($i, "\t");
                }
        }

exit;


##########################











#=============================================================
#
#=============================================================

sub writeQuery
{
my ($num)=@_;
my %accessions=();
my @accessions="";



#
# Get homologues of original protein family
#


# this now done in screen genome script

system("/applic/blast/blastall -p blastp -i tmp/blast_for_query.fa -o tmp/blast_for_query.bls -d /usr3/database/swissprot/swissprot -e 0.0001 -m 8");

$ac_num="tmp/tmp/blast_for_query".$num.".bls";
system("cp tmp/blast_for_query.bls $ac_num");

# parse blast file
unless(open(IN, "tmp/blast_for_query.bls")){ print STDERR "Warning: couldn't open bls file\n"; };
$count=0;
while($line=<IN>)
        {
        if($count<25) # makes sure doesn't excede 25 seqs - time consideration
                {
                if($line=~/sp\|\w+\|(\w+)/)
                        {
                        $accessions{$1}="x";
                        }
                }
        $count++;
        }
close IN;
$num_seqs=scalar @accessions;








#
# and make into blast cluster.fa for pairwise alignment
#

# get seqs for weighting
$matches=0;
open(OUT, ">tmp/seqs_for_weighting.ac");
foreach $key(keys(%accessions))
        {
        if ($key=~/\w+/) { $matches=1; print OUT ($key, "\n"); }
        }
close OUT;



$ac_num="tmp/tmp/seqs_for_weighting".$num.".ac";
system("cp tmp/seqs_for_weighting.ac $ac_num");

if($matches==1)
        {
        system("/applic/blast/fastacmd -i tmp/seqs_for_weighting.ac -d /usr3/database/swissprot/swissprot > tmp/cluster.fa");
        }
if($matches==0)
        {
        $accessions{$start_seq}="x";
        open(OUT, ">tmp/cluster.fa");
        print OUT (">", $start_seq, "\n");
        close OUT;
        }
if($matches==1) {
        system("/applic/blast/formatdb -p T -i tmp/cluster.fa");
        }




#
# individual pairwise alignments calculate weightings
#
if($matches==1) {
        foreach $key(keys(%accessions))
                {
                if ($key=~/\w+/){
                        system("/applic/blast/fastacmd -s $key -d /usr3/database/swissprot/swissprot > tmp/tmpquery.fa");
                        system("/applic/blast/blastall -p blastp -d tmp/cluster.fa -i tmp/tmpquery.fa -o tmp/tmpquery.bls -m 8");

                        @ids="";
                        unless(open(IN, "tmp/tmpquery.bls")){ print "Warning: Couldn't open .blast file"; }
                        @hits="";
                        $count=0;
                        while($line=<IN>)
                                {
                                $line=~/^[\|\w\.]+\t([\|\w\.]+)\t([\w\.]+)/;    # id level
                                $hit=$1;
                                $id=$2;
                                $switch=0;
                                foreach $x(@hits)
                                        {
                                        if ($x eq $hit) { $switch=1; }
                                        }
                                if ($switch==0)
                                        {
                                        if ($count<25) {
                                                push(@ids, $id);
                                                }
                                        }
                                $count++;
                                push(@hits, $hit);
                                }
                        close IN;


                        $av_id=calc_av_id(@ids);
                        push(@distances, $av_id);

                        $i++;
                        }
                }
        }
elsif($matches==0)
        {
        push(@ids, 100);
        $av_id=calc_av_id(@ids);
        push(@distances, $av_id);
        }


@weights=calc_weights(@distances);



@weighted_aa_perc="";
my $i=0;
foreach $key(keys(%accessions))
        {
        # retrieve key_seq with fastacmd
        if ($key=~/\w+/)
                {
                if($matches==1) {
                        system("/applic/blast/fastacmd -s $key -d /usr3/database/swissprot/swissprot > tmp/weightedseq.fa");
                        unless(open(IN, "tmp/weightedseq.fa")){ print STDERR "Couldn't open sequence file\n"; }
                        my @key_seq="";
                        while($line=<IN>)
                                {
                                if ($line!~/^>/) { push(@key_seq, $line); }
                                }
                        $key_seq=join("", @key_seq);

                        }
                elsif($matches==0) {
                        $key_seq=$start_seq;
                        }

                @aa_weights="";
                @aa_weights=calc_aa_percentage($weights[$i], $key_seq);


                for($zz=0; $zz<20; $zz++)
                        {
                        $weighted_aa_perc[$zz]+=$aa_weights[$zz];
                        }
                $sum_weight+=$weights[$z];
                $i++;
               }
        }


$i=0;
if ($matches==0)
        {
        open(IN, "tmp/blast_for_query.fa");
        while($line=<IN>)
               {

               if($line!~/^>/)
                       {
                       push(@seq, $line);
                       }
               }
        $key_seq=join("", @seq);

        #print STDERR ("\nSeq= ", $key_seq, "\n");

        @aa_weights="";
        @aa_weights=calc_aa_percentage($weights[$i], $key_seq);

        for($zz=0; $zz<20; $zz++)
                {
                $weighted_aa_perc[$zz]+=$aa_weights[$zz];
                }
        $sum_weight+=$weights[$z];
        $i++;
        }


foreach $a(@weighted_aa_perc)
        {
        print ($a, "\t");
        }


}







sub calc_av_id
{
my(@ids)=@_;

$total_id=0;
$scalar_id=scalar @ids;

foreach $i(@ids)
        {
        if($scalar_id <= 2) {
                $total_id+=$i;
                }
        elsif($i < 100) {
                $total_id+=$i;
                }
        }

if($total_id>0) {
        $av_id=$total_id/scalar @ids;
        }
else { $av_id=0; }

return $av_id;
}







sub calc_weights
{
my(@distances)=@_;
@weights=();

my $zz=0;
#print "\n";


foreach $i(@distances)
        {

        $zz++;

        $sum_pj=0;
        foreach $n(@distances)
                {
                $sum_pj+=$n;
                }

        $w;
        if ($i>0){
                $w=$i/$sum_pj;
                }
        else { $w = 0; }
        push(@weights, $w);

        }



return @weights;
}








sub calc_aa_percentage
{
my ($weight, $seqx)=@_;
@aa_composition="";
@aa_percentage="";
@aa_weights="";

#print ("Weight: ", $weight, "\n");


@seq=split("", $seqx);
$total=scalar @seq;

$aa_type=0;
foreach $n(@aa_types)
        {
        foreach $i(@seq)
                {
                if($n eq $i)
                        {
                        $aa_composition[$aa_type]++;
                        }
                }
        $aa_type++;
        }


for($i=0; $i<20; $i++)
       {
        if($aa_composition[$i]>0) {
                $aa_percentage[$i]=($aa_composition[$i]/$total)*100;
                }
        else    {
                $aa_percentage[$i]=0;
                }
        }

if($xx==0) {
        for($i=0; $i<20; $i++)
                {
                $aa_weights[$i]=$aa_percentage[$i]*$weight;
                }
        }
else    {
        for($i=0; $i<20; $i++)
                {
                $aa_weights[$i]=$aa_percentage[$i];
                }
        }


return(@aa_weights);
}















sub read_in_seq
{

@seq=();
open(INPUT, "tmp/blast_for_query.fa");
while($line=<INPUT>)
        {
        if($line!~/^>/)
                {
                push(@seq, $line);
                }
        }
$seq=join('', @seq);
return ($seq);

}
