
/*
	file: io.c
	purpose: read sequences for xalign.
*/

#include "../include/seqsee.h" 

/* procedure calls */


/*************************************************************/
/* open a data file
*/
FILE *open_data_file(fname, msg)
char *fname, *msg;
{
	FILE *fp;
	char *entry, sVal[MAX_LINE_LEN];

	fp = fopen(fname, "r");

	if (fp == NULL) {
		fprintf(stdout, "\n Enter your %s.\n", msg);
		fprintf(stdout, PROG_PROMPT);
		fscanf(stdin, "%s", fname);
		fp = fopen(fname, "r");
		if (fp == NULL) {
			sprintf(sVal, "Cannot open data file: %s", fname);
			show_err(TRUE, "open_data_file", sVal);
		}
	}

	return(fp);

}   /* open_data_file */


/*************************************************************/
/* read a single output file 
*/
void get_output_file(resultsFname)
char *resultsFname;
{	
	FILE *fp;
	char sVal[MAX_LINE_LEN];

	fp = fopen(resultsFname, "w");
	if (fp == NULL) {
		show_prompt(stdout, "\n Enter output filename.\n");
//		fscanf(stdin, "%s", resultsFname);
		fp = fopen(resultsFname, "w");
		if (fp == NULL) {
			sprintf(sVal, "Cannot open output file: '%s'\n", resultsFname);
			show_err(TRUE, "get_output_file", sVal);
		}
	}

	fclose(fp);

}	/* get_output_file */


/*************************************************************/
/* read integer response to menu item, do range checking
*/
int read_menu_num(infp, xMin, xMax, quitFlag)
FILE *infp;
int xMin, xMax, quitFlag;
{
	int select;
	char aStr[MAX_LINE_LEN], sVal[MAX_LINE_LEN];

	fscanf(infp, "%s", aStr);
	select = atoi(aStr);

	if ((select < xMin) || (select > xMax)) {
		select = ERROR_FLAG;
		sprintf(sVal, "Range error, Input=%d where Min=%d, Max=%d\n",
			select, xMin, xMax);
		show_err(quitFlag, "read_menu_num", sVal);
	}

	return(select);

}   /* read_menu_num */
