
/*
	file: print.c
	common writing routines for sequences
*/

#include "../include/seqsee.h"

/* procedure calls */

/*************************************************************/
/* prints one sequence to output in a standardized format
*/
char *write_seq_db(num) 
int num;
{

	switch (num) {
		case SEQ_PIR: 		return("PIR"); break;
		case SEQ_SPROT:		return("SWISSPROT"); break;
		case SEQ_PEP:	 	return("PEPTOOL"); break;
		case SEQ_PIRCOMP: 	return("PIR_COMP"); break;
		case SEQ_RBO:		return("IG"); break;
		case SEQ_KBD: 		return("KEYBOARD"); break;
	}

	return("UNKNOWN");

}	/* write_seq_db */


/*************************************************************/
/* prints one sequence to output in a standardized format
*/
void print_seq_seqsee(fp, rSeq) 
FILE *fp;
SEQ_REC *rSeq;
{

	fprintf(fp, "PSEQ\n");

	if (rSeq->title != NULL)
		fprintf(fp, "n%s\n", rSeq->title);

	if (rSeq->acc != NULL)
		fprintf(fp, "A%s\n", rSeq->acc);

	if (rSeq->pRes != NULL)
		fprintf(fp, "r%s\n", rSeq->pRes);

	if (rSeq->sRes != NULL)
		fprintf(fp, "S%s\n", rSeq->sRes);

	if (rSeq->uBuf != NULL)
		fprintf(fp, "G%s\n", rSeq->uBuf);

	putc('\n', fp);

}	/* print_seq_seqsee */
