
/*
	file:		unix.c
	purpose:	unix dependent utilities. 

	author: Robert Boyko
	date:	July 18, 1995	
	place:	University of Alberta / Department of Biochemistry
*/

#define MAX_LINE			256
#define EDITOR "more"

#include <stdio.h> 
#include <time.h>

extern char *ctime();
extern time_t time();


/*************************************************************/
/* return today's date. 
*/
char *get_date()
{	
	time_t tloc[8];

	(void*) time(tloc);
	return((char *) ctime(tloc));

}	/* get_date */


/*************************************************************/
/* return temporary filename by reading the clock. 
*/
void get_temp_file(fname)
char *fname;
{
	time_t *tloc;

	sprintf(fname, "%d.tmp", (int) time(tloc));

}	/* get_temp_file */


/*************************************************************/
/* edit a file in the present window. 
*/
void edit_file(fname)
char *fname;
{	
	char sVal[MAX_LINE];

	sprintf(sVal, "%s %s", EDITOR, fname);
	system(sVal);

}	/* edit_file */


/*************************************************************/
/* destroy a file without confirmation.
*/
void remove_file(fname)
char *fname;
{	
	char sVal[MAX_LINE];

	sprintf(sVal, "rm -f %s", fname);
	system(sVal);

}	/* remove_file */


/*************************************************************/
/* rename a file. 
*/
void rename_file(oldFname, newFname)
char *oldFname, *newFname;
{	
	char sVal[MAX_LINE];

	sprintf(sVal, "mv -f %s %s", oldFname, newFname);
	system(sVal);

}	/* rename_file */


/*************************************************************/
/* display a file in the present window. 
*/
void more_file(fname)
char *fname;
{	
	char sVal[MAX_LINE];

	sprintf(sVal, "more %s", fname);
	system(sVal);

}	/* more_file */


/*************************************************************/
/* Parse unix filename for wildcard characters. 
** Place each individual filename in output file.
*/
void parse_fname(inputFname, outputFname)
char *inputFname, *outputFname;
{	
	char 	sVal[MAX_LINE];

	sprintf(sVal, "ls %s > %s", inputFname, outputFname);
	system(sVal);

}	/* parse_fname */


/*************************************************************/
/* Clear the screen
*/
void clear_screen()
{

	system("clear");

}	/* clear_screen */
