#!/usr/bin/perl

open(OUT,">xalign.parms");

print OUT
"
****************************************************************
XALIGN Parameters
****************************************************************

Enter the file which contains the amino acid similarity
scoring matrix and the various gap penalties.
This file contains a lower triangular matrix which indicates
the similarity score between two amino acids. The matrix  is
of  a  general nature and may not reflect the specific needs
of the user (for example, a user who is  adamant  that cys-
tines  line  up with cystines may want to increase the score
for such a match). 

XALIGN:SCOR_MATRIX $ENV{'PWD'}/wtm.rbo

----------------------------------------------------------------

Indicate if pairwise alignments should be printed. This  can
greatly increase the output however it often contains useful
information.  Enter \"1\" for printing and \"0\" for not  printing.

XALIGN:PRINT_PAIRWISE 0

----------------------------------------------------------------

The following is an offset added to the percent homology score
of a pairwise alignment if secondary structure is known for a
given sequence.  In general, any sequence which has secondary
structure known should be given precedence over those that do not
when determining the order of sequences in the multiple alignment.

An offset of \"0\" means the order of the sequences in the multiple
alignment algorithm is based only on primary sequence homology.

Range: MIN_STRUCT_BIAS <= x <= MAX_STRUCT_BIAS

XALIGN:STRUCT_BIAS 100

----------------------------------------------------------------

As more and more sequences are added to the multiple alignment,
the cumulative effect of all the amino acid scoring starts to
dwarf the gapping penalties.  Therefore we probably want to
increase the gap and gap size penalties by a given percent for
each sequence added.

For example, this number should be adjusted up if too many gaps
are found in the final sequences of the multiple alignment. 

Range: MIN_INC_GAP_PEN <= x <= MAX_INC_GAP_PEN

XALIGN:INC_GAP_PEN 30   

----------------------------------------------------------------

Indicate if the pairwise sequence percent homology table should
be printed.

This table allows the user to quickly compare pairwise sequence
alignments in terms of percent homology.
Enter \"0\" for not printing and \"1\" for printing.

Range: 0 <= x <= 1

XALIGN:PRINT_PCT_HOM 1

----------------------------------------------------------------

Indicate the order of the sequences in your multiple alignment
output.

To have sequences printed in the order that the program ranks
them (for adding them to the multiple alignment), enter \"0\".

If you prefer to have the sequences printed in the order that
they were entered into the program, enter \"1\".

Range: 0 <= x <= 1

XALIGN:PRINT_ORDER 0

----------------------------------------------------------------

Following the multiple alignment, a consensus sequence is
printed.  At what percent identity is a consensus reached for
a given amino acid at a given position?

Enter an integer from 0 - 100 to represent this threshold.

Range: 0 <= x <= 100

XALIGN:CONSENSUS_PCT 70

----------------------------------------------------------------

This section was used by biotools software to more easily read
the output. There is no reason to change these settings.

If you want seqsee gui format for the output, set this parameter
to 0. If you want a formatted text base output, enter \"1\".

XALIGN:DATA_FORMAT	1
XALIGN:DATA_FILE    x
XALIGN:SEQ_SELECT   1
";

close(OUT);
