
/*
	file: select.c
	purpose: read sequences for xalign.
*/

#include "include/seqsee.h" 
#include "include/xalign.h" 
#include "include/align.h" 

/* procedure calls */
extern int mread_seq();
static void show_seq_select();
extern void read_xalign_file();


/*************************************************************/
/* read xalign sequences, select the sequence for which we align to 
*/
int read_seq_select(fp, format)
FILE *fp;
int format;
{
	int okFlag, seqNum, select, fileType;
	SEQ_REC mySeq[MAX_MULT_ALIGN];
	char sVal[MAX_LINE_LEN];

	seqNum = 0;

	mread_seq(fp, stdout, mySeq, &seqNum, MAX_MULT_ALIGN, format,
			MIN_RES, MAX_RES); 

	fprintf(stdout, "\n\n Number of sequences to align: %d", seqNum);

	if (seqNum <= 1) {
		sprintf(sVal, "Must have 2 or more sequences to align.");
		show_err(TRUE, "read_seq_select", sVal);
	}

	show_seq_select(stdout, mySeq, seqNum);
	select = read_menu_num(stdin, 1, seqNum + 2, TRUE);
	return(select);

}	/* read_seq_select */


/*************************************************************/
/* ask user to select a sequence from a group of sequences
*/
static void show_seq_select(fp, mySeqs, num)
FILE *fp;
SEQ_REC *mySeqs;
int num;
{
	int i;

	fprintf(fp, "\n");
	fprintf(fp, "\n Choose a sequence to align against:\n\n");
	for (i=0; i<num; i++)
		fprintf(fp, "   %d) %s\n", i+1, mySeqs[i].title);
	fprintf(fp, "\n");
	fprintf(fp, " Alternatively, ");
	fprintf(fp, " choose another method of ordering the alignment: \n\n");

	fprintf(fp, "   %d) Computer decides on ordering of sequences\n", num + 1);
	fprintf(fp, "   %d) Align sequences in the order they were input\n",
		num + 2);
	fprintf(fp, PROG_PROMPT);

}   /* show_seq_select */
